"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _momentTimezone = _interopRequireDefault(require("moment-timezone"));

var _lodash = _interopRequireDefault(require("lodash"));

var timeManagement = /*#__PURE__*/function () {
  /**
   *
   * @param { Object } config
   * @param { String } config.locale
   * @param { String } config.timezone
   *
   */
  function timeManagement(config) {
    var _this = this;

    (0, _classCallCheck2["default"])(this, timeManagement);
    (0, _defineProperty2["default"])(this, "mTime", null);
    (0, _defineProperty2["default"])(this, "mCheckTime", null);
    (0, _defineProperty2["default"])(this, "mStartTime", null);
    (0, _defineProperty2["default"])(this, "mEndTime", null);
    (0, _defineProperty2["default"])(this, "getDifferentTime", /*#__PURE__*/function () {
      var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(startTime, endTime) {
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return new Promise( /*#__PURE__*/function () {
                  var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(resolve, rejected) {
                    var timeAgo, reformatTime, _timeAgo, _reformatTime;

                    return _regenerator["default"].wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            _context.t0 = (0, _typeof2["default"])(startTime) && (0, _typeof2["default"])(endTime);
                            _context.next = _context.t0 === "string" ? 3 : _context.t0 === "number" ? 38 : 73;
                            break;

                          case 3:
                            _context.next = 5;
                            return (0, _momentTimezone["default"])(startTime, "DD-MM-YYYY HH:mm:ss");

                          case 5:
                            _this.mStartTime = _context.sent;
                            _context.next = 8;
                            return (0, _momentTimezone["default"])(endTime, "DD-MM-YYYY HH:mm:ss");

                          case 8:
                            _this.mEndTime = _context.sent;

                            if (!_this.mStartTime.isValid()) {
                              _context.next = 35;
                              break;
                            }

                            if (!_this.mEndTime.isValid()) {
                              _context.next = 31;
                              break;
                            }

                            if (!(_this.mEndTime.unix() - _this.mStartTime.unix() > 0)) {
                              _context.next = 27;
                              break;
                            }

                            _context.next = 14;
                            return _momentTimezone["default"].duration(_this.mEndTime.diff(_this.mStartTime));

                          case 14:
                            timeAgo = _context.sent;
                            _context.next = 17;
                            return timeAgo.months() !== 0;

                          case 17:
                            if (!_context.sent) {
                              _context.next = 21;
                              break;
                            }

                            _context.t1 = "".concat(Math.floor(timeAgo.months()), " Bulan, ").concat(Math.floor(timeAgo.weeks()), " Minggu, ").concat(Math.floor(timeAgo.days()), " hari, - ").concat(Math.floor(timeAgo.hours()), " Jam, ").concat(Math.floor(timeAgo.minutes()), " Menit, ").concat(Math.floor(timeAgo.seconds()), " Detik");
                            _context.next = 22;
                            break;

                          case 21:
                            _context.t1 = timeAgo.weeks() !== 0 ? "".concat(Math.floor(timeAgo.weeks()), " Minggu, ").concat(Math.floor(timeAgo.days()), " hari, ").concat(Math.floor(timeAgo.hours()), " Jam, ").concat(Math.floor(timeAgo.minutes()), " Menit, ").concat(Math.floor(timeAgo.seconds()), " Detik") : timeAgo.days() !== 0 ? "".concat(Math.floor(timeAgo.days()), " hari, ").concat(Math.floor(timeAgo.hours()), " Jam, ").concat(Math.floor(timeAgo.minutes()), " Menit, ").concat(Math.floor(timeAgo.seconds()), " Detik") : timeAgo.hours() !== 0 ? "".concat(Math.floor(timeAgo.hours()), " Jam, ").concat(Math.floor(timeAgo.minutes()), " Menit, ").concat(Math.floor(timeAgo.seconds()), " Detik") : timeAgo.minutes() !== 0 ? "".concat(Math.floor(timeAgo.minutes()), " Menit, ").concat(Math.floor(timeAgo.seconds()), " Detik") : timeAgo.seconds() !== 0 ? "".concat(Math.floor(timeAgo.seconds()), " Detik") : timeAgo.milliseconds() !== 0 ? "".concat(Math.floor(timeAgo.milliseconds()), " Milidetik") : "Tidak Ada Selisih";

                          case 22:
                            reformatTime = _context.t1;
                            _context.next = 25;
                            return resolve({
                              status: true,
                              code: 200,
                              msg: "Successfully get Different Time",
                              data: {
                                duration_instance: timeAgo,
                                unix: {
                                  start_time: _this.mStartTime.unix(),
                                  end_time: _this.mEndTime.unix(),
                                  duration_time: _this.mEndTime.unix() - _this.mStartTime.unix()
                                },
                                diff: {
                                  time_years: timeAgo.asYears(),
                                  time_month: timeAgo.asMonths(),
                                  time_week: timeAgo.asWeeks(),
                                  time_days: timeAgo.asDays(),
                                  time_hours: timeAgo.asHours(),
                                  time_minutes: timeAgo.asMinutes(),
                                  time_seconds: timeAgo.asSeconds(),
                                  time_milliseconds: timeAgo.asMilliseconds()
                                },
                                humanize: {
                                  start_time: _this.mStartTime.format("DD-MM-YYYY HH:mm:ss"),
                                  end_time: _this.mEndTime.format("DD-MM-YYYY HH:mm:ss")
                                },
                                duration_humanize: reformatTime
                              }
                            });

                          case 25:
                            _context.next = 29;
                            break;

                          case 27:
                            _context.next = 29;
                            return rejected({
                              status: false,
                              code: 500,
                              msg: "The final value must be greater than the initial value"
                            });

                          case 29:
                            _context.next = 33;
                            break;

                          case 31:
                            _context.next = 33;
                            return rejected({
                              status: false,
                              code: 500,
                              msg: "Time End Not Valid"
                            });

                          case 33:
                            _context.next = 37;
                            break;

                          case 35:
                            _context.next = 37;
                            return rejected({
                              status: false,
                              code: 500,
                              msg: "Time Start Not Valid"
                            });

                          case 37:
                            return _context.abrupt("break", 76);

                          case 38:
                            _context.next = 40;
                            return _momentTimezone["default"].unix(startTime);

                          case 40:
                            _this.mStartTime = _context.sent;
                            _context.next = 43;
                            return _momentTimezone["default"].unix(endTime);

                          case 43:
                            _this.mEndTime = _context.sent;

                            if (!_this.mStartTime.isValid()) {
                              _context.next = 70;
                              break;
                            }

                            if (!_this.mEndTime.isValid()) {
                              _context.next = 66;
                              break;
                            }

                            if (!(_this.mEndTime.unix() - _this.mStartTime.unix() > 0)) {
                              _context.next = 62;
                              break;
                            }

                            _context.next = 49;
                            return _momentTimezone["default"].duration(_this.mEndTime.diff(_this.mStartTime));

                          case 49:
                            _timeAgo = _context.sent;
                            _context.next = 52;
                            return _timeAgo.months() !== 0;

                          case 52:
                            if (!_context.sent) {
                              _context.next = 56;
                              break;
                            }

                            _context.t2 = "".concat(Math.floor(_timeAgo.months()), " Bulan, ").concat(Math.floor(_timeAgo.weeks()), " Minggu, ").concat(Math.floor(_timeAgo.days()), " hari, - ").concat(Math.floor(_timeAgo.hours()), " Jam, ").concat(Math.floor(_timeAgo.minutes()), " Menit, ").concat(Math.floor(_timeAgo.seconds()), " Detik");
                            _context.next = 57;
                            break;

                          case 56:
                            _context.t2 = _timeAgo.weeks() !== 0 ? "".concat(Math.floor(_timeAgo.weeks()), " Minggu, ").concat(Math.floor(_timeAgo.days()), " hari, ").concat(Math.floor(_timeAgo.hours()), " Jam, ").concat(Math.floor(_timeAgo.minutes()), " Menit, ").concat(Math.floor(_timeAgo.seconds()), " Detik") : _timeAgo.days() !== 0 ? "".concat(Math.floor(_timeAgo.days()), " hari, ").concat(Math.floor(_timeAgo.hours()), " Jam, ").concat(Math.floor(_timeAgo.minutes()), " Menit, ").concat(Math.floor(_timeAgo.seconds()), " Detik") : _timeAgo.hours() !== 0 ? "".concat(Math.floor(_timeAgo.hours()), " Jam, ").concat(Math.floor(_timeAgo.minutes()), " Menit, ").concat(Math.floor(_timeAgo.seconds()), " Detik") : _timeAgo.minutes() !== 0 ? "".concat(Math.floor(_timeAgo.minutes()), " Menit, ").concat(Math.floor(_timeAgo.seconds()), " Detik") : _timeAgo.seconds() !== 0 ? "".concat(Math.floor(_timeAgo.seconds()), " Detik, ").concat(Math.floor(_timeAgo.milliseconds())) : _timeAgo.milliseconds() !== 0 ? "".concat(Math.floor(_timeAgo.milliseconds()), " Milidetik") : "Tidak Ada Selisih";

                          case 57:
                            _reformatTime = _context.t2;
                            _context.next = 60;
                            return resolve({
                              status: true,
                              code: 200,
                              msg: "Successfully get Different Time",
                              data: {
                                duration_instance: _timeAgo,
                                unix: {
                                  start_time: _this.mStartTime.unix(),
                                  end_time: _this.mEndTime.unix(),
                                  duration_time: _this.mEndTime.unix() - _this.mStartTime.unix()
                                },
                                diff: {
                                  time_years: _timeAgo.asYears(),
                                  time_month: _timeAgo.asMonths(),
                                  time_week: _timeAgo.asWeeks(),
                                  time_days: _timeAgo.asDays(),
                                  time_hours: _timeAgo.asHours(),
                                  time_minutes: _timeAgo.asMinutes(),
                                  time_seconds: _timeAgo.asSeconds(),
                                  time_milliseconds: _timeAgo.asMilliseconds()
                                },
                                humanize: {
                                  start_time: _this.mStartTime.format("DD-MM-YYYY HH:mm:ss"),
                                  end_time: _this.mEndTime.format("DD-MM-YYYY HH:mm:ss")
                                },
                                duration_humanize: _reformatTime
                              }
                            });

                          case 60:
                            _context.next = 64;
                            break;

                          case 62:
                            _context.next = 64;
                            return rejected({
                              status: false,
                              code: 500,
                              msg: "The final value must be greater than the initial value"
                            });

                          case 64:
                            _context.next = 68;
                            break;

                          case 66:
                            _context.next = 68;
                            return rejected({
                              status: false,
                              code: 500,
                              msg: "Time End Not Valid"
                            });

                          case 68:
                            _context.next = 72;
                            break;

                          case 70:
                            _context.next = 72;
                            return rejected({
                              status: false,
                              code: 500,
                              msg: "Time Start Not Valid"
                            });

                          case 72:
                            return _context.abrupt("break", 76);

                          case 73:
                            _context.next = 75;
                            return rejected({
                              status: false,
                              code: 500,
                              msg: "Illegal Format startTime or EndTime"
                            });

                          case 75:
                            return _context.abrupt("break", 76);

                          case 76:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee);
                  }));

                  return function (_x3, _x4) {
                    return _ref2.apply(this, arguments);
                  };
                }());

              case 2:
                return _context2.abrupt("return", _context2.sent);

              case 3:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      return function (_x, _x2) {
        return _ref.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "getTimeBetween", /*#__PURE__*/function () {
      var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(checkTime, startTime, endTime) {
        return _regenerator["default"].wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                return _context4.abrupt("return", new Promise( /*#__PURE__*/function () {
                  var _ref4 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(resolve, rejected) {
                    return _regenerator["default"].wrap(function _callee3$(_context3) {
                      while (1) {
                        switch (_context3.prev = _context3.next) {
                          case 0:
                            _context3.next = 2;
                            return _momentTimezone["default"].unix(checkTime);

                          case 2:
                            _this.mCheckTime = _context3.sent;
                            _context3.next = 5;
                            return _momentTimezone["default"].unix(startTime);

                          case 5:
                            _this.mStartTime = _context3.sent;
                            _context3.next = 8;
                            return _momentTimezone["default"].unix(endTime);

                          case 8:
                            _this.mEndTime = _context3.sent;

                            if (!_this.mCheckTime.isValid()) {
                              _context3.next = 28;
                              break;
                            }

                            if (!_this.mStartTime.isValid()) {
                              _context3.next = 24;
                              break;
                            }

                            if (!_this.mEndTime.isValid()) {
                              _context3.next = 20;
                              break;
                            }

                            if (!(_this.mEndTime.unix() - _this.mStartTime.unix() > 0)) {
                              _context3.next = 16;
                              break;
                            }

                            if (_this.mCheckTime >= _this.mStartTime && _this.mCheckTime <= _this.mEndTime) {
                              resolve({
                                status: true,
                                code: 200,
                                msg: "success, check time is Between start and end time",
                                data: {
                                  checkTime: (0, _momentTimezone["default"])(_this.mCheckTime).format("DD-MM-YYYY HH:mm:ss"),
                                  startTime: (0, _momentTimezone["default"])(_this.mStartTime).format("DD-MM-YYYY HH:mm:ss"),
                                  endTime: (0, _momentTimezone["default"])(_this.mEndTime).format("DD-MM-YYYY HH:mm:ss")
                                }
                              });
                            } else {
                              rejected({
                                status: false,
                                code: 404,
                                msg: "failed, check time is Between start and end time",
                                data: {
                                  checkTime: (0, _momentTimezone["default"])(_this.mCheckTime).format("DD-MM-YYYY HH:mm:ss"),
                                  startTime: (0, _momentTimezone["default"])(_this.mStartTime).format("DD-MM-YYYY HH:mm:ss"),
                                  endTime: (0, _momentTimezone["default"])(_this.mEndTime).format("DD-MM-YYYY HH:mm:ss")
                                }
                              });
                            }

                            _context3.next = 18;
                            break;

                          case 16:
                            _context3.next = 18;
                            return rejected({
                              status: false,
                              code: 500,
                              msg: "The final value must be greater than the initial value"
                            });

                          case 18:
                            _context3.next = 22;
                            break;

                          case 20:
                            _context3.next = 22;
                            return rejected({
                              status: false,
                              code: 500,
                              msg: "Time End Not Valid"
                            });

                          case 22:
                            _context3.next = 26;
                            break;

                          case 24:
                            _context3.next = 26;
                            return rejected({
                              status: false,
                              code: 500,
                              msg: "Time Start Not Valid"
                            });

                          case 26:
                            _context3.next = 30;
                            break;

                          case 28:
                            _context3.next = 30;
                            return rejected({
                              status: false,
                              code: 500,
                              msg: "Time Check Not Valid"
                            });

                          case 30:
                          case "end":
                            return _context3.stop();
                        }
                      }
                    }, _callee3);
                  }));

                  return function (_x8, _x9) {
                    return _ref4.apply(this, arguments);
                  };
                }()));

              case 1:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4);
      }));

      return function (_x5, _x6, _x7) {
        return _ref3.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "getTimeRangeBetween", function (checkTime, startTime, endTime) {
      _this.mCheckTime = checkTime.replace(":", "");
      _this.mStartTime = startTime.replace(":", "");
      _this.mEndTime = endTime.replace(":", "");
      return _this.mCheckTime >= _this.mStartTime && _this.mCheckTime <= _this.mEndTime;
    });
    (0, _defineProperty2["default"])(this, "addTime", /*#__PURE__*/function () {
      var _ref5 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6(time, numberAdd, unit) {
        return _regenerator["default"].wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return new Promise( /*#__PURE__*/function () {
                  var _ref6 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(resolve, rejected) {
                    var timeMoment;
                    return _regenerator["default"].wrap(function _callee5$(_context5) {
                      while (1) {
                        switch (_context5.prev = _context5.next) {
                          case 0:
                            _context5.t0 = (0, _typeof2["default"])(time);
                            _context5.next = _context5.t0 === "string" ? 3 : _context5.t0 === "number" ? 15 : 16;
                            break;

                          case 3:
                            _context5.next = 5;
                            return (0, _momentTimezone["default"])(time, "DD-MM-YYYY HH:mm:ss");

                          case 5:
                            _this.mTime = _context5.sent;

                            if (!(typeof numberAdd !== "number")) {
                              _context5.next = 12;
                              break;
                            }

                            timeMoment = _this.mTime.add(numberAdd, unit);
                            _context5.next = 10;
                            return resolve({
                              humanize: timeMoment.format("DD-MM-YYYY HH:mm:ss"),
                              unix: timeMoment.unix()
                            });

                          case 10:
                            _context5.next = 14;
                            break;

                          case 12:
                            _context5.next = 14;
                            return rejected({
                              status: false,
                              code: 500,
                              msg: "Illegal Format Type NumberAdd"
                            });

                          case 14:
                            return _context5.abrupt("break", 17);

                          case 15:
                            return _context5.abrupt("break", 17);

                          case 16:
                            return _context5.abrupt("break", 17);

                          case 17:
                          case "end":
                            return _context5.stop();
                        }
                      }
                    }, _callee5);
                  }));

                  return function (_x13, _x14) {
                    return _ref6.apply(this, arguments);
                  };
                }());

              case 2:
                return _context6.abrupt("return", _context6.sent);

              case 3:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6);
      }));

      return function (_x10, _x11, _x12) {
        return _ref5.apply(this, arguments);
      };
    }());
    this.config = _lodash["default"].merge({
      locale: "id",
      timezone: "Asia/Makassar"
    }, config);

    _momentTimezone["default"].locale(this.config.locale);

    (0, _momentTimezone["default"])().tz(this.config.timezone);
  }
  /**
   *
   * @param {String | Number} startTime - start time to diff
   * require format DD-MM-YYYY HH:mm:ss
   * @param {String | number } endTime - end time to diff
   * require format DD-MM-YYYY HH:mm:ss
   * @example
   * let time = new Functions.TimeManagement();
   * time.getDifferentTime("01-04-2022","02-4-2022");
   * @returns {Promise<{
   * status : Boolean,
   * code : Number,
   * msg : String,
   * data : {
   *     duration_instance : Moment.Duration,
   *     unix : {
   *         start_time : Moment.unix,
   *         end_time : Moment.unix,
   *         duration_time : Moment.unix
   *     },
   *     diff : {
   *         time_years : number,
   *         time_month : number,
   *         time_week : number,
   *         time_days : number,
   *         time_hours : number,
   *         time_minutes : number,
   *         time_seconds : number,
   *         time_milliseconds : number
   *     },
   *     humanize : {
   *         start_time : String,
   *         end_time : String,
   *     },
   *     duration_humanize : String
   * }
   * }>}
   */


  (0, _createClass2["default"])(timeManagement, [{
    key: "TIME_FORMATTER",
    value: function TIME_FORMATTER(timeString) {
      var t = timeString.split(":");
      this.hour = parseInt(t[0]);
      this.minutes = parseInt(t[1]);
      this.seconds = parseInt(t[2]);

      this.isBiggerThan = function (other) {
        return (this.hour > other.hour || this.hour === other.hour) && (this.minutes > other.minutes || (this.minutes = other.minutes)) && this.seconds > other.seconds;
      };
    }
  }, {
    key: "TIME_IS_BETWEEN",
    value: function TIME_IS_BETWEEN(check, start, end) {
      return start.hour <= end.hour ? check.isBiggerThan(start) && !check.isBiggerThan(end) : check.isBiggerThan(start) && check.isBiggerThan(end) || !check.isBiggerThan(start) && !check.isBiggerThan(end);
    }
  }]);
  return timeManagement;
}();

var _default = timeManagement;
exports["default"] = _default;
//# sourceMappingURL=index.js.map