"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _lodash = _interopRequireDefault(require("lodash"));

var _Options = _interopRequireDefault(require("./../../Options"));

var _Security = _interopRequireDefault(require("../../Security"));

function checkModuleExist(name) {
  try {
    require.resolve(name);

    return true;
  } catch (e) {
    return false;
  }
}

var Reader = null;

var Nfc = /*#__PURE__*/function () {
  /**
   *
   * @returns {Nfc}
   */
  function Nfc(_config) {
    var _this = this;

    (0, _classCallCheck2["default"])(this, Nfc);
    (0, _defineProperty2["default"])(this, "mNFC", null);
    (0, _defineProperty2["default"])(this, "eventEmit", null);
    (0, _defineProperty2["default"])(this, "Trigger", /*#__PURE__*/function () {
      var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(event, callback) {
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.t0 = event;
                _context.next = _context.t0 === "READER" ? 3 : _context.t0 === "READER_ERROR" ? 6 : _context.t0 === "CARD_DETECTED" ? 9 : _context.t0 === "CARD_OFF" ? 12 : _context.t0 === "NFC_ERROR" ? 15 : _context.t0 === "FATAL_ERROR" ? 18 : _context.t0 === "UNKNOWN_ERROR" ? 21 : 24;
                break;

              case 3:
                _context.next = 5;
                return _this.mEventEmitter.on("reader", callback);

              case 5:
                return _context.abrupt("break", 24);

              case 6:
                _context.next = 8;
                return _this.mEventEmitter.on("card.error", callback);

              case 8:
                return _context.abrupt("break", 24);

              case 9:
                _context.next = 11;
                return _this.mEventEmitter.on("card", callback);

              case 11:
                return _context.abrupt("break", 24);

              case 12:
                _context.next = 14;
                return _this.mEventEmitter.on("card.off", callback);

              case 14:
                return _context.abrupt("break", 24);

              case 15:
                _context.next = 17;
                return _this.mEventEmitter.on("nfc.error", callback);

              case 17:
                return _context.abrupt("break", 24);

              case 18:
                _context.next = 20;
                return _this.mEventEmitter.on("nfc.fatal", callback);

              case 20:
                return _context.abrupt("break", 24);

              case 21:
                _context.next = 23;
                return _this.mEventEmitter.on("nfc.unknown.error", callback);

              case 23:
                return _context.abrupt("break", 24);

              case 24:
                return _context.abrupt("return", _this);

              case 25:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x, _x2) {
        return _ref.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "LoadAuthentificationKey", /*#__PURE__*/function () {
      var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(keyNumber, key, response) {
        return _regenerator["default"].wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return _this.mEventEmitter.on("card", /*#__PURE__*/function () {
                  var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(result) {
                    var reader;
                    return _regenerator["default"].wrap(function _callee4$(_context4) {
                      while (1) {
                        switch (_context4.prev = _context4.next) {
                          case 0:
                            reader = result.reader;
                            _context4.next = 3;
                            return reader.loadAuthenticationKey(keyNumber, key).then( /*#__PURE__*/function () {
                              var _ref4 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(res) {
                                return _regenerator["default"].wrap(function _callee2$(_context2) {
                                  while (1) {
                                    switch (_context2.prev = _context2.next) {
                                      case 0:
                                        _context2.next = 2;
                                        return response({
                                          status: true,
                                          code: 200,
                                          msg: "Successfully Load Authentification Key "
                                        });

                                      case 2:
                                      case "end":
                                        return _context2.stop();
                                    }
                                  }
                                }, _callee2);
                              }));

                              return function (_x7) {
                                return _ref4.apply(this, arguments);
                              };
                            }())["catch"]( /*#__PURE__*/function () {
                              var _ref5 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(error) {
                                return _regenerator["default"].wrap(function _callee3$(_context3) {
                                  while (1) {
                                    switch (_context3.prev = _context3.next) {
                                      case 0:
                                        _context3.next = 2;
                                        return response({
                                          status: false,
                                          code: 500,
                                          msg: "Failed Load Authentification Key ",
                                          error: error
                                        });

                                      case 2:
                                      case "end":
                                        return _context3.stop();
                                    }
                                  }
                                }, _callee3);
                              }));

                              return function (_x8) {
                                return _ref5.apply(this, arguments);
                              };
                            }());

                          case 3:
                          case "end":
                            return _context4.stop();
                        }
                      }
                    }, _callee4);
                  }));

                  return function (_x6) {
                    return _ref3.apply(this, arguments);
                  };
                }());

              case 2:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5);
      }));

      return function (_x3, _x4, _x5) {
        return _ref2.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "Authentificate", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7() {
      var arraySectorCluster,
          response,
          _args7 = arguments;
      return _regenerator["default"].wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              arraySectorCluster = _args7.length > 0 && _args7[0] !== undefined ? _args7[0] : [];
              response = _args7.length > 1 ? _args7[1] : undefined;
              _context7.next = 4;
              return _this.mEventEmitter.on("card", /*#__PURE__*/function () {
                var _ref7 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6(result) {
                  var reader, mArrayPass, num;
                  return _regenerator["default"].wrap(function _callee6$(_context6) {
                    while (1) {
                      switch (_context6.prev = _context6.next) {
                        case 0:
                          reader = result.reader;
                          mArrayPass = [];
                          num = 0;
                          _context6.next = 5;
                          return arraySectorCluster.forEach(function () {
                            try {
                              reader.authenticate(arraySectorCluster[num].blockNumber, arraySectorCluster[num].keyType, arraySectorCluster[num].key);
                              mArrayPass.push({
                                status: true,
                                blockNumber: arraySectorCluster[num].blockNumber
                              });
                            } catch (e) {
                              mArrayPass.push({
                                status: false,
                                blockNumber: arraySectorCluster[num].blockNumber
                              });
                            }

                            num++;
                          });

                        case 5:
                          _context6.next = 7;
                          return response(mArrayPass);

                        case 7:
                        case "end":
                          return _context6.stop();
                      }
                    }
                  }, _callee6);
                }));

                return function (_x9) {
                  return _ref7.apply(this, arguments);
                };
              }());

            case 4:
              return _context7.abrupt("return", _this);

            case 5:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7);
    })));
    (0, _defineProperty2["default"])(this, "Read", /*#__PURE__*/function () {
      var _ref8 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee10(blockNumber, response) {
        return _regenerator["default"].wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                _this.configRead = {};
                _context10.t0 = (0, _typeof2["default"])(blockNumber);
                _context10.next = _context10.t0 === "number" ? 4 : _context10.t0 === "object" ? 8 : 12;
                break;

              case 4:
                _context10.next = 6;
                return _lodash["default"].merge({
                  blockNumber: blockNumber,
                  dataLength: 16,
                  blockSize: 16,
                  authenticate: {
                    keyType: _this.config.authenticate.typeKey,
                    key: _this.config.authenticate.key
                  }
                });

              case 6:
                _this.configRead = _context10.sent;
                return _context10.abrupt("break", 12);

              case 8:
                _context10.next = 10;
                return _lodash["default"].merge({
                  blockNumber: 4,
                  dataLength: 16,
                  blockSize: 16,
                  authenticate: {
                    keyType: _this.config.authenticate.typeKey,
                    key: _this.config.authenticate.key
                  }
                }, blockNumber);

              case 10:
                _this.configRead = _context10.sent;
                return _context10.abrupt("break", 12);

              case 12:
                _context10.next = 14;
                return _this.mEventEmitter.on("card", /*#__PURE__*/function () {
                  var _ref9 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee9(result) {
                    var reader, mRead, tempRawData, arrayTypeData, objectTempData, mResponseTemp;
                    return _regenerator["default"].wrap(function _callee9$(_context9) {
                      while (1) {
                        switch (_context9.prev = _context9.next) {
                          case 0:
                            reader = result.reader;
                            _context9.prev = 1;
                            _context9.next = 4;
                            return reader.authenticate(_this.configRead.blockNumber, _this.configRead.authenticate.keyType, _this.configRead.authenticate.key);

                          case 4:
                            _context9.next = 6;
                            return reader.read(_this.configRead.blockNumber, _this.configRead.length, _this.configRead.blockSize);

                          case 6:
                            mRead = _context9.sent;

                            if (!_this.config.options.encryption.enabled) {
                              _context9.next = 11;
                              break;
                            }

                            _context9.next = 10;
                            return new _Security["default"].Encryption.Crypto({
                              algorithm: _Options["default"].ALGORITHM_AES_128_GCM
                            }).decodeIvSync(mRead);

                          case 10:
                            mRead = _context9.sent;

                          case 11:
                            tempRawData = mRead.toString().split("@")[0];
                            arrayTypeData = tempRawData.split("#");
                            objectTempData = {};
                            arrayTypeData.map( /*#__PURE__*/function () {
                              var _ref10 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee8(values) {
                                var jsonData;
                                return _regenerator["default"].wrap(function _callee8$(_context8) {
                                  while (1) {
                                    switch (_context8.prev = _context8.next) {
                                      case 0:
                                        jsonData = values.split(":");
                                        objectTempData[jsonData[0]] = jsonData[1]; // jsonData.map(async (mValues) => {
                                        //     console.log(mValues)
                                        //     objectTempData[mValues[0]] = mValues[1]
                                        // })

                                      case 2:
                                      case "end":
                                        return _context8.stop();
                                    }
                                  }
                                }, _callee8);
                              }));

                              return function (_x13) {
                                return _ref10.apply(this, arguments);
                              };
                            }());
                            mResponseTemp = {
                              status: true,
                              code: 200,
                              msg: "Successfully Read Data",
                              data: {
                                raw: mRead,
                                string: mRead.toString().split("@")[0],
                                length: mRead.toString().length,
                                refactorData: {
                                  companyId: mRead.toString().split("@")[0].split("#")[0],
                                  type_card: mRead.toString().split("@")[0].split("#")[1],
                                  uid_identify: mRead.toString().split("@")[0].split("#")[2]
                                },
                                card: {
                                  atr: result.card.atr,
                                  standard: result.card.standard,
                                  type: result.card.type,
                                  uid: result.card.uid
                                }
                              }
                            };
                            mResponseTemp.data.refactorData = objectTempData;
                            _context9.next = 19;
                            return response(mResponseTemp);

                          case 19:
                            _context9.next = 25;
                            break;

                          case 21:
                            _context9.prev = 21;
                            _context9.t0 = _context9["catch"](1);
                            _context9.next = 25;
                            return response({
                              status: false,
                              code: 500,
                              msg: "Failed Read Data",
                              error: _context9.t0
                            });

                          case 25:
                          case "end":
                            return _context9.stop();
                        }
                      }
                    }, _callee9, null, [[1, 21]]);
                  }));

                  return function (_x12) {
                    return _ref9.apply(this, arguments);
                  };
                }());

              case 14:
                return _context10.abrupt("return", _this);

              case 15:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee10);
      }));

      return function (_x10, _x11) {
        return _ref8.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "Baca", this.Read);
    (0, _defineProperty2["default"])(this, "Write", /*#__PURE__*/function () {
      var _ref11 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee13(data, response) {
        var mFinalDataToString;
        return _regenerator["default"].wrap(function _callee13$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                _this.configWrite = {};
                mFinalDataToString = "";
                _context13.t0 = (0, _typeof2["default"])(data);
                _context13.next = _context13.t0 === "string" ? 5 : _context13.t0 === "object" ? 9 : 21;
                break;

              case 5:
                _context13.next = 7;
                return _lodash["default"].merge({
                  blockNumber: 4,
                  data: data,
                  dataLength: 16,
                  blockSize: 16,
                  authenticate: {
                    keyType: _this.config.authenticate.typeKey,
                    key: _this.config.authenticate.key
                  }
                });

              case 7:
                _this.configWrite = _context13.sent;
                return _context13.abrupt("break", 21);

              case 9:
                _context13.next = 11;
                return _lodash["default"].merge({
                  blockNumber: 4,
                  data: data.data,
                  dataLength: 16,
                  blockSize: 16,
                  authenticate: {
                    keyType: _this.config.authenticate.typeKey,
                    key: _this.config.authenticate.key
                  }
                }, data);

              case 11:
                _this.configWrite = _context13.sent;
                _context13.t1 = (0, _typeof2["default"])(_this.configWrite.data);
                _context13.next = _context13.t1 === "object" ? 15 : _context13.t1 === "string" ? 18 : 20;
                break;

              case 15:
                //console.log(this.configWrite.data)

                /** Add Separator Split Character (#) for The push Data **/
                Object.keys(_this.configWrite.data).map( /*#__PURE__*/function () {
                  var _ref12 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee11(key, index, array) {
                    return _regenerator["default"].wrap(function _callee11$(_context11) {
                      while (1) {
                        switch (_context11.prev = _context11.next) {
                          case 0:
                            if (index !== array.length - 1) {
                              mFinalDataToString += "".concat(key, ":").concat(_this.configWrite.data[key], "#");
                            } else {
                              mFinalDataToString += "".concat(key, ":").concat(_this.configWrite.data[key]);
                            }

                          case 1:
                          case "end":
                            return _context11.stop();
                        }
                      }
                    }, _callee11);
                  }));

                  return function (_x16, _x17, _x18) {
                    return _ref12.apply(this, arguments);
                  };
                }());
                _this.configWrite.data = mFinalDataToString;
                return _context13.abrupt("break", 20);

              case 18:
                _this.configWrite.data = data.data;
                return _context13.abrupt("break", 20);

              case 20:
                return _context13.abrupt("break", 21);

              case 21:
                _context13.next = 23;
                return _this.mEventEmitter.on("card", /*#__PURE__*/function () {
                  var _ref13 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee12(result) {
                    var reader, mBuffer, mFillData;
                    return _regenerator["default"].wrap(function _callee12$(_context12) {
                      while (1) {
                        switch (_context12.prev = _context12.next) {
                          case 0:
                            reader = result.reader;
                            _context12.prev = 1;
                            _context12.next = 4;
                            return reader.authenticate(_this.configWrite.blockNumber, _this.configWrite.authenticate.keyType, _this.configWrite.authenticate.key);

                          case 4:
                            _context12.next = 6;
                            return Buffer.allocUnsafe(_this.configWrite.dataLength);

                          case 6:
                            mBuffer = _context12.sent;
                            mFillData = "".concat(_this.configWrite.data, "@");

                            if (_this.config.options.encryption.enabled) {
                              mFillData = new _Security["default"].Encryption.Crypto({
                                algorithm: _Options["default"].ALGORITHM_AES_128_GCM
                              }).encodeIvSync(mFillData);
                            }

                            _context12.next = 11;
                            return mBuffer.fill(mFillData);

                          case 11:
                            if (!(_this.configWrite.data.length <= _this.configWrite.dataLength)) {
                              _context12.next = 26;
                              break;
                            }

                            _context12.t0 = _this.config.cardType;
                            _context12.next = _context12.t0 === _Options["default"].MIFARE_CLASSIC_1K ? 15 : 24;
                            break;

                          case 15:
                            if (!(_this.configWrite.blockNumber === 4 || _this.configWrite.blockNumber === 8)) {
                              _context12.next = 22;
                              break;
                            }

                            _context12.next = 18;
                            return reader.write(_this.configWrite.blockNumber, mBuffer, _this.configWrite.blockSize);

                          case 18:
                            _context12.next = 20;
                            return response({
                              status: true,
                              code: 200,
                              msg: "Successfully Write Data",
                              data: {
                                raw: mBuffer.toString()
                              }
                            });

                          case 20:
                            _context12.next = 24;
                            break;

                          case 22:
                            _context12.next = 24;
                            return response({
                              status: false,
                              code: 505,
                              msg: "Failed Write Data. for Mifare 1 K blockNumber must 4 or 8 "
                            });

                          case 24:
                            _context12.next = 28;
                            break;

                          case 26:
                            _context12.next = 28;
                            return response({
                              status: false,
                              code: 505,
                              msg: "Failed Write Data. the data length must smaller than options 'dataLength' "
                            });

                          case 28:
                            _context12.next = 34;
                            break;

                          case 30:
                            _context12.prev = 30;
                            _context12.t1 = _context12["catch"](1);
                            _context12.next = 34;
                            return response({
                              status: false,
                              code: 500,
                              msg: "AUTHENTIFICATION : error",
                              error: _context12.t1
                            });

                          case 34:
                          case "end":
                            return _context12.stop();
                        }
                      }
                    }, _callee12, null, [[1, 30]]);
                  }));

                  return function (_x19) {
                    return _ref13.apply(this, arguments);
                  };
                }());

              case 23:
                return _context13.abrupt("return", _this);

              case 24:
              case "end":
                return _context13.stop();
            }
          }
        }, _callee13);
      }));

      return function (_x14, _x15) {
        return _ref11.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "Tulis", this.Write);
    (0, _defineProperty2["default"])(this, "Reset", /*#__PURE__*/function () {
      var _ref14 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee15(config, response) {
        var WriteConfig;
        return _regenerator["default"].wrap(function _callee15$(_context15) {
          while (1) {
            switch (_context15.prev = _context15.next) {
              case 0:
                _context15.next = 2;
                return _lodash["default"].merge({
                  blockNumber: 4,
                  blockSize: 16,
                  authentification: {
                    typeKey: _this.KEY_TYPE_A,
                    key: "FFFFFFFFFFFF"
                  }
                }, config);

              case 2:
                WriteConfig = _context15.sent;

                _this.mEventEmitter.on("card", /*#__PURE__*/function () {
                  var _ref15 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee14(result) {
                    var reader, mBuffer;
                    return _regenerator["default"].wrap(function _callee14$(_context14) {
                      while (1) {
                        switch (_context14.prev = _context14.next) {
                          case 0:
                            reader = result.reader;
                            _context14.prev = 1;
                            _context14.next = 4;
                            return reader.authenticate(WriteConfig.blockNumber, WriteConfig.authentification.typeKey, WriteConfig.authentification.key);

                          case 4:
                            _context14.next = 6;
                            return Buffer.allocUnsafe(WriteConfig.blockSize);

                          case 6:
                            mBuffer = _context14.sent;
                            _context14.next = 9;
                            return mBuffer.fill(0);

                          case 9:
                            _context14.next = 11;
                            return reader.write(WriteConfig.blockNumber, mBuffer, WriteConfig.blockSize);

                          case 11:
                            _context14.next = 13;
                            return response({
                              status: true,
                              code: 200,
                              msg: "Successfully Reset Data",
                              data: mBuffer.toString()
                            });

                          case 13:
                            _context14.next = 19;
                            break;

                          case 15:
                            _context14.prev = 15;
                            _context14.t0 = _context14["catch"](1);
                            _context14.next = 19;
                            return response({
                              status: false,
                              code: 505,
                              msg: "AUTHENTIFICATION : error",
                              error: _context14.t0
                            });

                          case 19:
                          case "end":
                            return _context14.stop();
                        }
                      }
                    }, _callee14, null, [[1, 15]]);
                  }));

                  return function (_x22) {
                    return _ref15.apply(this, arguments);
                  };
                }());

                return _context15.abrupt("return", _this);

              case 5:
              case "end":
                return _context15.stop();
            }
          }
        }, _callee15);
      }));

      return function (_x20, _x21) {
        return _ref14.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "Format", this.Reset);
    this.config = _lodash["default"].merge({
      state: _Options["default"].SERVER_STATE_DEVELOPMENT,
      cardType: _Options["default"].MIFARE_CLASSIC_1K,
      authenticate: {
        typeKey: Nfc.KEY_TYPE_A,
        key: "FFFFFFFFFFFF"
      },
      options: {
        autoProcessing: true,
        encryption: {
          enabled: false
        }
      }
    }, _config);

    var EventEmitter = require("node:events");

    this.mEventEmitter = new EventEmitter();

    if (checkModuleExist("nfc-pcsc")) {
      var _require = require("nfc-pcsc"),
          NFC = _require.NFC;

      try {
        this.mNFC = new NFC();
        this.mNFC.on('reader', /*#__PURE__*/function () {
          var _ref16 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee20(reader) {
            return _regenerator["default"].wrap(function _callee20$(_context20) {
              while (1) {
                switch (_context20.prev = _context20.next) {
                  case 0:
                    _this.mEventEmitter.emit("reader", reader);

                    _this.config.state === _Options["default"].SERVER_STATE_DEVELOPMENT ? console.log("reader ready ! :", "".concat(reader)) : false;
                    reader.autoProcessing = _this.config.options.autoProcessing;
                    _context20.next = 5;
                    return reader.on('card', /*#__PURE__*/function () {
                      var _ref17 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee16(card) {
                        return _regenerator["default"].wrap(function _callee16$(_context16) {
                          while (1) {
                            switch (_context16.prev = _context16.next) {
                              case 0:
                                _this.mEventEmitter.emit("card", {
                                  reader: reader,
                                  card: card
                                });

                                _this.config.state === _Options["default"].SERVER_STATE_DEVELOPMENT ? console.log("card detected :", "".concat(card)) : false;

                              case 2:
                              case "end":
                                return _context16.stop();
                            }
                          }
                        }, _callee16);
                      }));

                      return function (_x24) {
                        return _ref17.apply(this, arguments);
                      };
                    }());

                  case 5:
                    reader.on('card.off', /*#__PURE__*/function () {
                      var _ref18 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee17(card) {
                        return _regenerator["default"].wrap(function _callee17$(_context17) {
                          while (1) {
                            switch (_context17.prev = _context17.next) {
                              case 0:
                                _this.mEventEmitter.emit("card.off", card);

                                _this.config.state === _Options["default"].SERVER_STATE_DEVELOPMENT ? console.log("card remove :", "".concat(card)) : false;

                              case 2:
                              case "end":
                                return _context17.stop();
                            }
                          }
                        }, _callee17);
                      }));

                      return function (_x25) {
                        return _ref18.apply(this, arguments);
                      };
                    }());
                    _context20.next = 8;
                    return reader.on('error', /*#__PURE__*/function () {
                      var _ref19 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee18(error) {
                        return _regenerator["default"].wrap(function _callee18$(_context18) {
                          while (1) {
                            switch (_context18.prev = _context18.next) {
                              case 0:
                                _this.mEventEmitter.emit("card.error", {
                                  status: false,
                                  code: 502,
                                  msg: "Reader Error",
                                  error: error
                                });

                                _this.config.state === _Options["default"].SERVER_STATE_DEVELOPMENT ? console.log("reader error :", "".concat(error)) : false;

                              case 2:
                              case "end":
                                return _context18.stop();
                            }
                          }
                        }, _callee18);
                      }));

                      return function (_x26) {
                        return _ref19.apply(this, arguments);
                      };
                    }());

                  case 8:
                    _context20.next = 10;
                    return reader.on('end', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee19() {
                      return _regenerator["default"].wrap(function _callee19$(_context19) {
                        while (1) {
                          switch (_context19.prev = _context19.next) {
                            case 0:
                              _this.mEventEmitter.emit('card.end');

                              _this.config.state === _Options["default"].SERVER_STATE_DEVELOPMENT ? console.log("card end") : false;

                            case 2:
                            case "end":
                              return _context19.stop();
                          }
                        }
                      }, _callee19);
                    })));

                  case 10:
                  case "end":
                    return _context20.stop();
                }
              }
            }, _callee20);
          }));

          return function (_x23) {
            return _ref16.apply(this, arguments);
          };
        }());
        this.mNFC.on('error', /*#__PURE__*/function () {
          var _ref21 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee21(err) {
            var nFCErrorExtractStatus, error;
            return _regenerator["default"].wrap(function _callee21$(_context21) {
              while (1) {
                switch (_context21.prev = _context21.next) {
                  case 0:
                    nFCErrorExtractStatus = {
                      code: err.toString().split(":")[1].toString(),
                      description: err.toString().split(":")[2].toString()
                    };
                    error = {
                      status: false,
                      code: 500,
                      msg: "NFC Error",
                      error: nFCErrorExtractStatus
                    };

                    _this.mEventEmitter.emit("nfc.error", error);

                    _this.config.state === _Options["default"].SERVER_STATE_DEVELOPMENT ? console.log("nfc error : ", "".concat(nFCErrorExtractStatus)) : false;

                  case 4:
                  case "end":
                    return _context21.stop();
                }
              }
            }, _callee21);
          }));

          return function (_x27) {
            return _ref21.apply(this, arguments);
          };
        }());
      } catch (e) {
        var error = {
          status: false,
          code: 505,
          msg: "Unknown Error",
          error: e
        };
        this.mEventEmitter.emit("nfc.fatal", error);
      }
    } else {
      throw Error("MODULE `nfc-pcsc` not Installed. Please Installed First");
    }

    return this;
  }
  /**
   *
   * @param { "UNKNOWN_ERROR" | "FATAL_ERROR" | "NFC_ERROR" | "READER_ERROR" | "READER_END" | "READER" | "CARD_DETECTED" | "CARD_OFF"  } event
   * @param {Function} callback
   * @returns {Promise<Nfc>}
   */


  (0, _createClass2["default"])(Nfc, null, [{
    key: "KEY_TYPE_A",
    get: function get() {
      //**********************************************************************
      return checkModuleExist("nfc-pcsc") ? require("nfc-pcsc").KEY_TYPE_A : null; //**********************************************************************
    }
  }, {
    key: "KEY_TYPE_B",
    get: function get() {
      //**********************************************************************
      return checkModuleExist("nfc-pcsc") ? require("nfc-pcsc").KEY_TYPE_B : null; //**********************************************************************
    }
  }]);
  return Nfc;
}();

var _default = Nfc;
exports["default"] = _default;
//# sourceMappingURL=index.js.map