'use strict';
'use warning';

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _indexModule = _interopRequireWildcard(require("./../../../index.module.d"));

var _lodash = _interopRequireDefault(require("lodash"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var configEscposGlobally;

function checkModuleExist(name) {
  try {
    require.resolve(name);

    return true;
  } catch (e) {
    return false;
  }
}

var Escpos = /*#__PURE__*/(0, _createClass2["default"])(function Escpos(config) {
  var _this = this;

  (0, _classCallCheck2["default"])(this, Escpos);
  this.config = _lodash["default"].merge(_indexModule["default"].config.Hardware.Printer.Escpos, config);

  var mEscpos = require("escpos");

  return new Promise( /*#__PURE__*/function () {
    var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(resolve, rejected) {
      return _regenerator["default"].wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              _context5.t0 = _this.config.type;
              _context5.next = _context5.t0 === _indexModule.Options.ESCPOS_TYPE_USB ? 3 : _context5.t0 === _indexModule.Options.ESCPOS_TYPE_NETWORK ? 31 : _context5.t0 === _indexModule.Options.ESCPOS_TYPE_SERIAL ? 35 : _context5.t0 === _indexModule.Options.ESCPOS_TYPE_BLUETOOTH ? 40 : 42;
              break;

            case 3:
              _context5.prev = 3;
              mEscpos.USB = checkModuleExist("escpos-usb") ? require("escpos-usb") : console.error("MODULE `escpos-usb` not installed. please Installed First");

              if (!(mEscpos.USB.findPrinter().length > 0)) {
                _context5.next = 22;
                break;
              }

              if (!(_this.config.settings.usb.vendorId !== undefined && _this.config.settings.usb.productId !== undefined)) {
                _context5.next = 12;
                break;
              }

              _context5.next = 9;
              return new mEscpos.USB(_this.config.settings.usb.vendorId, _this.config.settings.usb.productId);

            case 9:
              _context5.t1 = _context5.sent;
              _context5.next = 15;
              break;

            case 12:
              _context5.next = 14;
              return new mEscpos.USB();

            case 14:
              _context5.t1 = _context5.sent;

            case 15:
              _this.device = _context5.t1;
              _context5.next = 18;
              return new mEscpos.Printer(_this.device, _this.config.options);

            case 18:
              _this.printer = _context5.sent;

              _this.device.open( /*#__PURE__*/function () {
                var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(error) {
                  return _regenerator["default"].wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          if (error) {
                            _context.next = 6;
                            break;
                          }

                          if (_this.config.copyright.enabled) {
                            _this.printer.align('ct').style('b').text(_this.config.copyright.banner).style('').text(_this.config.copyright.description).feed(3).align('lt');
                          }

                          _context.next = 4;
                          return resolve(_this.printer);

                        case 4:
                          _context.next = 8;
                          break;

                        case 6:
                          _context.next = 8;
                          return rejected({
                            status: false,
                            code: 505,
                            msg: "Failed To Open Printer",
                            error: error
                          });

                        case 8:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee);
                }));

                return function (_x3) {
                  return _ref2.apply(this, arguments);
                };
              }());

              _context5.next = 24;
              break;

            case 22:
              _context5.next = 24;
              return rejected({
                status: false,
                code: 404,
                msg: "Error, Printer Device Not Detected"
              });

            case 24:
              _context5.next = 30;
              break;

            case 26:
              _context5.prev = 26;
              _context5.t2 = _context5["catch"](3);
              _context5.next = 30;
              return rejected({
                status: false,
                code: 500,
                msg: "Fatal Error Unknown",
                error: _context5.t2
              });

            case 30:
              return _context5.abrupt("break", 69);

            case 31:
              /** Parsing The Network Function For The Data Type Communication **/

              /** End Parsing The Network Function For The Data Type Communication **/
              //#########################################################################################
              mEscpos.network = checkModuleExist("escpos-network") ? require("escpos-network") : console.error("MODULE `escpos-network` not installed. please Installed First");
              _this.device = new mEscpos.network(_this.config.settings.network.ipAddress, _this.config.settings.network.port);
              _this.printer = new mEscpos.Printer(_this.device, _this.config.options);
              return _context5.abrupt("break", 69);

            case 35:
              /** Start Parsing The Serial Function For The Data Type Communication **/

              /** End Start Parsing The Serial Function For The Data Type Communication **/
              mEscpos.serial = checkModuleExist("escpos-serialport") ? require("escpos-serialport") : console.error("MODULE `escpos-serialport` not installed. please Installed First");
              _this.device = _this.config.settings.serial.settings !== undefined ? new mEscpos.serial(_this.config.settings.serial.port, _this.config.settings.serial.settings) : new mEscpos.serial(_this.config.settings.serial.port);
              _this.printer = new mEscpos.Printer(_this.device, _this.config.options);

              _this.device.open( /*#__PURE__*/function () {
                var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(error) {
                  return _regenerator["default"].wrap(function _callee3$(_context3) {
                    while (1) {
                      switch (_context3.prev = _context3.next) {
                        case 0:
                          if (error) {
                            _context3.next = 6;
                            break;
                          }

                          _this.printer.getStatuses( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
                            return _regenerator["default"].wrap(function _callee2$(_context2) {
                              while (1) {
                                switch (_context2.prev = _context2.next) {
                                  case 0:
                                  case "end":
                                    return _context2.stop();
                                }
                              }
                            }, _callee2);
                          })));

                          _context3.next = 4;
                          return resolve(_this.printer);

                        case 4:
                          _context3.next = 8;
                          break;

                        case 6:
                          _context3.next = 8;
                          return rejected({
                            status: false,
                            code: 505,
                            msg: "Failed To Open Printer",
                            error: error
                          });

                        case 8:
                        case "end":
                          return _context3.stop();
                      }
                    }
                  }, _callee3);
                }));

                return function (_x4) {
                  return _ref3.apply(this, arguments);
                };
              }());

              return _context5.abrupt("break", 69);

            case 40:
              console.log("type printer connection not available now");
              return _context5.abrupt("break", 69);

            case 42:
              _context5.prev = 42;
              mEscpos.USB = checkModuleExist("escpos-usb") ? require("escpos-usb") : console.error("MODULE `escpos-usb` not installed. please Installed First");

              if (!(mEscpos.USB.findPrinter().length > 0)) {
                _context5.next = 61;
                break;
              }

              if (!(_this.config.settings.usb.vendorId !== undefined && _this.config.settings.usb.productId !== undefined)) {
                _context5.next = 51;
                break;
              }

              _context5.next = 48;
              return new mEscpos.USB(_this.config.settings.usb.vendorId, _this.config.settings.usb.productId);

            case 48:
              _context5.t3 = _context5.sent;
              _context5.next = 54;
              break;

            case 51:
              _context5.next = 53;
              return new mEscpos.USB();

            case 53:
              _context5.t3 = _context5.sent;

            case 54:
              _this.device = _context5.t3;
              _context5.next = 57;
              return new mEscpos.Printer(_this.device, _this.config.options);

            case 57:
              _this.printer = _context5.sent;

              _this.device.open( /*#__PURE__*/function () {
                var _ref5 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(error) {
                  return _regenerator["default"].wrap(function _callee4$(_context4) {
                    while (1) {
                      switch (_context4.prev = _context4.next) {
                        case 0:
                          if (error) {
                            _context4.next = 5;
                            break;
                          }

                          _context4.next = 3;
                          return resolve(_this.printer, _this.device);

                        case 3:
                          _context4.next = 7;
                          break;

                        case 5:
                          _context4.next = 7;
                          return rejected({
                            status: false,
                            code: 505,
                            msg: "Failed To Open Printer",
                            error: error
                          });

                        case 7:
                        case "end":
                          return _context4.stop();
                      }
                    }
                  }, _callee4);
                }));

                return function (_x5) {
                  return _ref5.apply(this, arguments);
                };
              }());

              _context5.next = 63;
              break;

            case 61:
              _context5.next = 63;
              return rejected({
                status: false,
                code: 404,
                msg: "Error, Printer Device Not Detected"
              });

            case 63:
              _context5.next = 69;
              break;

            case 65:
              _context5.prev = 65;
              _context5.t4 = _context5["catch"](42);
              _context5.next = 69;
              return rejected({
                status: false,
                code: 500,
                msg: "Fatal Error Unknown",
                error: _context5.t4
              });

            case 69:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5, null, [[3, 26], [42, 65]]);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }());
});
var _default = Escpos;
exports["default"] = _default;
//# sourceMappingURL=index.js.map