'use warnings';
'use strict';

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _Options = _interopRequireDefault(require("./../../Options"));

var _lodash = _interopRequireDefault(require("lodash"));

var _child_process = require("child_process");

var _ispi = _interopRequireDefault(require("@rodrigogs/ispi"));

/**
 * @class RaspberryPi
 */
var RaspberryPi = /*#__PURE__*/function () {
  /**
   *
   * @param config
   */
  function RaspberryPi(config) {
    var _this = this;

    (0, _classCallCheck2["default"])(this, RaspberryPi);
    (0, _defineProperty2["default"])(this, "mPortArray", {});
    (0, _defineProperty2["default"])(this, "export", /*#__PURE__*/function () {
      var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(pin, settings) {
        var defaultLower,
            _args3 = arguments;
        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                defaultLower = _args3.length > 2 && _args3[2] !== undefined ? _args3[2] : _this.config.defaultLower;
                _context3.next = 3;
                return new Promise( /*#__PURE__*/function () {
                  var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(resolve, rejected) {
                    var mPort;
                    return _regenerator["default"].wrap(function _callee2$(_context2) {
                      while (1) {
                        switch (_context2.prev = _context2.next) {
                          case 0:
                            if (!_ispi["default"].sync()) {
                              _context2.next = 17;
                              break;
                            }

                            _context2.next = 3;
                            return _lodash["default"].extend({
                              direction: _Options["default"].GPIO_DIR_OUT,
                              interval: 200
                            }, settings);

                          case 3:
                            _this.settingsExport = _context2.sent;
                            _context2.t0 = _this.config.engine;
                            _context2.next = _context2.t0 === RaspberryPi.ENGINE_GPIO_LIBRARY ? 7 : 12;
                            break;

                          case 7:
                            mPort = _this.engineInstance["export"]("".concat(pin), {
                              direction: _this.settingsExport.direction,
                              interval: _this.settingsExport.interval,
                              ready: function () {
                                var _ready = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
                                  return _regenerator["default"].wrap(function _callee$(_context) {
                                    while (1) {
                                      switch (_context.prev = _context.next) {
                                        case 0:
                                          if (!defaultLower) {
                                            _context.next = 3;
                                            break;
                                          }

                                          _context.next = 3;
                                          return (0, _child_process.execSync)("gpio -g write ".concat(pin, " 1"));

                                        case 3:
                                        case "end":
                                          return _context.stop();
                                      }
                                    }
                                  }, _callee);
                                }));

                                function ready() {
                                  return _ready.apply(this, arguments);
                                }

                                return ready;
                              }()
                            });
                            _this.mPortArray[pin] = {
                              instance: mPort,
                              direction: _this.settingsExport.direction,
                              interval: _this.settingsExport.interval
                            };
                            _context2.next = 11;
                            return resolve({
                              status: true,
                              code: 200,
                              msg: "Successfully Export Port Raspberry Pi",
                              pin: pin,
                              direction: _this.settingsExport.direction
                            });

                          case 11:
                            return _context2.abrupt("break", 15);

                          case 12:
                            _context2.next = 14;
                            return rejected({
                              status: false,
                              code: 500,
                              msg: "Engine Config unknown or Unavailable"
                            });

                          case 14:
                            return _context2.abrupt("break", 15);

                          case 15:
                            _context2.next = 19;
                            break;

                          case 17:
                            _context2.next = 19;
                            return rejected({
                              status: false,
                              code: 505,
                              msg: "This Device Not Raspberry Pi"
                            });

                          case 19:
                          case "end":
                            return _context2.stop();
                        }
                      }
                    }, _callee2);
                  }));

                  return function (_x3, _x4) {
                    return _ref2.apply(this, arguments);
                  };
                }());

              case 3:
                return _context3.abrupt("return", _context3.sent);

              case 4:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      }));

      return function (_x, _x2) {
        return _ref.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "read", /*#__PURE__*/function () {
      var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6(pin) {
        return _regenerator["default"].wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return new Promise( /*#__PURE__*/function () {
                  var _ref4 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(resolve, rejected) {
                    return _regenerator["default"].wrap(function _callee5$(_context5) {
                      while (1) {
                        switch (_context5.prev = _context5.next) {
                          case 0:
                            if (!_ispi["default"].sync()) {
                              _context5.next = 11;
                              break;
                            }

                            _context5.t0 = _this.config.engine;
                            _context5.next = _context5.t0 === RaspberryPi.ENGINE_GPIO_LIBRARY ? 4 : 6;
                            break;

                          case 4:
                            Object.keys(_this.mPortArray).map( /*#__PURE__*/function () {
                              var _ref5 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(key) {
                                return _regenerator["default"].wrap(function _callee4$(_context4) {
                                  while (1) {
                                    switch (_context4.prev = _context4.next) {
                                      case 0:
                                        if (!(Number(key) === Number(pin))) {
                                          _context4.next = 3;
                                          break;
                                        }

                                        _context4.next = 3;
                                        return resolve({
                                          status: true,
                                          code: 200,
                                          msg: "Successfully to Read State",
                                          state: _this.mPortArray[key].instance.value
                                        });

                                      case 3:
                                      case "end":
                                        return _context4.stop();
                                    }
                                  }
                                }, _callee4);
                              }));

                              return function (_x8) {
                                return _ref5.apply(this, arguments);
                              };
                            }());
                            return _context5.abrupt("break", 9);

                          case 6:
                            _context5.next = 8;
                            return rejected({
                              status: false,
                              code: 500,
                              msg: "Engine Config unknown or Unavailable"
                            });

                          case 8:
                            return _context5.abrupt("break", 9);

                          case 9:
                            _context5.next = 13;
                            break;

                          case 11:
                            _context5.next = 13;
                            return rejected({
                              status: false,
                              code: 505,
                              msg: "This Device Not Raspberry Pi"
                            });

                          case 13:
                          case "end":
                            return _context5.stop();
                        }
                      }
                    }, _callee5);
                  }));

                  return function (_x6, _x7) {
                    return _ref4.apply(this, arguments);
                  };
                }());

              case 2:
                return _context6.abrupt("return", _context6.sent);

              case 3:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6);
      }));

      return function (_x5) {
        return _ref3.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "set", /*#__PURE__*/function () {
      var _ref6 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee9(pin) {
        var state,
            defaultLower,
            _args9 = arguments;
        return _regenerator["default"].wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                state = _args9.length > 1 && _args9[1] !== undefined ? _args9[1] : false;
                defaultLower = _args9.length > 2 && _args9[2] !== undefined ? _args9[2] : _this.config.defaultLower;
                _context9.next = 4;
                return new Promise( /*#__PURE__*/function () {
                  var _ref7 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee8(resolve, rejected) {
                    return _regenerator["default"].wrap(function _callee8$(_context8) {
                      while (1) {
                        switch (_context8.prev = _context8.next) {
                          case 0:
                            if (!_ispi["default"].sync()) {
                              _context8.next = 11;
                              break;
                            }

                            _context8.t0 = _this.config.engine;
                            _context8.next = _context8.t0 === RaspberryPi.ENGINE_GPIO_LIBRARY ? 4 : 6;
                            break;

                          case 4:
                            Object.keys(_this.mPortArray).map( /*#__PURE__*/function () {
                              var _ref8 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7(key) {
                                return _regenerator["default"].wrap(function _callee7$(_context7) {
                                  while (1) {
                                    switch (_context7.prev = _context7.next) {
                                      case 0:
                                        if (!(Number(key) === Number(pin))) {
                                          _context7.next = 27;
                                          break;
                                        }

                                        if (!(_this.mPortArray[key].direction === _Options["default"].GPIO_DIR_OUT)) {
                                          _context7.next = 27;
                                          break;
                                        }

                                        if (!(defaultLower === false)) {
                                          _context7.next = 16;
                                          break;
                                        }

                                        if (!state) {
                                          _context7.next = 10;
                                          break;
                                        }

                                        _context7.next = 6;
                                        return (0, _child_process.execSync)("gpio -g write ".concat(pin, " 1"));

                                      case 6:
                                        _context7.next = 8;
                                        return resolve({
                                          status: true,
                                          code: 200,
                                          msg: "state IO is High Successfully Set"
                                        });

                                      case 8:
                                        _context7.next = 14;
                                        break;

                                      case 10:
                                        _context7.next = 12;
                                        return (0, _child_process.execSync)("gpio -g write ".concat(pin, " 0"));

                                      case 12:
                                        _context7.next = 14;
                                        return resolve({
                                          status: true,
                                          code: 200,
                                          msg: "state IO is Low Successfully Set"
                                        });

                                      case 14:
                                        _context7.next = 27;
                                        break;

                                      case 16:
                                        if (!state) {
                                          _context7.next = 23;
                                          break;
                                        }

                                        _context7.next = 19;
                                        return (0, _child_process.execSync)("gpio -g write ".concat(pin, " 0"));

                                      case 19:
                                        _context7.next = 21;
                                        return resolve({
                                          status: true,
                                          code: 200,
                                          msg: "state IO is High Successfully Set"
                                        });

                                      case 21:
                                        _context7.next = 27;
                                        break;

                                      case 23:
                                        _context7.next = 25;
                                        return (0, _child_process.execSync)("gpio -g write ".concat(pin, " 1"));

                                      case 25:
                                        _context7.next = 27;
                                        return resolve({
                                          status: true,
                                          code: 200,
                                          msg: "state IO is Low Successfully Set"
                                        });

                                      case 27:
                                      case "end":
                                        return _context7.stop();
                                    }
                                  }
                                }, _callee7);
                              }));

                              return function (_x12) {
                                return _ref8.apply(this, arguments);
                              };
                            }());
                            return _context8.abrupt("break", 9);

                          case 6:
                            _context8.next = 8;
                            return rejected({
                              status: false,
                              code: 500,
                              msg: "Engine Config unknown or Unavailable"
                            });

                          case 8:
                            return _context8.abrupt("break", 9);

                          case 9:
                            _context8.next = 13;
                            break;

                          case 11:
                            _context8.next = 13;
                            return rejected({
                              status: false,
                              code: 505,
                              msg: "This Device Not Raspberry Pi"
                            });

                          case 13:
                          case "end":
                            return _context8.stop();
                        }
                      }
                    }, _callee8);
                  }));

                  return function (_x10, _x11) {
                    return _ref7.apply(this, arguments);
                  };
                }());

              case 4:
                return _context9.abrupt("return", _context9.sent);

              case 5:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9);
      }));

      return function (_x9) {
        return _ref6.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "change", /*#__PURE__*/function () {
      var _ref9 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee12(pin, callback) {
        return _regenerator["default"].wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                if (!_ispi["default"].sync()) {
                  _context12.next = 10;
                  break;
                }

                _context12.t0 = _this.config.engine;
                _context12.next = _context12.t0 === RaspberryPi.ENGINE_GPIO_LIBRARY ? 4 : 6;
                break;

              case 4:
                Object.keys(_this.mPortArray).map( /*#__PURE__*/function () {
                  var _ref10 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee11(key) {
                    return _regenerator["default"].wrap(function _callee11$(_context11) {
                      while (1) {
                        switch (_context11.prev = _context11.next) {
                          case 0:
                            if (Number(key) === Number(pin)) {
                              if (_this.mPortArray[key].direction === _Options["default"].GPIO_DIR_IN) {
                                _this.mPortArray[key].instance.on("change", /*#__PURE__*/function () {
                                  var _ref11 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee10(pinStates) {
                                    return _regenerator["default"].wrap(function _callee10$(_context10) {
                                      while (1) {
                                        switch (_context10.prev = _context10.next) {
                                          case 0:
                                            callback(null, {
                                              status: true,
                                              code: 200,
                                              msg: "detecting Pin State to ".concat(pinStates),
                                              state: pinStates
                                            });

                                          case 1:
                                          case "end":
                                            return _context10.stop();
                                        }
                                      }
                                    }, _callee10);
                                  }));

                                  return function (_x16) {
                                    return _ref11.apply(this, arguments);
                                  };
                                }());
                              } else {
                                callback({
                                  status: false,
                                  code: 505,
                                  msg: "The Pin is Not Dir In Mode. please Set Dir In Mode"
                                });
                              }
                            }

                          case 1:
                          case "end":
                            return _context11.stop();
                        }
                      }
                    }, _callee11);
                  }));

                  return function (_x15) {
                    return _ref10.apply(this, arguments);
                  };
                }());
                return _context12.abrupt("break", 8);

              case 6:
                callback({
                  status: false,
                  code: 500,
                  msg: "Engine Config unknown or Unavailable"
                });
                return _context12.abrupt("break", 8);

              case 8:
                _context12.next = 11;
                break;

              case 10:
                callback({
                  status: false,
                  code: 505,
                  msg: "This Device Not Raspberry Pi"
                });

              case 11:
              case "end":
                return _context12.stop();
            }
          }
        }, _callee12);
      }));

      return function (_x13, _x14) {
        return _ref9.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "toggle", /*#__PURE__*/function () {
      var _ref12 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee17(pin) {
        var delay,
            defaultLower,
            _args17 = arguments;
        return _regenerator["default"].wrap(function _callee17$(_context17) {
          while (1) {
            switch (_context17.prev = _context17.next) {
              case 0:
                delay = _args17.length > 1 && _args17[1] !== undefined ? _args17[1] : 200;
                defaultLower = _args17.length > 2 && _args17[2] !== undefined ? _args17[2] : _this.config.defaultLower;
                return _context17.abrupt("return", new Promise( /*#__PURE__*/function () {
                  var _ref13 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee16(resolve, rejected) {
                    return _regenerator["default"].wrap(function _callee16$(_context16) {
                      while (1) {
                        switch (_context16.prev = _context16.next) {
                          case 0:
                            if (!_ispi["default"].sync()) {
                              _context16.next = 11;
                              break;
                            }

                            _context16.t0 = _this.config.engine;
                            _context16.next = _context16.t0 === RaspberryPi.ENGINE_GPIO_LIBRARY ? 4 : 6;
                            break;

                          case 4:
                            Object.keys(_this.mPortArray).map( /*#__PURE__*/function () {
                              var _ref14 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee15(key) {
                                return _regenerator["default"].wrap(function _callee15$(_context15) {
                                  while (1) {
                                    switch (_context15.prev = _context15.next) {
                                      case 0:
                                        if (!(Number(key) === Number(pin))) {
                                          _context15.next = 15;
                                          break;
                                        }

                                        if (!(_this.mPortArray[key].direction === _Options["default"].GPIO_DIR_OUT)) {
                                          _context15.next = 13;
                                          break;
                                        }

                                        if (!(defaultLower === false)) {
                                          _context15.next = 8;
                                          break;
                                        }

                                        _context15.next = 5;
                                        return (0, _child_process.execSync)("gpio -g write ".concat(pin, " 1"));

                                      case 5:
                                        setTimeout( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee13() {
                                          return _regenerator["default"].wrap(function _callee13$(_context13) {
                                            while (1) {
                                              switch (_context13.prev = _context13.next) {
                                                case 0:
                                                  _context13.next = 2;
                                                  return (0, _child_process.execSync)("gpio -g write ".concat(pin, " 0"));

                                                case 2:
                                                  _context13.next = 4;
                                                  return resolve({
                                                    status: true,
                                                    code: 200,
                                                    msg: "state IO is Low Successfully Set"
                                                  });

                                                case 4:
                                                case "end":
                                                  return _context13.stop();
                                              }
                                            }
                                          }, _callee13);
                                        })), delay);
                                        /*await mArray[key].instance.set();
                                        await mDelay(delay);
                                        await mArray[key].instance.set(0);*/

                                        _context15.next = 11;
                                        break;

                                      case 8:
                                        _context15.next = 10;
                                        return (0, _child_process.execSync)("gpio -g write ".concat(pin, " 0"));

                                      case 10:
                                        setTimeout( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee14() {
                                          return _regenerator["default"].wrap(function _callee14$(_context14) {
                                            while (1) {
                                              switch (_context14.prev = _context14.next) {
                                                case 0:
                                                  _context14.next = 2;
                                                  return (0, _child_process.execSync)("gpio -g write ".concat(pin, " 1"));

                                                case 2:
                                                  _context14.next = 4;
                                                  return resolve({
                                                    status: true,
                                                    code: 200,
                                                    msg: "state IO is Low Successfully Set"
                                                  });

                                                case 4:
                                                case "end":
                                                  return _context14.stop();
                                              }
                                            }
                                          }, _callee14);
                                        })), delay);
                                        /*await mArray[key].instance.set(0);
                                        await mDelay(delay);
                                        await mArray[key].instance.set();
                                        await resolve({ status : true, code : 200, msg : `state IO is Low Successfully Set`});*/

                                      case 11:
                                        _context15.next = 15;
                                        break;

                                      case 13:
                                        _context15.next = 15;
                                        return rejected({
                                          status: false,
                                          code: 500,
                                          msg: "The Pin is Not Dir Out Mode. please Set Dir Out Mode"
                                        });

                                      case 15:
                                      case "end":
                                        return _context15.stop();
                                    }
                                  }
                                }, _callee15);
                              }));

                              return function (_x20) {
                                return _ref14.apply(this, arguments);
                              };
                            }());
                            return _context16.abrupt("break", 9);

                          case 6:
                            _context16.next = 8;
                            return rejected({
                              status: false,
                              code: 500,
                              msg: "Engine Config unknown or Unavailable"
                            });

                          case 8:
                            return _context16.abrupt("break", 9);

                          case 9:
                            _context16.next = 13;
                            break;

                          case 11:
                            _context16.next = 13;
                            return rejected({
                              status: false,
                              code: 505,
                              msg: "This Device Not Raspberry Pi"
                            });

                          case 13:
                          case "end":
                            return _context16.stop();
                        }
                      }
                    }, _callee16);
                  }));

                  return function (_x18, _x19) {
                    return _ref13.apply(this, arguments);
                  };
                }()));

              case 3:
              case "end":
                return _context17.stop();
            }
          }
        }, _callee17);
      }));

      return function (_x17) {
        return _ref12.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "reset", /*#__PURE__*/function () {
      var _ref17 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee22(pin) {
        var defaultLower,
            _args22 = arguments;
        return _regenerator["default"].wrap(function _callee22$(_context22) {
          while (1) {
            switch (_context22.prev = _context22.next) {
              case 0:
                defaultLower = _args22.length > 1 && _args22[1] !== undefined ? _args22[1] : _this.config.defaultLower;
                _context22.next = 3;
                return new Promise( /*#__PURE__*/function () {
                  var _ref18 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee21(resolve, rejected) {
                    return _regenerator["default"].wrap(function _callee21$(_context21) {
                      while (1) {
                        switch (_context21.prev = _context21.next) {
                          case 0:
                            if (!_ispi["default"].sync()) {
                              _context21.next = 8;
                              break;
                            }

                            _context21.t0 = _this.config.engine;
                            _context21.next = _context21.t0 === RaspberryPi.ENGINE_GPIO_LIBRARY ? 4 : 6;
                            break;

                          case 4:
                            Object.keys(_this.mPortArray).map( /*#__PURE__*/function () {
                              var _ref19 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee20(key) {
                                return _regenerator["default"].wrap(function _callee20$(_context20) {
                                  while (1) {
                                    switch (_context20.prev = _context20.next) {
                                      case 0:
                                        if (!(Number(key) === Number(pin))) {
                                          _context20.next = 15;
                                          break;
                                        }

                                        if (!(defaultLower === false)) {
                                          _context20.next = 11;
                                          break;
                                        }

                                        if (!(_this.mPortArray[key].direction === _Options["default"].GPIO_DIR_IN)) {
                                          _context20.next = 5;
                                          break;
                                        }

                                        _context20.next = 5;
                                        return _this.mPortArray[key].instance.removeAllListeners('change');

                                      case 5:
                                        _context20.next = 7;
                                        return _this.mPortArray[key].instance.reset();

                                      case 7:
                                        _context20.next = 9;
                                        return _this.mPortArray[key].instance.unexport( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee18() {
                                          return _regenerator["default"].wrap(function _callee18$(_context18) {
                                            while (1) {
                                              switch (_context18.prev = _context18.next) {
                                                case 0:
                                                  _context18.next = 2;
                                                  return resolve({
                                                    status: true,
                                                    code: 200,
                                                    msg: "Successfully to Reset Port"
                                                  });

                                                case 2:
                                                  delete _this.mPortArray[key];

                                                case 3:
                                                case "end":
                                                  return _context18.stop();
                                              }
                                            }
                                          }, _callee18);
                                        })));

                                      case 9:
                                        _context20.next = 15;
                                        break;

                                      case 11:
                                        if (!(_this.mPortArray[key].direction === _Options["default"].GPIO_DIR_IN)) {
                                          _context20.next = 14;
                                          break;
                                        }

                                        _context20.next = 14;
                                        return _this.mPortArray[key].instance.removeAllListeners('change');

                                      case 14:
                                        _this.mPortArray[key].instance.unexport( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee19() {
                                          return _regenerator["default"].wrap(function _callee19$(_context19) {
                                            while (1) {
                                              switch (_context19.prev = _context19.next) {
                                                case 0:
                                                  _context19.next = 2;
                                                  return resolve({
                                                    status: true,
                                                    code: 200,
                                                    msg: "Successfully to Reset Port"
                                                  });

                                                case 2:
                                                  delete _this.mPortArray[key];

                                                case 3:
                                                case "end":
                                                  return _context19.stop();
                                              }
                                            }
                                          }, _callee19);
                                        })));

                                      case 15:
                                      case "end":
                                        return _context20.stop();
                                    }
                                  }
                                }, _callee20);
                              }));

                              return function (_x24) {
                                return _ref19.apply(this, arguments);
                              };
                            }());
                            return _context21.abrupt("break", 6);

                          case 6:
                            _context21.next = 10;
                            break;

                          case 8:
                            _context21.next = 10;
                            return rejected({
                              status: false,
                              code: 505,
                              msg: "This Device Not Raspberry Pi"
                            });

                          case 10:
                          case "end":
                            return _context21.stop();
                        }
                      }
                    }, _callee21);
                  }));

                  return function (_x22, _x23) {
                    return _ref18.apply(this, arguments);
                  };
                }());

              case 3:
                return _context22.abrupt("return", _context22.sent);

              case 4:
              case "end":
                return _context22.stop();
            }
          }
        }, _callee22);
      }));

      return function (_x21) {
        return _ref17.apply(this, arguments);
      };
    }());
    this.mPortArray = {};
    this.config = _lodash["default"].extend({
      engine: RaspberryPi.ENGINE_GPIO_LIBRARY,
      defaultLower: false
    }, config);

    function checkModuleExist(name) {
      try {
        require.resolve(name);

        return true;
      } catch (e) {
        return false;
      }
    }

    switch (this.config.engine) {
      case RaspberryPi.ENGINE_JHONNYFIVE:
        //this.engineInstance = new Board();
        break;

      case RaspberryPi.ENGINE_GPIO_LIBRARY:
        this.engineInstance = checkModuleExist("gpio") ? require("gpio") : function (e) {
          throw e;
        }(Error("MODULE GPIO NOT EXISTS OR NOT INSTALLED. PLEASE INSTALLED FIRST"));
        break;

      default:
        //this.engineInstance = new Board();
        break;
    }
  }
  /**
   *
   * @param {Number} pin the gpio number board
   * @param {{ direction : String, interval : Number}} settings - for setting gpio options
   * @param {Boolean}defaultLower
   * @returns {Promise<Object>} the return Response
   */


  (0, _createClass2["default"])(RaspberryPi, null, [{
    key: "ENGINE_JHONNYFIVE",
    get: function get() {
      return 1;
    }
  }, {
    key: "ENGINE_GPIO_LIBRARY",
    get: function get() {
      return 2;
    }
    /**
     *
     * @type {{}}
     */

  }]);
  return RaspberryPi;
}();

var _default = RaspberryPi;
exports["default"] = _default;
//# sourceMappingURL=index.js.map