"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _lodash = _interopRequireDefault(require("lodash"));

var _usbDetection = _interopRequireDefault(require("usb-detection"));

var Usb = /*#__PURE__*/function () {
  function Usb() {
    var _this = this;

    (0, _classCallCheck2["default"])(this, Usb);
    (0, _defineProperty2["default"])(this, "mStartState", false);
    (0, _defineProperty2["default"])(this, "stringQuery", '');
    (0, _defineProperty2["default"])(this, "detection", /*#__PURE__*/function () {
      var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(Options, callback) {
        return _regenerator["default"].wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return _lodash["default"].merge({
                  state: Usb.ADDED_EVENT,
                  Ids: {
                    idVendor: undefined,
                    idProduct: undefined
                  }
                }, Options);

              case 2:
                _this.options = _context4.sent;

                if (!_this.mStartState) {
                  _context4.next = 6;
                  break;
                }

                _context4.next = 6;
                return _usbDetection["default"].startMonitoring();

              case 6:
                _context4.t0 = _this.options.state;
                _context4.next = _context4.t0 === Usb.ADDED_EVENT ? 9 : _context4.t0 === Usb.CHANGE_EVENT ? 16 : _context4.t0 === Usb.REMOVE_EVENT ? 23 : 30;
                break;

              case 9:
                _this.stringQuery = "";

                _this.stringQuery.concat("add");

                if (_this.options.Ids.idProduct !== undefined) {
                  _this.stringQuery.concat(":".concat(_this.options.Ids.idProduct));
                }

                if (_this.options.Ids.idVendor !== undefined) {
                  _this.stringQuery.concat(":".concat(_this.options.Ids.idVendor));
                }

                _context4.next = 15;
                return _usbDetection["default"].on(_this.stringQuery, /*#__PURE__*/function () {
                  var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(device) {
                    return _regenerator["default"].wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            callback(device);

                          case 1:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee);
                  }));

                  return function (_x3) {
                    return _ref2.apply(this, arguments);
                  };
                }());

              case 15:
                return _context4.abrupt("break", 30);

              case 16:
                _this.stringQuery = "";

                _this.stringQuery.concat("change");

                if (_this.options.Ids.idProduct !== undefined) {
                  _this.stringQuery.concat(":".concat(_this.options.Ids.idProduct));
                }

                if (_this.options.Ids.idVendor !== undefined) {
                  _this.stringQuery.concat(":".concat(_this.options.Ids.idVendor));
                }

                _context4.next = 22;
                return _usbDetection["default"].on(_this.stringQuery, /*#__PURE__*/function () {
                  var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(device) {
                    return _regenerator["default"].wrap(function _callee2$(_context2) {
                      while (1) {
                        switch (_context2.prev = _context2.next) {
                          case 0:
                            callback(device);

                          case 1:
                          case "end":
                            return _context2.stop();
                        }
                      }
                    }, _callee2);
                  }));

                  return function (_x4) {
                    return _ref3.apply(this, arguments);
                  };
                }());

              case 22:
                return _context4.abrupt("break", 30);

              case 23:
                _this.stringQuery = "";

                _this.stringQuery.concat("remove");

                if (_this.options.Ids.idProduct !== undefined) {
                  _this.stringQuery.concat(":".concat(_this.options.Ids.idProduct));
                }

                if (_this.options.Ids.idVendor !== undefined) {
                  _this.stringQuery.concat(":".concat(_this.options.Ids.idVendor));
                }

                _context4.next = 29;
                return _usbDetection["default"].on(_this.stringQuery, /*#__PURE__*/function () {
                  var _ref4 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(device) {
                    return _regenerator["default"].wrap(function _callee3$(_context3) {
                      while (1) {
                        switch (_context3.prev = _context3.next) {
                          case 0:
                            callback(device);

                          case 1:
                          case "end":
                            return _context3.stop();
                        }
                      }
                    }, _callee3);
                  }));

                  return function (_x5) {
                    return _ref4.apply(this, arguments);
                  };
                }());

              case 29:
                return _context4.abrupt("break", 30);

              case 30:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4);
      }));

      return function (_x, _x2) {
        return _ref.apply(this, arguments);
      };
    }());
  }

  (0, _createClass2["default"])(Usb, null, [{
    key: "ADDED_EVENT",
    get: function get() {
      return 1;
    }
  }, {
    key: "REMOVE_EVENT",
    get: function get() {
      return 2;
    }
  }, {
    key: "CHANGE_EVENT",
    get: function get() {
      return 3;
    }
  }]);
  return Usb;
}();
//# sourceMappingURL=index.js.map