"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _lodash = _interopRequireDefault(require("lodash"));

var _path = _interopRequireDefault(require("path"));

var _fs = _interopRequireDefault(require("fs"));

var _ftp = _interopRequireDefault(require("ftp"));

var FTP = /*#__PURE__*/function () {
  /**
   *
   * @param {Object} config
   * @param {String} config.host
   * @param {String} config.user
   * @param {Number} config.port
   * @param {String} config.password
   * @param {'basic'} config.logging
   */
  function FTP(config) {
    var _this = this;

    (0, _classCallCheck2["default"])(this, FTP);
    (0, _defineProperty2["default"])(this, "mBuffer", []);
    (0, _defineProperty2["default"])(this, "upload", /*#__PURE__*/function () {
      var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(files) {
        var destination,
            mFinalDestionation,
            _args4 = arguments;
        return _regenerator["default"].wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                destination = _args4.length > 1 && _args4[1] !== undefined ? _args4[1] : null;
                mFinalDestionation = null;
                _context4.next = 4;
                return new Promise( /*#__PURE__*/function () {
                  var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(resolve, reject) {
                    var getInformationPath, checkRootFilesInput;
                    return _regenerator["default"].wrap(function _callee3$(_context3) {
                      while (1) {
                        switch (_context3.prev = _context3.next) {
                          case 0:
                            getInformationPath = _path["default"].parse(files);
                            checkRootFilesInput = getInformationPath.root === '' ? _path["default"].join(require.main.filename, "./../".concat(files)) : files;

                            if (!_fs["default"].existsSync(checkRootFilesInput)) {
                              _context3.next = 9;
                              break;
                            }

                            mFinalDestionation = destination !== null ? destination : "".concat(getInformationPath.name).concat(getInformationPath.ext);
                            _context3.next = 6;
                            return _this.FtpInterface.on('ready', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
                              return _regenerator["default"].wrap(function _callee2$(_context2) {
                                while (1) {
                                  switch (_context2.prev = _context2.next) {
                                    case 0:
                                      _context2.next = 2;
                                      return _this.FtpInterface.put(checkRootFilesInput, mFinalDestionation, _this.config.compressed, /*#__PURE__*/function () {
                                        var _ref4 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(err) {
                                          return _regenerator["default"].wrap(function _callee$(_context) {
                                            while (1) {
                                              switch (_context.prev = _context.next) {
                                                case 0:
                                                  if (err) {
                                                    _context.next = 7;
                                                    break;
                                                  }

                                                  _context.next = 3;
                                                  return resolve({
                                                    status: true,
                                                    msg: "success for upload files",
                                                    metadata: getInformationPath
                                                  });

                                                case 3:
                                                  _context.next = 5;
                                                  return _this.FtpInterface.end();

                                                case 5:
                                                  _context.next = 11;
                                                  break;

                                                case 7:
                                                  _context.next = 9;
                                                  return reject({
                                                    status: false,
                                                    msg: "Error to Upload File",
                                                    error: err
                                                  });

                                                case 9:
                                                  _context.next = 11;
                                                  return _this.FtpInterface.end();

                                                case 11:
                                                case "end":
                                                  return _context.stop();
                                              }
                                            }
                                          }, _callee);
                                        }));

                                        return function (_x4) {
                                          return _ref4.apply(this, arguments);
                                        };
                                      }());

                                    case 2:
                                    case "end":
                                      return _context2.stop();
                                  }
                                }
                              }, _callee2);
                            })));

                          case 6:
                            _this.FtpInterface.connect(_this.config);

                            _context3.next = 10;
                            break;

                          case 9:
                            reject({
                              status: false,
                              msg: "File Upload Not Exist",
                              metadata: getInformationPath
                            });

                          case 10:
                          case "end":
                            return _context3.stop();
                        }
                      }
                    }, _callee3);
                  }));

                  return function (_x2, _x3) {
                    return _ref2.apply(this, arguments);
                  };
                }());

              case 4:
                return _context4.abrupt("return", _context4.sent);

              case 5:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "download", /*#__PURE__*/function () {
      var _ref5 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee11(files) {
        var options,
            mOptions,
            _args11 = arguments;
        return _regenerator["default"].wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                options = _args11.length > 1 && _args11[1] !== undefined ? _args11[1] : {};
                mOptions = _lodash["default"].merge({
                  saveFile: true,
                  convertToBase64: false,
                  withProgress: false,
                  targetDir: _path["default"].join(require.main.filename, "./../")
                }, options);
                return _context11.abrupt("return", new Promise( /*#__PURE__*/function () {
                  var _ref6 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee10(resolve, rejected) {
                    return _regenerator["default"].wrap(function _callee10$(_context10) {
                      while (1) {
                        switch (_context10.prev = _context10.next) {
                          case 0:
                            _context10.next = 2;
                            return _this.FtpInterface.on("ready", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee9() {
                              return _regenerator["default"].wrap(function _callee9$(_context9) {
                                while (1) {
                                  switch (_context9.prev = _context9.next) {
                                    case 0:
                                      _context9.next = 2;
                                      return _this.FtpInterface.get(files, _this.config.compressed, /*#__PURE__*/function () {
                                        var _ref8 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee8(err, stream) {
                                          return _regenerator["default"].wrap(function _callee8$(_context8) {
                                            while (1) {
                                              switch (_context8.prev = _context8.next) {
                                                case 0:
                                                  if (err) {
                                                    _context8.next = 14;
                                                    break;
                                                  }

                                                  _this.returnValue = {
                                                    status: true,
                                                    msg: "successfully to get data",
                                                    data: {
                                                      saveDir: _path["default"].join(mOptions.targetDir, files)
                                                    }
                                                  };
                                                  _this.mBuffer = [];
                                                  _context8.next = 5;
                                                  return stream.on('data', /*#__PURE__*/function () {
                                                    var _ref9 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(data) {
                                                      return _regenerator["default"].wrap(function _callee5$(_context5) {
                                                        while (1) {
                                                          switch (_context5.prev = _context5.next) {
                                                            case 0:
                                                              _context5.next = 2;
                                                              return _this.mBuffer.push(data);

                                                            case 2:
                                                            case "end":
                                                              return _context5.stop();
                                                          }
                                                        }
                                                      }, _callee5);
                                                    }));

                                                    return function (_x10) {
                                                      return _ref9.apply(this, arguments);
                                                    };
                                                  }());

                                                case 5:
                                                  if (!mOptions.saveFile) {
                                                    _context8.next = 8;
                                                    break;
                                                  }

                                                  _context8.next = 8;
                                                  return stream.pipe(_fs["default"].createWriteStream(_path["default"].join(mOptions.targetDir, files)));

                                                case 8:
                                                  _context8.next = 10;
                                                  return stream.once("finish", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6() {
                                                    var mb;
                                                    return _regenerator["default"].wrap(function _callee6$(_context6) {
                                                      while (1) {
                                                        switch (_context6.prev = _context6.next) {
                                                          case 0:
                                                            if (!mOptions.convertToBase64) {
                                                              _context6.next = 8;
                                                              break;
                                                            }

                                                            mb = Buffer.concat(_this.mBuffer);
                                                            _context6.next = 4;
                                                            return mb.toString('base64');

                                                          case 4:
                                                            _this.returnValue.data.base64 = _context6.sent;
                                                            resolve(_this.returnValue);
                                                            _context6.next = 9;
                                                            break;

                                                          case 8:
                                                            resolve(_this.returnValue);

                                                          case 9:
                                                          case "end":
                                                            return _context6.stop();
                                                        }
                                                      }
                                                    }, _callee6);
                                                  })));

                                                case 10:
                                                  _context8.next = 12;
                                                  return stream.once('error', /*#__PURE__*/function () {
                                                    var _ref11 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7(err) {
                                                      return _regenerator["default"].wrap(function _callee7$(_context7) {
                                                        while (1) {
                                                          switch (_context7.prev = _context7.next) {
                                                            case 0:
                                                              rejected({
                                                                status: false,
                                                                msg: "error stream",
                                                                error: err
                                                              });

                                                            case 1:
                                                            case "end":
                                                              return _context7.stop();
                                                          }
                                                        }
                                                      }, _callee7);
                                                    }));

                                                    return function (_x11) {
                                                      return _ref11.apply(this, arguments);
                                                    };
                                                  }());

                                                case 12:
                                                  _context8.next = 15;
                                                  break;

                                                case 14:
                                                  rejected({
                                                    status: false,
                                                    msg: "Error for get files from ftp server",
                                                    error: err
                                                  });

                                                case 15:
                                                case "end":
                                                  return _context8.stop();
                                              }
                                            }
                                          }, _callee8);
                                        }));

                                        return function (_x8, _x9) {
                                          return _ref8.apply(this, arguments);
                                        };
                                      }());

                                    case 2:
                                    case "end":
                                      return _context9.stop();
                                  }
                                }
                              }, _callee9);
                            })));

                          case 2:
                            _this.FtpInterface.connect(_this.config);

                          case 3:
                          case "end":
                            return _context10.stop();
                        }
                      }
                    }, _callee10);
                  }));

                  return function (_x6, _x7) {
                    return _ref6.apply(this, arguments);
                  };
                }()));

              case 3:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee11);
      }));

      return function (_x5) {
        return _ref5.apply(this, arguments);
      };
    }());
    this.config = _lodash["default"].merge({
      engine: FTP.FTP_NATIVE,
      host: 'localhost',
      port: 22,
      user: 'anonymous',
      password: 'anonymous@',
      logging: "basic",
      compressed: false
    }, config);
    /*this.FtpInterface =  new ftp(this.config, {
        logging : this.config.logging
    })*/

    switch (this.config.engine) {
      case FTP.FTP_NATIVE:
        this.FtpInterface = new _ftp["default"]();
        break;

      default:
    }
  }

  (0, _createClass2["default"])(FTP, null, [{
    key: "FTP_NATIVE",
    get: function get() {
      return "FTP_NATIVE";
    }
  }]);
  return FTP;
}();

var _default = FTP;
exports["default"] = _default;
//# sourceMappingURL=index.js.map