"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var hookHandler = /*#__PURE__*/function () {
  var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee10(app, config) {
    return _regenerator["default"].wrap(function _callee10$(_context10) {
      while (1) {
        switch (_context10.prev = _context10.next) {
          case 0:
            _context10.next = 2;
            return app.addHook('onRequest', /*#__PURE__*/function () {
              var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(request, response) {
                var mHeader, packages, IP;
                return _regenerator["default"].wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        /** Set Variable data Config Header **/
                        mHeader = {};

                        if (_fs["default"].existsSync(_path["default"].join(__dirname, "./../../../../../package.json"))) {
                          packages = require(_path["default"].join(__dirname, "./../../../../../package.json"));
                          mHeader = {
                            FrameworkName: packages.name,
                            FrameworkVersion: packages.version,
                            FrameworkAuthor: packages.author
                          };
                        }
                        /** Header Key Configuration data For All get hook **/


                        _context.next = 4;
                        return Object.keys(mHeader).forEach(function (keys) {
                          response.header(keys, mHeader[keys]);
                        });

                      case 4:
                        _context.next = 6;
                        return Object.keys(mHeader).forEach(function (keys) {
                          request.headers[keys] = mHeader[keys];
                        });

                      case 6:
                        IP = request.ip;
                        _context.next = 9;
                        return config.settings.firewall.forEach(function (key) {
                          if (request.method === key.method && IP === key.ip_address && key.action === "DENY") {
                            response.code(401).send({
                              code: 401,
                              msg: "Not Authorization. Firewall Rules"
                            });
                          }
                        });

                      case 9:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));

              return function (_x3, _x4) {
                return _ref2.apply(this, arguments);
              };
            }());

          case 2:
            _context10.next = 4;
            return app.addHook('preParsing', /*#__PURE__*/function () {
              var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(request, response) {
                return _regenerator["default"].wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2);
              }));

              return function (_x5, _x6) {
                return _ref3.apply(this, arguments);
              };
            }());

          case 4:
            _context10.next = 6;
            return app.addHook('preValidation', /*#__PURE__*/function () {
              var _ref4 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(request, response) {
                return _regenerator["default"].wrap(function _callee3$(_context3) {
                  while (1) {
                    switch (_context3.prev = _context3.next) {
                      case 0:
                      case "end":
                        return _context3.stop();
                    }
                  }
                }, _callee3);
              }));

              return function (_x7, _x8) {
                return _ref4.apply(this, arguments);
              };
            }());

          case 6:
            _context10.next = 8;
            return app.addHook('preHandler', /*#__PURE__*/function () {
              var _ref5 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(request, response) {
                return _regenerator["default"].wrap(function _callee4$(_context4) {
                  while (1) {
                    switch (_context4.prev = _context4.next) {
                      case 0:
                      case "end":
                        return _context4.stop();
                    }
                  }
                }, _callee4);
              }));

              return function (_x9, _x10) {
                return _ref5.apply(this, arguments);
              };
            }());

          case 8:
            _context10.next = 10;
            return app.addHook('preSerialization', /*#__PURE__*/function () {
              var _ref6 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(request, response) {
                return _regenerator["default"].wrap(function _callee5$(_context5) {
                  while (1) {
                    switch (_context5.prev = _context5.next) {
                      case 0:
                      case "end":
                        return _context5.stop();
                    }
                  }
                }, _callee5);
              }));

              return function (_x11, _x12) {
                return _ref6.apply(this, arguments);
              };
            }());

          case 10:
            _context10.next = 12;
            return app.addHook('onError', /*#__PURE__*/function () {
              var _ref7 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6(request, response) {
                return _regenerator["default"].wrap(function _callee6$(_context6) {
                  while (1) {
                    switch (_context6.prev = _context6.next) {
                      case 0:
                      case "end":
                        return _context6.stop();
                    }
                  }
                }, _callee6);
              }));

              return function (_x13, _x14) {
                return _ref7.apply(this, arguments);
              };
            }());

          case 12:
            _context10.next = 14;
            return app.addHook('onSend', /*#__PURE__*/function () {
              var _ref8 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7(request, response) {
                var mHeader, packages;
                return _regenerator["default"].wrap(function _callee7$(_context7) {
                  while (1) {
                    switch (_context7.prev = _context7.next) {
                      case 0:
                        mHeader = {};

                        if (_fs["default"].existsSync(_path["default"].join(__dirname, "./../../../../../package.json"))) {
                          packages = require(_path["default"].join(__dirname, "./../../../../../package.json"));
                          mHeader = {
                            FrameworkName: packages.name,
                            FrameworkVersion: packages.version,
                            FrameworkAuthor: packages.author
                          };
                        }
                        /** Header Key Configuration data For All get hook **/


                        _context7.next = 4;
                        return Object.keys(mHeader).forEach(function (keys) {
                          response.header(keys, mHeader[keys]);
                        });

                      case 4:
                        _context7.next = 6;
                        return Object.keys(mHeader).forEach(function (keys) {
                          request.headers[keys] = mHeader[keys];
                        });

                      case 6:
                      case "end":
                        return _context7.stop();
                    }
                  }
                }, _callee7);
              }));

              return function (_x15, _x16) {
                return _ref8.apply(this, arguments);
              };
            }());

          case 14:
            _context10.next = 16;
            return app.addHook('onResponse', /*#__PURE__*/function () {
              var _ref9 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee8(request, response) {
                return _regenerator["default"].wrap(function _callee8$(_context8) {
                  while (1) {
                    switch (_context8.prev = _context8.next) {
                      case 0:
                      case "end":
                        return _context8.stop();
                    }
                  }
                }, _callee8);
              }));

              return function (_x17, _x18) {
                return _ref9.apply(this, arguments);
              };
            }());

          case 16:
            _context10.next = 18;
            return app.addHook('onTimeout', /*#__PURE__*/function () {
              var _ref10 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee9(request, response) {
                return _regenerator["default"].wrap(function _callee9$(_context9) {
                  while (1) {
                    switch (_context9.prev = _context9.next) {
                      case 0:
                      case "end":
                        return _context9.stop();
                    }
                  }
                }, _callee9);
              }));

              return function (_x19, _x20) {
                return _ref10.apply(this, arguments);
              };
            }());

          case 18:
            return _context10.abrupt("return", app);

          case 19:
          case "end":
            return _context10.stop();
        }
      }
    }, _callee10);
  }));

  return function hookHandler(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var _default = hookHandler;
exports["default"] = _default;
//# sourceMappingURL=hookHandler.js.map