"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _indexModuleD = _interopRequireDefault(require("../../index.module.d.js"));

var _fs = require("fs");

var _isElectron = _interopRequireDefault(require("is-electron"));

var _electronLog = _interopRequireDefault(require("electron-log"));

var _delay = _interopRequireDefault(require("delay"));

var _Options = _interopRequireDefault(require("./../../Options"));

/** Melakukan Setting Export Default Untuk File JS Ini **/
var _default = /*#__PURE__*/function () {
  var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee60(config) {
    var mSetting, checkModuleExist, ServerInstance, SocketIOInstance, ServerViewInstance, CorsInstance, RateLimitInstance, MultipartInstance, CookieInstance, CompressInstance, HelmetInstance, LoggingInstance, GracefulShutdownInstance, JWTInstance, FormBodyInstance, AssetDirInstance, UploadDirInstance, mAppEngine;
    return _regenerator["default"].wrap(function _callee60$(_context60) {
      while (1) {
        switch (_context60.prev = _context60.next) {
          case 0:
            checkModuleExist = function _checkModuleExist(name) {
              try {
                require.resolve(name);

                return true;
              } catch (e) {
                return false;
              }
            };

            mSetting = {};
            /**
             * Melakukan Pengecekan Apakah Server Mode DEVELOPMENT ATAU PRODUCTION
             * Jika True, Maka Server Menampilkan Log System, Jika Tidak Mematikan Mode Logger
             *
             */

            _context60.next = 4;
            return new Promise( /*#__PURE__*/function () {
              var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(resolve, rejected) {
                var AppEngine, _AppEngine;

                return _regenerator["default"].wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _context.t0 = config.serverState;
                        _context.next = _context.t0 === _Options["default"].SERVER_STATE_DEVELOPMENT ? 3 : _context.t0 === _Options["default"].SERVER_STATE_PRODUCTION ? 34 : 66;
                        break;

                      case 3:
                        mSetting = {
                          logger: {
                            level: 'warn'
                          },
                          connectionTimeout: 180000,
                          pluginTimeout: 20000,
                          trustProxy: true
                        };

                        if (config.http2) {
                          mSetting.http2 = true;
                        }

                        if (config.secure !== false) {
                          mSetting.https = config.secure;
                        }

                        if (!checkModuleExist("fastify")) {
                          _context.next = 31;
                          break;
                        }

                        _context.next = 9;
                        return (0, _isElectron["default"])();

                      case 9:
                        if (!_context.sent) {
                          _context.next = 13;
                          break;
                        }

                        _electronLog["default"].info({
                          state: _Options["default"].LOADING_STATE,
                          descriptions: "require [Fastify] core engine Development"
                        });

                        _context.next = 14;
                        break;

                      case 13:
                        mProgressBar.increment({
                          state: _Options["default"].LOADING_STATE,
                          descriptions: "require [Fastify] core engine Development"
                        });

                      case 14:
                        _context.next = 16;
                        return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                      case 16:
                        _context.next = 18;
                        return require("fastify")(mSetting);

                      case 18:
                        AppEngine = _context.sent;
                        _context.next = 21;
                        return (0, _isElectron["default"])();

                      case 21:
                        if (!_context.sent) {
                          _context.next = 25;
                          break;
                        }

                        _electronLog["default"].info({
                          state: _Options["default"].LOADED_STATE,
                          descriptions: "require [Fastify] core engine Development"
                        });

                        _context.next = 26;
                        break;

                      case 25:
                        mProgressBar.increment({
                          state: _Options["default"].LOADED_STATE,
                          descriptions: "require [Fastify] core engine Development"
                        });

                      case 26:
                        _context.next = 28;
                        return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                      case 28:
                        resolve(AppEngine);
                        _context.next = 33;
                        break;

                      case 31:
                        _context.next = 33;
                        return rejected({
                          status: false,
                          code: 500,
                          msg: "Module Fastify Server Engine is Not Found"
                        });

                      case 33:
                        return _context.abrupt("break", 66);

                      case 34:
                        mSetting = {
                          logger: {
                            level: 'warn'
                          },
                          connectionTimeout: 180000,
                          trustProxy: true
                        };

                        if (config.http2) {
                          mSetting.http2 = true;
                        }

                        if (config.secure !== false) {
                          mSetting.https = config.secure;
                        }

                        if (!checkModuleExist("fastify")) {
                          _context.next = 63;
                          break;
                        }

                        _context.next = 40;
                        return (0, _isElectron["default"])();

                      case 40:
                        if (!_context.sent) {
                          _context.next = 44;
                          break;
                        }

                        _electronLog["default"].info({
                          state: _Options["default"].LOADING_STATE,
                          descriptions: "require [Fastify] core engine Development"
                        });

                        _context.next = 45;
                        break;

                      case 44:
                        mProgressBar.increment({
                          state: _Options["default"].LOADING_STATE,
                          descriptions: "require [Fastify] core engine Development"
                        });

                      case 45:
                        _context.next = 47;
                        return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                      case 47:
                        _context.next = 49;
                        return require("fastify")(mSetting);

                      case 49:
                        _AppEngine = _context.sent;
                        _context.next = 52;
                        return (0, _isElectron["default"])();

                      case 52:
                        if (!_context.sent) {
                          _context.next = 56;
                          break;
                        }

                        _electronLog["default"].info({
                          state: _Options["default"].LOADED_STATE,
                          descriptions: "require [Fastify] core engine Development"
                        });

                        _context.next = 57;
                        break;

                      case 56:
                        mProgressBar.increment({
                          state: _Options["default"].LOADED_STATE,
                          descriptions: "require [Fastify] core engine Development"
                        });

                      case 57:
                        _context.next = 59;
                        return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                      case 59:
                        d;
                        resolve(_AppEngine);
                        _context.next = 65;
                        break;

                      case 63:
                        _context.next = 65;
                        return rejected({
                          status: false,
                          code: 500,
                          msg: "Module Fastify Server Engine is Not Found"
                        });

                      case 65:
                        return _context.abrupt("break", 66);

                      case 66:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));

              return function (_x2, _x3) {
                return _ref2.apply(this, arguments);
              };
            }());

          case 4:
            ServerInstance = _context60.sent;

            SocketIOInstance = /*#__PURE__*/function () {
              var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(AppEngine) {
                return _regenerator["default"].wrap(function _callee3$(_context3) {
                  while (1) {
                    switch (_context3.prev = _context3.next) {
                      case 0:
                        _context3.next = 2;
                        return new Promise( /*#__PURE__*/function () {
                          var _ref4 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(resolve, rejected) {
                            var mAppEngine;
                            return _regenerator["default"].wrap(function _callee2$(_context2) {
                              while (1) {
                                switch (_context2.prev = _context2.next) {
                                  case 0:
                                    mAppEngine = null;

                                    if (!config.plugin.FastifySocketIO.enabled) {
                                      _context2.next = 41;
                                      break;
                                    }

                                    _context2.next = 4;
                                    return (0, _isElectron["default"])();

                                  case 4:
                                    if (!_context2.sent) {
                                      _context2.next = 8;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "socket.io plugin"
                                    });

                                    _context2.next = 9;
                                    break;

                                  case 8:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "socket.io plugin"
                                    });

                                  case 9:
                                    _context2.next = 11;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 11:
                                    if (!checkModuleExist('fastify-socket.io')) {
                                      _context2.next = 28;
                                      break;
                                    }

                                    _context2.next = 14;
                                    return AppEngine.register(require('fastify-socket.io'), config.plugin.FastifySocketIO.options);

                                  case 14:
                                    mAppEngine = _context2.sent;
                                    _context2.next = 17;
                                    return (0, _isElectron["default"])();

                                  case 17:
                                    if (!_context2.sent) {
                                      _context2.next = 21;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "socket.io plugin"
                                    });

                                    _context2.next = 22;
                                    break;

                                  case 21:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "socket.io plugin"
                                    });

                                  case 22:
                                    _context2.next = 24;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 24:
                                    _context2.next = 26;
                                    return resolve(mAppEngine);

                                  case 26:
                                    _context2.next = 39;
                                    break;

                                  case 28:
                                    _context2.next = 30;
                                    return (0, _isElectron["default"])();

                                  case 30:
                                    if (!_context2.sent) {
                                      _context2.next = 34;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "socket.io plugin Not Found"
                                    });

                                    _context2.next = 35;
                                    break;

                                  case 34:
                                    mProgressBar.increment({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "socket.io plugin Not Found"
                                    });

                                  case 35:
                                    _context2.next = 37;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 37:
                                    _context2.next = 39;
                                    return rejected({
                                      status: false,
                                      code: 500,
                                      msg: "socket.io enable but, plugin Not Found"
                                    });

                                  case 39:
                                    _context2.next = 43;
                                    break;

                                  case 41:
                                    _context2.next = 43;
                                    return resolve(AppEngine);

                                  case 43:
                                  case "end":
                                    return _context2.stop();
                                }
                              }
                            }, _callee2);
                          }));

                          return function (_x5, _x6) {
                            return _ref4.apply(this, arguments);
                          };
                        }());

                      case 2:
                        return _context3.abrupt("return", _context3.sent);

                      case 3:
                      case "end":
                        return _context3.stop();
                    }
                  }
                }, _callee3);
              }));

              return function SocketIOInstance(_x4) {
                return _ref3.apply(this, arguments);
              };
            }();

            ServerViewInstance = /*#__PURE__*/function () {
              var _ref5 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(AppEngine) {
                return _regenerator["default"].wrap(function _callee5$(_context5) {
                  while (1) {
                    switch (_context5.prev = _context5.next) {
                      case 0:
                        _context5.next = 2;
                        return new Promise( /*#__PURE__*/function () {
                          var _ref6 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(resolve, rejected) {
                            var mAppEngine;
                            return _regenerator["default"].wrap(function _callee4$(_context4) {
                              while (1) {
                                switch (_context4.prev = _context4.next) {
                                  case 0:
                                    mAppEngine = null;
                                    /** Mendaftarkan Module Tambahan Untuk Server Fastify **/

                                    _context4.t0 = config.serverView;
                                    _context4.next = 4;
                                    break;

                                  case 4:
                                    if (!(0, _fs.existsSync)(config.options.layoutDir)) {
                                      _context4.next = 44;
                                      break;
                                    }

                                    _context4.next = 7;
                                    return (0, _isElectron["default"])();

                                  case 7:
                                    if (!_context4.sent) {
                                      _context4.next = 11;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "view plugin"
                                    });

                                    _context4.next = 12;
                                    break;

                                  case 11:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "view plugin"
                                    });

                                  case 12:
                                    _context4.next = 14;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 14:
                                    if (!checkModuleExist('point-of-view')) {
                                      _context4.next = 31;
                                      break;
                                    }

                                    _context4.next = 17;
                                    return AppEngine.register(require('point-of-view'), {
                                      engine: {
                                        ejs: require('ejs')
                                      },
                                      root: config.options.layoutDir,

                                      /*viewExt: 'html'*/
                                      includeViewExtension: true
                                    });

                                  case 17:
                                    mAppEngine = _context4.sent;
                                    _context4.next = 20;
                                    return (0, _isElectron["default"])();

                                  case 20:
                                    if (!_context4.sent) {
                                      _context4.next = 24;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "view plugin"
                                    });

                                    _context4.next = 25;
                                    break;

                                  case 24:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "view plugin"
                                    });

                                  case 25:
                                    _context4.next = 27;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 27:
                                    _context4.next = 29;
                                    return resolve(mAppEngine);

                                  case 29:
                                    _context4.next = 42;
                                    break;

                                  case 31:
                                    _context4.next = 33;
                                    return (0, _isElectron["default"])();

                                  case 33:
                                    if (!_context4.sent) {
                                      _context4.next = 37;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].WARNING_STATE,
                                      descriptions: "view plugin Not Found"
                                    });

                                    _context4.next = 38;
                                    break;

                                  case 37:
                                    mProgressBar.increment({
                                      state: _Options["default"].WARNING_STATE,
                                      descriptions: "view plugin Not Found"
                                    });

                                  case 38:
                                    _context4.next = 40;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 40:
                                    _context4.next = 42;
                                    return rejected({
                                      status: true,
                                      code: 500,
                                      msg: "View Plugin Not Found"
                                    });

                                  case 42:
                                    _context4.next = 55;
                                    break;

                                  case 44:
                                    _context4.next = 46;
                                    return (0, _isElectron["default"])();

                                  case 46:
                                    if (!_context4.sent) {
                                      _context4.next = 50;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].WARNING_STATE,
                                      descriptions: "view plugin Disabled"
                                    });

                                    _context4.next = 51;
                                    break;

                                  case 50:
                                    mProgressBar.increment({
                                      state: _Options["default"].WARNING_STATE,
                                      descriptions: "view plugin Disabled"
                                    });

                                  case 51:
                                    _context4.next = 53;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 53:
                                    _context4.next = 55;
                                    return resolve(AppEngine);

                                  case 55:
                                  case "end":
                                    return _context4.stop();
                                }
                              }
                            }, _callee4);
                          }));

                          return function (_x8, _x9) {
                            return _ref6.apply(this, arguments);
                          };
                        }());

                      case 2:
                        return _context5.abrupt("return", _context5.sent);

                      case 3:
                      case "end":
                        return _context5.stop();
                    }
                  }
                }, _callee5);
              }));

              return function ServerViewInstance(_x7) {
                return _ref5.apply(this, arguments);
              };
            }();

            CorsInstance = /*#__PURE__*/function () {
              var _ref7 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7(AppEngine) {
                return _regenerator["default"].wrap(function _callee7$(_context7) {
                  while (1) {
                    switch (_context7.prev = _context7.next) {
                      case 0:
                        _context7.next = 2;
                        return new Promise( /*#__PURE__*/function () {
                          var _ref8 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6(resolve, rejected) {
                            var mAppEngine;
                            return _regenerator["default"].wrap(function _callee6$(_context6) {
                              while (1) {
                                switch (_context6.prev = _context6.next) {
                                  case 0:
                                    mAppEngine = null;

                                    if (!config.plugin.FastifyCors.enabled) {
                                      _context6.next = 41;
                                      break;
                                    }

                                    _context6.next = 4;
                                    return (0, _isElectron["default"])();

                                  case 4:
                                    if (!_context6.sent) {
                                      _context6.next = 8;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "cors plugin"
                                    });

                                    _context6.next = 9;
                                    break;

                                  case 8:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "cors plugin"
                                    });

                                  case 9:
                                    _context6.next = 11;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 11:
                                    if (!checkModuleExist("@fastify/cors")) {
                                      _context6.next = 28;
                                      break;
                                    }

                                    _context6.next = 14;
                                    return AppEngine.register(require("@fastify/cors"), config.plugin.FastifyCors.options);

                                  case 14:
                                    mAppEngine = _context6.sent;
                                    _context6.next = 17;
                                    return (0, _isElectron["default"])();

                                  case 17:
                                    if (!_context6.sent) {
                                      _context6.next = 21;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "cors plugin"
                                    });

                                    _context6.next = 22;
                                    break;

                                  case 21:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "cors plugin"
                                    });

                                  case 22:
                                    _context6.next = 24;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 24:
                                    _context6.next = 26;
                                    return resolve(mAppEngine);

                                  case 26:
                                    _context6.next = 39;
                                    break;

                                  case 28:
                                    _context6.next = 30;
                                    return (0, _isElectron["default"])();

                                  case 30:
                                    if (!_context6.sent) {
                                      _context6.next = 34;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "cors plugin Not Found"
                                    });

                                    _context6.next = 35;
                                    break;

                                  case 34:
                                    mProgressBar.increment({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "cors plugin Not Found"
                                    });

                                  case 35:
                                    _context6.next = 37;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 37:
                                    _context6.next = 39;
                                    return rejected({
                                      status: false,
                                      code: 500,
                                      msg: "Plugin Cors Not Found"
                                    });

                                  case 39:
                                    _context6.next = 43;
                                    break;

                                  case 41:
                                    _context6.next = 43;
                                    return resolve(AppEngine);

                                  case 43:
                                  case "end":
                                    return _context6.stop();
                                }
                              }
                            }, _callee6);
                          }));

                          return function (_x11, _x12) {
                            return _ref8.apply(this, arguments);
                          };
                        }());

                      case 2:
                        return _context7.abrupt("return", _context7.sent);

                      case 3:
                      case "end":
                        return _context7.stop();
                    }
                  }
                }, _callee7);
              }));

              return function CorsInstance(_x10) {
                return _ref7.apply(this, arguments);
              };
            }();

            RateLimitInstance = /*#__PURE__*/function () {
              var _ref9 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee9(AppEngine) {
                return _regenerator["default"].wrap(function _callee9$(_context9) {
                  while (1) {
                    switch (_context9.prev = _context9.next) {
                      case 0:
                        _context9.next = 2;
                        return new Promise( /*#__PURE__*/function () {
                          var _ref10 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee8(resolve, rejected) {
                            var mAppEngine;
                            return _regenerator["default"].wrap(function _callee8$(_context8) {
                              while (1) {
                                switch (_context8.prev = _context8.next) {
                                  case 0:
                                    mAppEngine = null;

                                    if (!config.plugin.FastifyRateLimit.enabled) {
                                      _context8.next = 41;
                                      break;
                                    }

                                    _context8.next = 4;
                                    return (0, _isElectron["default"])();

                                  case 4:
                                    if (!_context8.sent) {
                                      _context8.next = 8;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "rate limit plugin"
                                    });

                                    _context8.next = 9;
                                    break;

                                  case 8:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "rate limit plugin"
                                    });

                                  case 9:
                                    _context8.next = 11;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 11:
                                    if (!checkModuleExist("@fastify/rate-limit")) {
                                      _context8.next = 28;
                                      break;
                                    }

                                    _context8.next = 14;
                                    return AppEngine.register(require("@fastify/rate-limit"), {
                                      global: true,
                                      max: 1000,
                                      timeWindow: '1 minute'
                                    });

                                  case 14:
                                    mAppEngine = _context8.sent;
                                    _context8.next = 17;
                                    return (0, _isElectron["default"])();

                                  case 17:
                                    if (!_context8.sent) {
                                      _context8.next = 21;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "rate limit plugin"
                                    });

                                    _context8.next = 22;
                                    break;

                                  case 21:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "rate limit plugin"
                                    });

                                  case 22:
                                    _context8.next = 24;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 24:
                                    _context8.next = 26;
                                    return resolve(mAppEngine);

                                  case 26:
                                    _context8.next = 39;
                                    break;

                                  case 28:
                                    _context8.next = 30;
                                    return (0, _isElectron["default"])();

                                  case 30:
                                    if (!_context8.sent) {
                                      _context8.next = 34;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "rate limit plugin Not Found"
                                    });

                                    _context8.next = 35;
                                    break;

                                  case 34:
                                    mProgressBar.increment({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "rate limit plugin Not Found"
                                    });

                                  case 35:
                                    _context8.next = 37;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 37:
                                    _context8.next = 39;
                                    return rejected({
                                      status: false,
                                      code: 500,
                                      msg: "Plugin Rate Limit Plugin Not Exist"
                                    });

                                  case 39:
                                    _context8.next = 43;
                                    break;

                                  case 41:
                                    _context8.next = 43;
                                    return resolve(AppEngine);

                                  case 43:
                                  case "end":
                                    return _context8.stop();
                                }
                              }
                            }, _callee8);
                          }));

                          return function (_x14, _x15) {
                            return _ref10.apply(this, arguments);
                          };
                        }());

                      case 2:
                        return _context9.abrupt("return", _context9.sent);

                      case 3:
                      case "end":
                        return _context9.stop();
                    }
                  }
                }, _callee9);
              }));

              return function RateLimitInstance(_x13) {
                return _ref9.apply(this, arguments);
              };
            }();

            MultipartInstance = /*#__PURE__*/function () {
              var _ref11 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee11(AppEngine) {
                return _regenerator["default"].wrap(function _callee11$(_context11) {
                  while (1) {
                    switch (_context11.prev = _context11.next) {
                      case 0:
                        _context11.next = 2;
                        return new Promise( /*#__PURE__*/function () {
                          var _ref12 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee10(resolve, rejected) {
                            var mAppEngine;
                            return _regenerator["default"].wrap(function _callee10$(_context10) {
                              while (1) {
                                switch (_context10.prev = _context10.next) {
                                  case 0:
                                    mAppEngine = null;

                                    if (!config.plugin.FastifyMultipart.enabled) {
                                      _context10.next = 40;
                                      break;
                                    }

                                    _context10.next = 4;
                                    return (0, _isElectron["default"])();

                                  case 4:
                                    if (!_context10.sent) {
                                      _context10.next = 8;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "Multipart format plugin"
                                    });

                                    _context10.next = 9;
                                    break;

                                  case 8:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "Multipart format plugin"
                                    });

                                  case 9:
                                    _context10.next = 11;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 11:
                                    if (!checkModuleExist('@fastify/multipart')) {
                                      _context10.next = 27;
                                      break;
                                    }

                                    _context10.next = 14;
                                    return AppEngine.register(require('@fastify/multipart'), {
                                      attachFieldsToBody: true
                                    });

                                  case 14:
                                    mAppEngine = _context10.sent;
                                    _context10.next = 17;
                                    return (0, _isElectron["default"])();

                                  case 17:
                                    if (!_context10.sent) {
                                      _context10.next = 21;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "Multipart format plugin"
                                    });

                                    _context10.next = 22;
                                    break;

                                  case 21:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "Multipart format plugin"
                                    });

                                  case 22:
                                    _context10.next = 24;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 24:
                                    resolve(mAppEngine);
                                    _context10.next = 38;
                                    break;

                                  case 27:
                                    _context10.next = 29;
                                    return (0, _isElectron["default"])();

                                  case 29:
                                    if (!_context10.sent) {
                                      _context10.next = 33;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "Multipart format plugin"
                                    });

                                    _context10.next = 34;
                                    break;

                                  case 33:
                                    mProgressBar.increment({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "Multipart format plugin"
                                    });

                                  case 34:
                                    _context10.next = 36;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 36:
                                    _context10.next = 38;
                                    return rejected({
                                      status: false,
                                      code: 500,
                                      msg: "Plugin Multipart format Not Exist"
                                    });

                                  case 38:
                                    _context10.next = 42;
                                    break;

                                  case 40:
                                    _context10.next = 42;
                                    return resolve(AppEngine);

                                  case 42:
                                  case "end":
                                    return _context10.stop();
                                }
                              }
                            }, _callee10);
                          }));

                          return function (_x17, _x18) {
                            return _ref12.apply(this, arguments);
                          };
                        }());

                      case 2:
                        return _context11.abrupt("return", _context11.sent);

                      case 3:
                      case "end":
                        return _context11.stop();
                    }
                  }
                }, _callee11);
              }));

              return function MultipartInstance(_x16) {
                return _ref11.apply(this, arguments);
              };
            }();

            CookieInstance = /*#__PURE__*/function () {
              var _ref13 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee13(AppEngine) {
                return _regenerator["default"].wrap(function _callee13$(_context13) {
                  while (1) {
                    switch (_context13.prev = _context13.next) {
                      case 0:
                        _context13.next = 2;
                        return new Promise( /*#__PURE__*/function () {
                          var _ref14 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee12(resolve, rejected) {
                            var mAppEngine;
                            return _regenerator["default"].wrap(function _callee12$(_context12) {
                              while (1) {
                                switch (_context12.prev = _context12.next) {
                                  case 0:
                                    mAppEngine = null;

                                    if (!config.plugin.FastifyCookie.enabled) {
                                      _context12.next = 41;
                                      break;
                                    }

                                    _context12.next = 4;
                                    return (0, _isElectron["default"])();

                                  case 4:
                                    if (!_context12.sent) {
                                      _context12.next = 8;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "Cookie plugin"
                                    });

                                    _context12.next = 9;
                                    break;

                                  case 8:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "Cookie plugin"
                                    });

                                  case 9:
                                    _context12.next = 11;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 11:
                                    if (!checkModuleExist('fastify-cookie')) {
                                      _context12.next = 28;
                                      break;
                                    }

                                    _context12.next = 14;
                                    return AppEngine.register(require('fastify-cookie'), {
                                      secret: config.settings.secretKey,
                                      path: "/"
                                    });

                                  case 14:
                                    mAppEngine = _context12.sent;
                                    _context12.next = 17;
                                    return (0, _isElectron["default"])();

                                  case 17:
                                    if (!_context12.sent) {
                                      _context12.next = 21;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "Cookie plugin"
                                    });

                                    _context12.next = 22;
                                    break;

                                  case 21:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "Cookie plugin"
                                    });

                                  case 22:
                                    _context12.next = 24;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 24:
                                    _context12.next = 26;
                                    return resolve(mAppEngine);

                                  case 26:
                                    _context12.next = 39;
                                    break;

                                  case 28:
                                    _context12.next = 30;
                                    return (0, _isElectron["default"])();

                                  case 30:
                                    if (!_context12.sent) {
                                      _context12.next = 34;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "Cookie plugin Not Found"
                                    });

                                    _context12.next = 35;
                                    break;

                                  case 34:
                                    mProgressBar.increment({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "Cookie plugin Not Found"
                                    });

                                  case 35:
                                    _context12.next = 37;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 37:
                                    _context12.next = 39;
                                    return rejected({
                                      status: false,
                                      code: 500,
                                      msg: "Cookie Plugin enabled, But Module Not Found"
                                    });

                                  case 39:
                                    _context12.next = 42;
                                    break;

                                  case 41:
                                    resolve(AppEngine);

                                  case 42:
                                  case "end":
                                    return _context12.stop();
                                }
                              }
                            }, _callee12);
                          }));

                          return function (_x20, _x21) {
                            return _ref14.apply(this, arguments);
                          };
                        }());

                      case 2:
                        return _context13.abrupt("return", _context13.sent);

                      case 3:
                      case "end":
                        return _context13.stop();
                    }
                  }
                }, _callee13);
              }));

              return function CookieInstance(_x19) {
                return _ref13.apply(this, arguments);
              };
            }();

            CompressInstance = /*#__PURE__*/function () {
              var _ref15 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee15(AppEngine) {
                return _regenerator["default"].wrap(function _callee15$(_context15) {
                  while (1) {
                    switch (_context15.prev = _context15.next) {
                      case 0:
                        _context15.next = 2;
                        return new Promise( /*#__PURE__*/function () {
                          var _ref16 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee14(resolve, rejected) {
                            var mAppEngine;
                            return _regenerator["default"].wrap(function _callee14$(_context14) {
                              while (1) {
                                switch (_context14.prev = _context14.next) {
                                  case 0:
                                    mAppEngine = null;

                                    if (!config.plugin.FastifyCompress.enabled) {
                                      _context14.next = 40;
                                      break;
                                    }

                                    _context14.next = 4;
                                    return (0, _isElectron["default"])();

                                  case 4:
                                    if (!_context14.sent) {
                                      _context14.next = 8;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "Compressing plugin"
                                    });

                                    _context14.next = 9;
                                    break;

                                  case 8:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "Compressing plugin"
                                    });

                                  case 9:
                                    _context14.next = 11;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 11:
                                    if (!checkModuleExist('fastify-compress')) {
                                      _context14.next = 28;
                                      break;
                                    }

                                    _context14.next = 14;
                                    return AppEngine.register(require('fastify-compress'), config.plugin.FastifyCompress.options);

                                  case 14:
                                    mAppEngine = _context14.sent;
                                    _context14.next = 17;
                                    return (0, _isElectron["default"])();

                                  case 17:
                                    if (!_context14.sent) {
                                      _context14.next = 21;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "Compressing plugin"
                                    });

                                    _context14.next = 22;
                                    break;

                                  case 21:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "Compressing plugin"
                                    });

                                  case 22:
                                    _context14.next = 24;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 24:
                                    _context14.next = 26;
                                    return resolve(mAppEngine);

                                  case 26:
                                    _context14.next = 38;
                                    break;

                                  case 28:
                                    _context14.next = 30;
                                    return (0, _isElectron["default"])();

                                  case 30:
                                    if (!_context14.sent) {
                                      _context14.next = 34;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "Compressing plugin Not Found"
                                    });

                                    _context14.next = 35;
                                    break;

                                  case 34:
                                    mProgressBar.increment({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "Compressing plugin Not Found"
                                    });

                                  case 35:
                                    _context14.next = 37;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 37:
                                    rejected({
                                      status: true,
                                      code: 500,
                                      msg: "Compressing Plugin Enabled But Not Found"
                                    });

                                  case 38:
                                    _context14.next = 42;
                                    break;

                                  case 40:
                                    _context14.next = 42;
                                    return resolve(AppEngine);

                                  case 42:
                                  case "end":
                                    return _context14.stop();
                                }
                              }
                            }, _callee14);
                          }));

                          return function (_x23, _x24) {
                            return _ref16.apply(this, arguments);
                          };
                        }());

                      case 2:
                        return _context15.abrupt("return", _context15.sent);

                      case 3:
                      case "end":
                        return _context15.stop();
                    }
                  }
                }, _callee15);
              }));

              return function CompressInstance(_x22) {
                return _ref15.apply(this, arguments);
              };
            }();

            HelmetInstance = /*#__PURE__*/function () {
              var _ref17 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee17(AppEngine) {
                return _regenerator["default"].wrap(function _callee17$(_context17) {
                  while (1) {
                    switch (_context17.prev = _context17.next) {
                      case 0:
                        _context17.next = 2;
                        return new Promise( /*#__PURE__*/function () {
                          var _ref18 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee16(resolve, rejected) {
                            var mAppEngine;
                            return _regenerator["default"].wrap(function _callee16$(_context16) {
                              while (1) {
                                switch (_context16.prev = _context16.next) {
                                  case 0:
                                    mAppEngine = null;

                                    if (!config.plugin.FastifyHelmet.enabled) {
                                      _context16.next = 41;
                                      break;
                                    }

                                    _context16.next = 4;
                                    return (0, _isElectron["default"])();

                                  case 4:
                                    if (!_context16.sent) {
                                      _context16.next = 8;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "Helmet plugin"
                                    });

                                    _context16.next = 9;
                                    break;

                                  case 8:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "Helmet plugin"
                                    });

                                  case 9:
                                    _context16.next = 11;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 11:
                                    if (!checkModuleExist("@fastify/helmet")) {
                                      _context16.next = 28;
                                      break;
                                    }

                                    _context16.next = 14;
                                    return AppEngine.register(require('@fastify/helmet'), config.plugin.FastifyHelmet.options);

                                  case 14:
                                    mAppEngine = _context16.sent;
                                    _context16.next = 17;
                                    return (0, _isElectron["default"])();

                                  case 17:
                                    if (!_context16.sent) {
                                      _context16.next = 21;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "Helmet plugin"
                                    });

                                    _context16.next = 22;
                                    break;

                                  case 21:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "Helmet plugin"
                                    });

                                  case 22:
                                    _context16.next = 24;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 24:
                                    _context16.next = 26;
                                    return resolve(mAppEngine);

                                  case 26:
                                    _context16.next = 39;
                                    break;

                                  case 28:
                                    _context16.next = 30;
                                    return (0, _isElectron["default"])();

                                  case 30:
                                    if (!_context16.sent) {
                                      _context16.next = 34;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "Helmet plugin Not Found"
                                    });

                                    _context16.next = 35;
                                    break;

                                  case 34:
                                    mProgressBar.increment({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "Helmet plugin Not Found"
                                    });

                                  case 35:
                                    _context16.next = 37;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 37:
                                    _context16.next = 39;
                                    return rejected({
                                      status: false,
                                      code: 500,
                                      msg: "Helmet Plugin Is Enabled But Not Found"
                                    });

                                  case 39:
                                    _context16.next = 43;
                                    break;

                                  case 41:
                                    _context16.next = 43;
                                    return resolve(AppEngine);

                                  case 43:
                                  case "end":
                                    return _context16.stop();
                                }
                              }
                            }, _callee16);
                          }));

                          return function (_x26, _x27) {
                            return _ref18.apply(this, arguments);
                          };
                        }());

                      case 2:
                        return _context17.abrupt("return", _context17.sent);

                      case 3:
                      case "end":
                        return _context17.stop();
                    }
                  }
                }, _callee17);
              }));

              return function HelmetInstance(_x25) {
                return _ref17.apply(this, arguments);
              };
            }();

            LoggingInstance = /*#__PURE__*/function () {
              var _ref19 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee19(AppEngine) {
                return _regenerator["default"].wrap(function _callee19$(_context19) {
                  while (1) {
                    switch (_context19.prev = _context19.next) {
                      case 0:
                        _context19.next = 2;
                        return new Promise( /*#__PURE__*/function () {
                          var _ref20 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee18(resolve, rejected) {
                            var mAppEngine;
                            return _regenerator["default"].wrap(function _callee18$(_context18) {
                              while (1) {
                                switch (_context18.prev = _context18.next) {
                                  case 0:
                                    mAppEngine = null;

                                    if (!config.plugin.FastifyLog.enabled) {
                                      _context18.next = 41;
                                      break;
                                    }

                                    _context18.next = 4;
                                    return (0, _isElectron["default"])();

                                  case 4:
                                    if (!_context18.sent) {
                                      _context18.next = 8;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "Logging plugin"
                                    });

                                    _context18.next = 9;
                                    break;

                                  case 8:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "Logging plugin"
                                    });

                                  case 9:
                                    _context18.next = 11;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 11:
                                    if (!checkModuleExist('fastify-log')) {
                                      _context18.next = 28;
                                      break;
                                    }

                                    _context18.next = 14;
                                    return AppEngine.register(require('fastify-log'), config.plugin.FastifyLog.options);

                                  case 14:
                                    mAppEngine = _context18.sent;
                                    _context18.next = 17;
                                    return (0, _isElectron["default"])();

                                  case 17:
                                    if (!_context18.sent) {
                                      _context18.next = 21;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "Logging plugin"
                                    });

                                    _context18.next = 22;
                                    break;

                                  case 21:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "Logging plugin"
                                    });

                                  case 22:
                                    _context18.next = 24;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 24:
                                    _context18.next = 26;
                                    return resolve(mAppEngine);

                                  case 26:
                                    _context18.next = 39;
                                    break;

                                  case 28:
                                    _context18.next = 30;
                                    return (0, _isElectron["default"])();

                                  case 30:
                                    if (!_context18.sent) {
                                      _context18.next = 34;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "Logging plugin Not Found"
                                    });

                                    _context18.next = 35;
                                    break;

                                  case 34:
                                    mProgressBar.increment({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "Logging plugin Not Found"
                                    });

                                  case 35:
                                    _context18.next = 37;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 37:
                                    _context18.next = 39;
                                    return rejected({
                                      status: false,
                                      code: 500,
                                      msg: "Logging Plugin Is Enabled But Not Found"
                                    });

                                  case 39:
                                    _context18.next = 43;
                                    break;

                                  case 41:
                                    _context18.next = 43;
                                    return resolve(AppEngine);

                                  case 43:
                                  case "end":
                                    return _context18.stop();
                                }
                              }
                            }, _callee18);
                          }));

                          return function (_x29, _x30) {
                            return _ref20.apply(this, arguments);
                          };
                        }());

                      case 2:
                        return _context19.abrupt("return", _context19.sent);

                      case 3:
                      case "end":
                        return _context19.stop();
                    }
                  }
                }, _callee19);
              }));

              return function LoggingInstance(_x28) {
                return _ref19.apply(this, arguments);
              };
            }();

            GracefulShutdownInstance = /*#__PURE__*/function () {
              var _ref21 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee21(AppEngine) {
                return _regenerator["default"].wrap(function _callee21$(_context21) {
                  while (1) {
                    switch (_context21.prev = _context21.next) {
                      case 0:
                        _context21.next = 2;
                        return new Promise( /*#__PURE__*/function () {
                          var _ref22 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee20(resolve, rejected) {
                            var mAppEngine;
                            return _regenerator["default"].wrap(function _callee20$(_context20) {
                              while (1) {
                                switch (_context20.prev = _context20.next) {
                                  case 0:
                                    mAppEngine = null;

                                    if (!config.plugin.FastifyGracefulShutdown.enabled) {
                                      _context20.next = 41;
                                      break;
                                    }

                                    _context20.next = 4;
                                    return (0, _isElectron["default"])();

                                  case 4:
                                    if (!_context20.sent) {
                                      _context20.next = 8;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "Shutdown plugin"
                                    });

                                    _context20.next = 9;
                                    break;

                                  case 8:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "Shutdown plugin"
                                    });

                                  case 9:
                                    _context20.next = 11;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 11:
                                    if (!checkModuleExist('fastify-graceful-shutdown')) {
                                      _context20.next = 28;
                                      break;
                                    }

                                    _context20.next = 14;
                                    return AppEngine.register(require('fastify-graceful-shutdown'));

                                  case 14:
                                    mAppEngine = _context20.sent;
                                    _context20.next = 17;
                                    return (0, _isElectron["default"])();

                                  case 17:
                                    if (!_context20.sent) {
                                      _context20.next = 21;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "Shutdown plugin"
                                    });

                                    _context20.next = 22;
                                    break;

                                  case 21:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "Shutdown plugin"
                                    });

                                  case 22:
                                    _context20.next = 24;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 24:
                                    _context20.next = 26;
                                    return resolve(mAppEngine);

                                  case 26:
                                    _context20.next = 39;
                                    break;

                                  case 28:
                                    _context20.next = 30;
                                    return (0, _isElectron["default"])();

                                  case 30:
                                    if (!_context20.sent) {
                                      _context20.next = 34;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "Shutdown plugin Module Not Found"
                                    });

                                    _context20.next = 35;
                                    break;

                                  case 34:
                                    mProgressBar.increment({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "Shutdown plugin Module Not Found"
                                    });

                                  case 35:
                                    _context20.next = 37;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 37:
                                    _context20.next = 39;
                                    return rejected({
                                      status: false,
                                      code: 500,
                                      msg: "Shutdown Plugin Is Enabled But Not Found"
                                    });

                                  case 39:
                                    _context20.next = 43;
                                    break;

                                  case 41:
                                    _context20.next = 43;
                                    return resolve(AppEngine);

                                  case 43:
                                  case "end":
                                    return _context20.stop();
                                }
                              }
                            }, _callee20);
                          }));

                          return function (_x32, _x33) {
                            return _ref22.apply(this, arguments);
                          };
                        }());

                      case 2:
                        return _context21.abrupt("return", _context21.sent);

                      case 3:
                      case "end":
                        return _context21.stop();
                    }
                  }
                }, _callee21);
              }));

              return function GracefulShutdownInstance(_x31) {
                return _ref21.apply(this, arguments);
              };
            }();

            JWTInstance = /*#__PURE__*/function () {
              var _ref23 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee23(AppEngine) {
                return _regenerator["default"].wrap(function _callee23$(_context23) {
                  while (1) {
                    switch (_context23.prev = _context23.next) {
                      case 0:
                        _context23.next = 2;
                        return new Promise( /*#__PURE__*/function () {
                          var _ref24 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee22(resolve, rejected) {
                            var mAppEngine;
                            return _regenerator["default"].wrap(function _callee22$(_context22) {
                              while (1) {
                                switch (_context22.prev = _context22.next) {
                                  case 0:
                                    mAppEngine = null;

                                    if (!config.plugin.FastifyJwt.enabled) {
                                      _context22.next = 41;
                                      break;
                                    }

                                    _context22.next = 4;
                                    return (0, _isElectron["default"])();

                                  case 4:
                                    if (!_context22.sent) {
                                      _context22.next = 8;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "JWT Tokens plugin"
                                    });

                                    _context22.next = 9;
                                    break;

                                  case 8:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "JWT Tokens plugin"
                                    });

                                  case 9:
                                    _context22.next = 11;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 11:
                                    if (!checkModuleExist("@fastify/jwt")) {
                                      _context22.next = 28;
                                      break;
                                    }

                                    _context22.next = 14;
                                    return AppEngine.register(require("@fastify/jwt"), {
                                      secret: _indexModuleD["default"].config.SecretConfig.EncryptSecret
                                    });

                                  case 14:
                                    mAppEngine = _context22.sent;
                                    _context22.next = 17;
                                    return (0, _isElectron["default"])();

                                  case 17:
                                    if (!_context22.sent) {
                                      _context22.next = 21;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "JWT Tokens plugin"
                                    });

                                    _context22.next = 22;
                                    break;

                                  case 21:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "JWT Tokens plugin"
                                    });

                                  case 22:
                                    _context22.next = 24;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 24:
                                    _context22.next = 26;
                                    return resolve({
                                      status: false,
                                      code: 500,
                                      msg: "JWT Plugin Enabled But Not Found"
                                    });

                                  case 26:
                                    _context22.next = 39;
                                    break;

                                  case 28:
                                    _context22.next = 30;
                                    return (0, _isElectron["default"])();

                                  case 30:
                                    if (!_context22.sent) {
                                      _context22.next = 34;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "JWT Tokens plugin Not Found"
                                    });

                                    _context22.next = 35;
                                    break;

                                  case 34:
                                    mProgressBar.increment({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "JWT Tokens plugin Not Found"
                                    });

                                  case 35:
                                    _context22.next = 37;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 37:
                                    _context22.next = 39;
                                    return rejected({
                                      status: false,
                                      code: 500,
                                      msg: "JTW Tokens Plugin Enabled But Not Found"
                                    });

                                  case 39:
                                    _context22.next = 43;
                                    break;

                                  case 41:
                                    _context22.next = 43;
                                    return resolve(AppEngine);

                                  case 43:
                                  case "end":
                                    return _context22.stop();
                                }
                              }
                            }, _callee22);
                          }));

                          return function (_x35, _x36) {
                            return _ref24.apply(this, arguments);
                          };
                        }());

                      case 2:
                        return _context23.abrupt("return", _context23.sent);

                      case 3:
                      case "end":
                        return _context23.stop();
                    }
                  }
                }, _callee23);
              }));

              return function JWTInstance(_x34) {
                return _ref23.apply(this, arguments);
              };
            }();

            FormBodyInstance = /*#__PURE__*/function () {
              var _ref25 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee25(AppEngine) {
                return _regenerator["default"].wrap(function _callee25$(_context25) {
                  while (1) {
                    switch (_context25.prev = _context25.next) {
                      case 0:
                        _context25.next = 2;
                        return new Promise( /*#__PURE__*/function () {
                          var _ref26 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee24(resolve, rejected) {
                            var mAppEngine;
                            return _regenerator["default"].wrap(function _callee24$(_context24) {
                              while (1) {
                                switch (_context24.prev = _context24.next) {
                                  case 0:
                                    mAppEngine = null;

                                    if (!config.plugin.FastifyFormBody.enabled) {
                                      _context24.next = 41;
                                      break;
                                    }

                                    _context24.next = 4;
                                    return (0, _isElectron["default"])();

                                  case 4:
                                    if (!_context24.sent) {
                                      _context24.next = 8;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "Form Body plugin"
                                    });

                                    _context24.next = 9;
                                    break;

                                  case 8:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "Form Body plugin"
                                    });

                                  case 9:
                                    _context24.next = 11;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 11:
                                    if (!checkModuleExist("@fastify/formbody")) {
                                      _context24.next = 28;
                                      break;
                                    }

                                    _context24.next = 14;
                                    return AppEngine.register(require("@fastify/formbody"));

                                  case 14:
                                    mAppEngine = _context24.sent;
                                    _context24.next = 17;
                                    return (0, _isElectron["default"])();

                                  case 17:
                                    if (!_context24.sent) {
                                      _context24.next = 21;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "Form Body plugin"
                                    });

                                    _context24.next = 22;
                                    break;

                                  case 21:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "Form Body plugin"
                                    });

                                  case 22:
                                    _context24.next = 24;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 24:
                                    _context24.next = 26;
                                    return resolve(mAppEngine);

                                  case 26:
                                    _context24.next = 39;
                                    break;

                                  case 28:
                                    _context24.next = 30;
                                    return (0, _isElectron["default"])();

                                  case 30:
                                    if (!_context24.sent) {
                                      _context24.next = 34;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "Form Body plugin Not Found"
                                    });

                                    _context24.next = 35;
                                    break;

                                  case 34:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "Form Body plugin Not Found"
                                    });

                                  case 35:
                                    _context24.next = 37;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 37:
                                    _context24.next = 39;
                                    return rejected({
                                      status: false,
                                      code: 500,
                                      msg: "Form Body Plugin Enabled But Not Found"
                                    });

                                  case 39:
                                    _context24.next = 43;
                                    break;

                                  case 41:
                                    _context24.next = 43;
                                    return resolve(AppEngine);

                                  case 43:
                                  case "end":
                                    return _context24.stop();
                                }
                              }
                            }, _callee24);
                          }));

                          return function (_x38, _x39) {
                            return _ref26.apply(this, arguments);
                          };
                        }());

                      case 2:
                        return _context25.abrupt("return", _context25.sent);

                      case 3:
                      case "end":
                        return _context25.stop();
                    }
                  }
                }, _callee25);
              }));

              return function FormBodyInstance(_x37) {
                return _ref25.apply(this, arguments);
              };
            }();

            AssetDirInstance = /*#__PURE__*/function () {
              var _ref27 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee27(AppEngine) {
                return _regenerator["default"].wrap(function _callee27$(_context27) {
                  while (1) {
                    switch (_context27.prev = _context27.next) {
                      case 0:
                        _context27.next = 2;
                        return new Promise( /*#__PURE__*/function () {
                          var _ref28 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee26(resolve, rejected) {
                            var mAppEngine;
                            return _regenerator["default"].wrap(function _callee26$(_context26) {
                              while (1) {
                                switch (_context26.prev = _context26.next) {
                                  case 0:
                                    mAppEngine = null;

                                    if (!(0, _fs.existsSync)(config.options.assetsDir)) {
                                      _context26.next = 41;
                                      break;
                                    }

                                    _context26.next = 4;
                                    return (0, _isElectron["default"])();

                                  case 4:
                                    if (!_context26.sent) {
                                      _context26.next = 8;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "Assets Dir Mounting"
                                    });

                                    _context26.next = 9;
                                    break;

                                  case 8:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "Assets Dir Mounting"
                                    });

                                  case 9:
                                    _context26.next = 11;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 11:
                                    if (!checkModuleExist("@fastify/static")) {
                                      _context26.next = 28;
                                      break;
                                    }

                                    _context26.next = 14;
                                    return AppEngine.register(require("@fastify/static"), {
                                      root: config.options.assetsDir,
                                      decorateReply: false
                                    });

                                  case 14:
                                    mAppEngine = _context26.sent;
                                    _context26.next = 17;
                                    return (0, _isElectron["default"])();

                                  case 17:
                                    if (!_context26.sent) {
                                      _context26.next = 21;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "Assets Dir Mounting"
                                    });

                                    _context26.next = 22;
                                    break;

                                  case 21:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "Assets Dir Mounting"
                                    });

                                  case 22:
                                    _context26.next = 24;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 24:
                                    _context26.next = 26;
                                    return resolve(mAppEngine);

                                  case 26:
                                    _context26.next = 39;
                                    break;

                                  case 28:
                                    _context26.next = 30;
                                    return (0, _isElectron["default"])();

                                  case 30:
                                    if (!_context26.sent) {
                                      _context26.next = 34;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "Assets Dir Mounting Not Found"
                                    });

                                    _context26.next = 35;
                                    break;

                                  case 34:
                                    mProgressBar.increment({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "Assets Dir Mounting Not Found"
                                    });

                                  case 35:
                                    _context26.next = 37;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 37:
                                    _context26.next = 39;
                                    return rejected({
                                      status: false,
                                      code: 500,
                                      msg: "Asset Dir Plugin Enable But Not Found"
                                    });

                                  case 39:
                                    _context26.next = 43;
                                    break;

                                  case 41:
                                    _context26.next = 43;
                                    return resolve(AppEngine);

                                  case 43:
                                  case "end":
                                    return _context26.stop();
                                }
                              }
                            }, _callee26);
                          }));

                          return function (_x41, _x42) {
                            return _ref28.apply(this, arguments);
                          };
                        }());

                      case 2:
                        return _context27.abrupt("return", _context27.sent);

                      case 3:
                      case "end":
                        return _context27.stop();
                    }
                  }
                }, _callee27);
              }));

              return function AssetDirInstance(_x40) {
                return _ref27.apply(this, arguments);
              };
            }();

            UploadDirInstance = /*#__PURE__*/function () {
              var _ref29 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee29(AppEngine) {
                return _regenerator["default"].wrap(function _callee29$(_context29) {
                  while (1) {
                    switch (_context29.prev = _context29.next) {
                      case 0:
                        _context29.next = 2;
                        return new Promise( /*#__PURE__*/function () {
                          var _ref30 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee28(resolve, rejected) {
                            var mAppEngine;
                            return _regenerator["default"].wrap(function _callee28$(_context28) {
                              while (1) {
                                switch (_context28.prev = _context28.next) {
                                  case 0:
                                    mAppEngine = null;

                                    if (!(0, _fs.existsSync)(config.options.uploadDir)) {
                                      _context28.next = 41;
                                      break;
                                    }

                                    _context28.next = 4;
                                    return (0, _isElectron["default"])();

                                  case 4:
                                    if (!_context28.sent) {
                                      _context28.next = 8;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "Upload Dir Mounting"
                                    });

                                    _context28.next = 9;
                                    break;

                                  case 8:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADING_STATE,
                                      descriptions: "Upload Dir Mounting"
                                    });

                                  case 9:
                                    _context28.next = 11;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 11:
                                    if (!checkModuleExist("@fastify/static")) {
                                      _context28.next = 28;
                                      break;
                                    }

                                    _context28.next = 14;
                                    return AppEngine.register(require("@fastify/static"), {
                                      root: config.options.uploadDir,
                                      prefix: '/upload/',
                                      decorateReply: false
                                    });

                                  case 14:
                                    mAppEngine = _context28.sent;
                                    _context28.next = 17;
                                    return (0, _isElectron["default"])();

                                  case 17:
                                    if (!_context28.sent) {
                                      _context28.next = 21;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "Upload Dir Mounting"
                                    });

                                    _context28.next = 22;
                                    break;

                                  case 21:
                                    mProgressBar.increment({
                                      state: _Options["default"].LOADED_STATE,
                                      descriptions: "Upload Dir Mounting"
                                    });

                                  case 22:
                                    _context28.next = 24;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 24:
                                    _context28.next = 26;
                                    return resolve(mAppEngine);

                                  case 26:
                                    _context28.next = 39;
                                    break;

                                  case 28:
                                    _context28.next = 30;
                                    return (0, _isElectron["default"])();

                                  case 30:
                                    if (!_context28.sent) {
                                      _context28.next = 34;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "Upload Dir Mounting Not Found"
                                    });

                                    _context28.next = 35;
                                    break;

                                  case 34:
                                    mProgressBar.increment({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "Upload Dir Mounting Not Found"
                                    });

                                  case 35:
                                    _context28.next = 37;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 37:
                                    _context28.next = 39;
                                    return rejected({
                                      status: false,
                                      code: 500,
                                      msg: "Upload Dir Is Enabled, But Not Found"
                                    });

                                  case 39:
                                    _context28.next = 43;
                                    break;

                                  case 41:
                                    _context28.next = 43;
                                    return resolve(AppEngine);

                                  case 43:
                                  case "end":
                                    return _context28.stop();
                                }
                              }
                            }, _callee28);
                          }));

                          return function (_x44, _x45) {
                            return _ref30.apply(this, arguments);
                          };
                        }());

                      case 2:
                        return _context29.abrupt("return", _context29.sent);

                      case 3:
                      case "end":
                        return _context29.stop();
                    }
                  }
                }, _callee29);
              }));

              return function UploadDirInstance(_x43) {
                return _ref29.apply(this, arguments);
              };
            }();

            mAppEngine = null;
            _context60.next = 22;
            return ServerInstance.then( /*#__PURE__*/function () {
              var _ref31 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee58(AppEngine) {
                return _regenerator["default"].wrap(function _callee58$(_context58) {
                  while (1) {
                    switch (_context58.prev = _context58.next) {
                      case 0:
                        _context58.next = 2;
                        return SocketIOInstance(AppEngine).then( /*#__PURE__*/function () {
                          var _ref32 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee56(AppEngine) {
                            return _regenerator["default"].wrap(function _callee56$(_context56) {
                              while (1) {
                                switch (_context56.prev = _context56.next) {
                                  case 0:
                                    _context56.next = 2;
                                    return ServerViewInstance(AppEngine).then( /*#__PURE__*/function () {
                                      var _ref33 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee54(AppEngine) {
                                        return _regenerator["default"].wrap(function _callee54$(_context54) {
                                          while (1) {
                                            switch (_context54.prev = _context54.next) {
                                              case 0:
                                                _context54.next = 2;
                                                return CorsInstance(AppEngine).then( /*#__PURE__*/function () {
                                                  var _ref34 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee52(AppEngine) {
                                                    return _regenerator["default"].wrap(function _callee52$(_context52) {
                                                      while (1) {
                                                        switch (_context52.prev = _context52.next) {
                                                          case 0:
                                                            _context52.next = 2;
                                                            return RateLimitInstance(AppEngine).then( /*#__PURE__*/function () {
                                                              var _ref35 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee50(AppEngine) {
                                                                return _regenerator["default"].wrap(function _callee50$(_context50) {
                                                                  while (1) {
                                                                    switch (_context50.prev = _context50.next) {
                                                                      case 0:
                                                                        _context50.next = 2;
                                                                        return MultipartInstance(AppEngine).then( /*#__PURE__*/function () {
                                                                          var _ref36 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee48(AppEngine) {
                                                                            return _regenerator["default"].wrap(function _callee48$(_context48) {
                                                                              while (1) {
                                                                                switch (_context48.prev = _context48.next) {
                                                                                  case 0:
                                                                                    _context48.next = 2;
                                                                                    return CookieInstance(AppEngine).then( /*#__PURE__*/function () {
                                                                                      var _ref37 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee46(AppEngine) {
                                                                                        return _regenerator["default"].wrap(function _callee46$(_context46) {
                                                                                          while (1) {
                                                                                            switch (_context46.prev = _context46.next) {
                                                                                              case 0:
                                                                                                _context46.next = 2;
                                                                                                return CompressInstance(AppEngine).then( /*#__PURE__*/function () {
                                                                                                  var _ref38 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee44(AppEngine) {
                                                                                                    return _regenerator["default"].wrap(function _callee44$(_context44) {
                                                                                                      while (1) {
                                                                                                        switch (_context44.prev = _context44.next) {
                                                                                                          case 0:
                                                                                                            _context44.next = 2;
                                                                                                            return HelmetInstance(AppEngine).then( /*#__PURE__*/function () {
                                                                                                              var _ref39 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee42(AppEngine) {
                                                                                                                return _regenerator["default"].wrap(function _callee42$(_context42) {
                                                                                                                  while (1) {
                                                                                                                    switch (_context42.prev = _context42.next) {
                                                                                                                      case 0:
                                                                                                                        _context42.next = 2;
                                                                                                                        return LoggingInstance(AppEngine).then( /*#__PURE__*/function () {
                                                                                                                          var _ref40 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee40(AppEngine) {
                                                                                                                            return _regenerator["default"].wrap(function _callee40$(_context40) {
                                                                                                                              while (1) {
                                                                                                                                switch (_context40.prev = _context40.next) {
                                                                                                                                  case 0:
                                                                                                                                    _context40.next = 2;
                                                                                                                                    return GracefulShutdownInstance(AppEngine).then( /*#__PURE__*/function () {
                                                                                                                                      var _ref41 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee38(AppEngine) {
                                                                                                                                        return _regenerator["default"].wrap(function _callee38$(_context38) {
                                                                                                                                          while (1) {
                                                                                                                                            switch (_context38.prev = _context38.next) {
                                                                                                                                              case 0:
                                                                                                                                                _context38.next = 2;
                                                                                                                                                return JWTInstance(AppEngine).then( /*#__PURE__*/function () {
                                                                                                                                                  var _ref42 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee36(AppEngine) {
                                                                                                                                                    return _regenerator["default"].wrap(function _callee36$(_context36) {
                                                                                                                                                      while (1) {
                                                                                                                                                        switch (_context36.prev = _context36.next) {
                                                                                                                                                          case 0:
                                                                                                                                                            _context36.next = 2;
                                                                                                                                                            return FormBodyInstance(AppEngine).then( /*#__PURE__*/function () {
                                                                                                                                                              var _ref43 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee34(AppEngine) {
                                                                                                                                                                return _regenerator["default"].wrap(function _callee34$(_context34) {
                                                                                                                                                                  while (1) {
                                                                                                                                                                    switch (_context34.prev = _context34.next) {
                                                                                                                                                                      case 0:
                                                                                                                                                                        _context34.next = 2;
                                                                                                                                                                        return AssetDirInstance(AppEngine).then( /*#__PURE__*/function () {
                                                                                                                                                                          var _ref44 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee32(AppEngine) {
                                                                                                                                                                            return _regenerator["default"].wrap(function _callee32$(_context32) {
                                                                                                                                                                              while (1) {
                                                                                                                                                                                switch (_context32.prev = _context32.next) {
                                                                                                                                                                                  case 0:
                                                                                                                                                                                    _context32.next = 2;
                                                                                                                                                                                    return UploadDirInstance(AppEngine).then( /*#__PURE__*/function () {
                                                                                                                                                                                      var _ref45 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee30(AppEngine) {
                                                                                                                                                                                        return _regenerator["default"].wrap(function _callee30$(_context30) {
                                                                                                                                                                                          while (1) {
                                                                                                                                                                                            switch (_context30.prev = _context30.next) {
                                                                                                                                                                                              case 0:
                                                                                                                                                                                                mAppEngine = AppEngine;

                                                                                                                                                                                              case 1:
                                                                                                                                                                                              case "end":
                                                                                                                                                                                                return _context30.stop();
                                                                                                                                                                                            }
                                                                                                                                                                                          }
                                                                                                                                                                                        }, _callee30);
                                                                                                                                                                                      }));

                                                                                                                                                                                      return function (_x60) {
                                                                                                                                                                                        return _ref45.apply(this, arguments);
                                                                                                                                                                                      };
                                                                                                                                                                                    }())["catch"]( /*#__PURE__*/function () {
                                                                                                                                                                                      var _ref46 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee31(error) {
                                                                                                                                                                                        return _regenerator["default"].wrap(function _callee31$(_context31) {
                                                                                                                                                                                          while (1) {
                                                                                                                                                                                            switch (_context31.prev = _context31.next) {
                                                                                                                                                                                              case 0:
                                                                                                                                                                                                throw error;

                                                                                                                                                                                              case 1:
                                                                                                                                                                                              case "end":
                                                                                                                                                                                                return _context31.stop();
                                                                                                                                                                                            }
                                                                                                                                                                                          }
                                                                                                                                                                                        }, _callee31);
                                                                                                                                                                                      }));

                                                                                                                                                                                      return function (_x61) {
                                                                                                                                                                                        return _ref46.apply(this, arguments);
                                                                                                                                                                                      };
                                                                                                                                                                                    }());

                                                                                                                                                                                  case 2:
                                                                                                                                                                                  case "end":
                                                                                                                                                                                    return _context32.stop();
                                                                                                                                                                                }
                                                                                                                                                                              }
                                                                                                                                                                            }, _callee32);
                                                                                                                                                                          }));

                                                                                                                                                                          return function (_x59) {
                                                                                                                                                                            return _ref44.apply(this, arguments);
                                                                                                                                                                          };
                                                                                                                                                                        }())["catch"]( /*#__PURE__*/function () {
                                                                                                                                                                          var _ref47 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee33(error) {
                                                                                                                                                                            return _regenerator["default"].wrap(function _callee33$(_context33) {
                                                                                                                                                                              while (1) {
                                                                                                                                                                                switch (_context33.prev = _context33.next) {
                                                                                                                                                                                  case 0:
                                                                                                                                                                                    throw error;

                                                                                                                                                                                  case 1:
                                                                                                                                                                                  case "end":
                                                                                                                                                                                    return _context33.stop();
                                                                                                                                                                                }
                                                                                                                                                                              }
                                                                                                                                                                            }, _callee33);
                                                                                                                                                                          }));

                                                                                                                                                                          return function (_x62) {
                                                                                                                                                                            return _ref47.apply(this, arguments);
                                                                                                                                                                          };
                                                                                                                                                                        }());

                                                                                                                                                                      case 2:
                                                                                                                                                                      case "end":
                                                                                                                                                                        return _context34.stop();
                                                                                                                                                                    }
                                                                                                                                                                  }
                                                                                                                                                                }, _callee34);
                                                                                                                                                              }));

                                                                                                                                                              return function (_x58) {
                                                                                                                                                                return _ref43.apply(this, arguments);
                                                                                                                                                              };
                                                                                                                                                            }())["catch"]( /*#__PURE__*/function () {
                                                                                                                                                              var _ref48 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee35(error) {
                                                                                                                                                                return _regenerator["default"].wrap(function _callee35$(_context35) {
                                                                                                                                                                  while (1) {
                                                                                                                                                                    switch (_context35.prev = _context35.next) {
                                                                                                                                                                      case 0:
                                                                                                                                                                        throw error;

                                                                                                                                                                      case 1:
                                                                                                                                                                      case "end":
                                                                                                                                                                        return _context35.stop();
                                                                                                                                                                    }
                                                                                                                                                                  }
                                                                                                                                                                }, _callee35);
                                                                                                                                                              }));

                                                                                                                                                              return function (_x63) {
                                                                                                                                                                return _ref48.apply(this, arguments);
                                                                                                                                                              };
                                                                                                                                                            }());

                                                                                                                                                          case 2:
                                                                                                                                                          case "end":
                                                                                                                                                            return _context36.stop();
                                                                                                                                                        }
                                                                                                                                                      }
                                                                                                                                                    }, _callee36);
                                                                                                                                                  }));

                                                                                                                                                  return function (_x57) {
                                                                                                                                                    return _ref42.apply(this, arguments);
                                                                                                                                                  };
                                                                                                                                                }())["catch"]( /*#__PURE__*/function () {
                                                                                                                                                  var _ref49 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee37(error) {
                                                                                                                                                    return _regenerator["default"].wrap(function _callee37$(_context37) {
                                                                                                                                                      while (1) {
                                                                                                                                                        switch (_context37.prev = _context37.next) {
                                                                                                                                                          case 0:
                                                                                                                                                            throw error;

                                                                                                                                                          case 1:
                                                                                                                                                          case "end":
                                                                                                                                                            return _context37.stop();
                                                                                                                                                        }
                                                                                                                                                      }
                                                                                                                                                    }, _callee37);
                                                                                                                                                  }));

                                                                                                                                                  return function (_x64) {
                                                                                                                                                    return _ref49.apply(this, arguments);
                                                                                                                                                  };
                                                                                                                                                }());

                                                                                                                                              case 2:
                                                                                                                                              case "end":
                                                                                                                                                return _context38.stop();
                                                                                                                                            }
                                                                                                                                          }
                                                                                                                                        }, _callee38);
                                                                                                                                      }));

                                                                                                                                      return function (_x56) {
                                                                                                                                        return _ref41.apply(this, arguments);
                                                                                                                                      };
                                                                                                                                    }())["catch"]( /*#__PURE__*/function () {
                                                                                                                                      var _ref50 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee39(error) {
                                                                                                                                        return _regenerator["default"].wrap(function _callee39$(_context39) {
                                                                                                                                          while (1) {
                                                                                                                                            switch (_context39.prev = _context39.next) {
                                                                                                                                              case 0:
                                                                                                                                                throw error;

                                                                                                                                              case 1:
                                                                                                                                              case "end":
                                                                                                                                                return _context39.stop();
                                                                                                                                            }
                                                                                                                                          }
                                                                                                                                        }, _callee39);
                                                                                                                                      }));

                                                                                                                                      return function (_x65) {
                                                                                                                                        return _ref50.apply(this, arguments);
                                                                                                                                      };
                                                                                                                                    }());

                                                                                                                                  case 2:
                                                                                                                                  case "end":
                                                                                                                                    return _context40.stop();
                                                                                                                                }
                                                                                                                              }
                                                                                                                            }, _callee40);
                                                                                                                          }));

                                                                                                                          return function (_x55) {
                                                                                                                            return _ref40.apply(this, arguments);
                                                                                                                          };
                                                                                                                        }())["catch"]( /*#__PURE__*/function () {
                                                                                                                          var _ref51 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee41(error) {
                                                                                                                            return _regenerator["default"].wrap(function _callee41$(_context41) {
                                                                                                                              while (1) {
                                                                                                                                switch (_context41.prev = _context41.next) {
                                                                                                                                  case 0:
                                                                                                                                    throw error;

                                                                                                                                  case 1:
                                                                                                                                  case "end":
                                                                                                                                    return _context41.stop();
                                                                                                                                }
                                                                                                                              }
                                                                                                                            }, _callee41);
                                                                                                                          }));

                                                                                                                          return function (_x66) {
                                                                                                                            return _ref51.apply(this, arguments);
                                                                                                                          };
                                                                                                                        }());

                                                                                                                      case 2:
                                                                                                                      case "end":
                                                                                                                        return _context42.stop();
                                                                                                                    }
                                                                                                                  }
                                                                                                                }, _callee42);
                                                                                                              }));

                                                                                                              return function (_x54) {
                                                                                                                return _ref39.apply(this, arguments);
                                                                                                              };
                                                                                                            }())["catch"]( /*#__PURE__*/function () {
                                                                                                              var _ref52 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee43(error) {
                                                                                                                return _regenerator["default"].wrap(function _callee43$(_context43) {
                                                                                                                  while (1) {
                                                                                                                    switch (_context43.prev = _context43.next) {
                                                                                                                      case 0:
                                                                                                                        throw error;

                                                                                                                      case 1:
                                                                                                                      case "end":
                                                                                                                        return _context43.stop();
                                                                                                                    }
                                                                                                                  }
                                                                                                                }, _callee43);
                                                                                                              }));

                                                                                                              return function (_x67) {
                                                                                                                return _ref52.apply(this, arguments);
                                                                                                              };
                                                                                                            }());

                                                                                                          case 2:
                                                                                                          case "end":
                                                                                                            return _context44.stop();
                                                                                                        }
                                                                                                      }
                                                                                                    }, _callee44);
                                                                                                  }));

                                                                                                  return function (_x53) {
                                                                                                    return _ref38.apply(this, arguments);
                                                                                                  };
                                                                                                }())["catch"]( /*#__PURE__*/function () {
                                                                                                  var _ref53 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee45(error) {
                                                                                                    return _regenerator["default"].wrap(function _callee45$(_context45) {
                                                                                                      while (1) {
                                                                                                        switch (_context45.prev = _context45.next) {
                                                                                                          case 0:
                                                                                                            throw error;

                                                                                                          case 1:
                                                                                                          case "end":
                                                                                                            return _context45.stop();
                                                                                                        }
                                                                                                      }
                                                                                                    }, _callee45);
                                                                                                  }));

                                                                                                  return function (_x68) {
                                                                                                    return _ref53.apply(this, arguments);
                                                                                                  };
                                                                                                }());

                                                                                              case 2:
                                                                                              case "end":
                                                                                                return _context46.stop();
                                                                                            }
                                                                                          }
                                                                                        }, _callee46);
                                                                                      }));

                                                                                      return function (_x52) {
                                                                                        return _ref37.apply(this, arguments);
                                                                                      };
                                                                                    }())["catch"]( /*#__PURE__*/function () {
                                                                                      var _ref54 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee47(error) {
                                                                                        return _regenerator["default"].wrap(function _callee47$(_context47) {
                                                                                          while (1) {
                                                                                            switch (_context47.prev = _context47.next) {
                                                                                              case 0:
                                                                                                throw error;

                                                                                              case 1:
                                                                                              case "end":
                                                                                                return _context47.stop();
                                                                                            }
                                                                                          }
                                                                                        }, _callee47);
                                                                                      }));

                                                                                      return function (_x69) {
                                                                                        return _ref54.apply(this, arguments);
                                                                                      };
                                                                                    }());

                                                                                  case 2:
                                                                                  case "end":
                                                                                    return _context48.stop();
                                                                                }
                                                                              }
                                                                            }, _callee48);
                                                                          }));

                                                                          return function (_x51) {
                                                                            return _ref36.apply(this, arguments);
                                                                          };
                                                                        }())["catch"]( /*#__PURE__*/function () {
                                                                          var _ref55 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee49(error) {
                                                                            return _regenerator["default"].wrap(function _callee49$(_context49) {
                                                                              while (1) {
                                                                                switch (_context49.prev = _context49.next) {
                                                                                  case 0:
                                                                                    throw error;

                                                                                  case 1:
                                                                                  case "end":
                                                                                    return _context49.stop();
                                                                                }
                                                                              }
                                                                            }, _callee49);
                                                                          }));

                                                                          return function (_x70) {
                                                                            return _ref55.apply(this, arguments);
                                                                          };
                                                                        }());

                                                                      case 2:
                                                                      case "end":
                                                                        return _context50.stop();
                                                                    }
                                                                  }
                                                                }, _callee50);
                                                              }));

                                                              return function (_x50) {
                                                                return _ref35.apply(this, arguments);
                                                              };
                                                            }())["catch"]( /*#__PURE__*/function () {
                                                              var _ref56 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee51(error) {
                                                                return _regenerator["default"].wrap(function _callee51$(_context51) {
                                                                  while (1) {
                                                                    switch (_context51.prev = _context51.next) {
                                                                      case 0:
                                                                        throw error;

                                                                      case 1:
                                                                      case "end":
                                                                        return _context51.stop();
                                                                    }
                                                                  }
                                                                }, _callee51);
                                                              }));

                                                              return function (_x71) {
                                                                return _ref56.apply(this, arguments);
                                                              };
                                                            }());

                                                          case 2:
                                                          case "end":
                                                            return _context52.stop();
                                                        }
                                                      }
                                                    }, _callee52);
                                                  }));

                                                  return function (_x49) {
                                                    return _ref34.apply(this, arguments);
                                                  };
                                                }())["catch"]( /*#__PURE__*/function () {
                                                  var _ref57 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee53(error) {
                                                    return _regenerator["default"].wrap(function _callee53$(_context53) {
                                                      while (1) {
                                                        switch (_context53.prev = _context53.next) {
                                                          case 0:
                                                            throw error;

                                                          case 1:
                                                          case "end":
                                                            return _context53.stop();
                                                        }
                                                      }
                                                    }, _callee53);
                                                  }));

                                                  return function (_x72) {
                                                    return _ref57.apply(this, arguments);
                                                  };
                                                }());

                                              case 2:
                                              case "end":
                                                return _context54.stop();
                                            }
                                          }
                                        }, _callee54);
                                      }));

                                      return function (_x48) {
                                        return _ref33.apply(this, arguments);
                                      };
                                    }())["catch"]( /*#__PURE__*/function () {
                                      var _ref58 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee55(error) {
                                        return _regenerator["default"].wrap(function _callee55$(_context55) {
                                          while (1) {
                                            switch (_context55.prev = _context55.next) {
                                              case 0:
                                                throw error;

                                              case 1:
                                              case "end":
                                                return _context55.stop();
                                            }
                                          }
                                        }, _callee55);
                                      }));

                                      return function (_x73) {
                                        return _ref58.apply(this, arguments);
                                      };
                                    }());

                                  case 2:
                                  case "end":
                                    return _context56.stop();
                                }
                              }
                            }, _callee56);
                          }));

                          return function (_x47) {
                            return _ref32.apply(this, arguments);
                          };
                        }())["catch"]( /*#__PURE__*/function () {
                          var _ref59 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee57(error) {
                            return _regenerator["default"].wrap(function _callee57$(_context57) {
                              while (1) {
                                switch (_context57.prev = _context57.next) {
                                  case 0:
                                    throw error;

                                  case 1:
                                  case "end":
                                    return _context57.stop();
                                }
                              }
                            }, _callee57);
                          }));

                          return function (_x74) {
                            return _ref59.apply(this, arguments);
                          };
                        }());

                      case 2:
                      case "end":
                        return _context58.stop();
                    }
                  }
                }, _callee58);
              }));

              return function (_x46) {
                return _ref31.apply(this, arguments);
              };
            }())["catch"]( /*#__PURE__*/function () {
              var _ref60 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee59(error) {
                return _regenerator["default"].wrap(function _callee59$(_context59) {
                  while (1) {
                    switch (_context59.prev = _context59.next) {
                      case 0:
                        _context59.next = 2;
                        return process.exit(1);

                      case 2:
                        throw error;

                      case 3:
                      case "end":
                        return _context59.stop();
                    }
                  }
                }, _callee59);
              }));

              return function (_x75) {
                return _ref60.apply(this, arguments);
              };
            }());

          case 22:
            return _context60.abrupt("return", mAppEngine);

          case 23:
          case "end":
            return _context60.stop();
        }
      }
    }, _callee60);
  }));

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}();

exports["default"] = _default;
//# sourceMappingURL=index.js.map