"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _path = _interopRequireDefault(require("path"));

var _fs = _interopRequireWildcard(require("fs"));

var _lodash = _interopRequireDefault(require("lodash"));

var _Options = _interopRequireDefault(require("./../../Options"));

var _webpack = _interopRequireDefault(require("webpack"));

var _htmlWebpackPlugin = _interopRequireDefault(require("html-webpack-plugin"));

var _webpackDevServer = _interopRequireDefault(require("webpack-dev-server"));

var _delay = _interopRequireDefault(require("delay"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 *
 * @param config
 * @returns {Promise<unknown>}
 */
var _default = function _default(config) {
  return new Promise( /*#__PURE__*/function () {
    var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(resolve, reject) {
      var serverState, mEntryPath, configuration;
      return _regenerator["default"].wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              //"development" | "production" | "none"
              serverState = config.serverState === _Options["default"].SERVER_STATE_DEVELOPMENT ? "development" : config.serverState === _Options["default"].SERVER_STATE_PRODUCTION ? "production" : "none";
              _context4.next = 3;
              return mProgressBar.increment({
                state: _Options["default"].LOADING_STATE,
                descriptions: "merged setting for react webpack"
              });

            case 3:
              _context4.next = 5;
              return (0, _delay["default"])(_Options["default"].DELAY_TIME);

            case 5:
              /** Merger Configuration Data Merger Object
               * @param {Number} configuration
               * **/
              mEntryPath = config.app.entry !== undefined ? config.app.entry : _path["default"].join(require.main.filename, './../app.js');
              /** Check Entry Path Exists Path **/

              if ((0, _fs.existsSync)(mEntryPath)) {
                _context4.next = 11;
                break;
              }

              _context4.next = 9;
              return mProgressBar.increment({
                state: _Options["default"].ERROR_STATE,
                descriptions: "entry path in ".concat(mEntryPath, " not found !. Please add options { entry : ... } ")
              });

            case 9:
              _context4.next = 11;
              return reject({
                status: false,
                code: 500,
                msg: "entry path in ".concat(mEntryPath, " not found !. Please add options { entry : ... } ")
              });

            case 11:
              _context4.next = 13;
              return _lodash["default"].merge({
                /** Server State Mode Server Less Object Settings **/
                mode: serverState,

                /** Entry Point Path File Loader Builder Native App.js Location Default**/
                entry: mEntryPath,

                /** Output Data Engine The Path And JS Output Path **/
                output: {
                  /** path Destination After Compile **/
                  path: config.options.distDir,
                  filename: 'dkabundle.js'
                },
                devServer: {
                  contentBase: config.options.publicDir,
                  writeToDisk: true
                },
                plugins: [
                /** Generate HTML Webpack Plugin data For Generation Webpack HTML React JS**/
                new _htmlWebpackPlugin["default"]({
                  template: _path["default"].resolve(config.options.publicDir, "./index.html")
                }), new _webpack["default"].ProvidePlugin({
                  process: 'process/browser'
                })],
                resolve: {
                  // configuration options
                  alias: {
                    process: "process/browser"
                  }
                }
              }, config.Webpack);

            case 13:
              configuration = _context4.sent;
              _context4.next = 16;
              return mProgressBar.increment({
                state: _Options["default"].LOADED_STATE,
                descriptions: "merged setting for react webpack"
              });

            case 16:
              _context4.next = 18;
              return (0, _delay["default"])(_Options["default"].DELAY_TIME);

            case 18:
              /** Checing Sserver Starts Data Start Development **/
              if (config.serverState === _Options["default"].SERVER_STATE_DEVELOPMENT) {
                console.log("entry config ".concat(configuration.entry));
                console.log("path config ".concat(configuration.output.path));
              }

              return _context4.abrupt("return", new Promise( /*#__PURE__*/function () {
                var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(stepResolve, stepRejected) {
                  return _regenerator["default"].wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          _context.next = 2;
                          return mProgressBar.increment({
                            state: _Options["default"].LOADING_STATE,
                            descriptions: "checking output path react"
                          });

                        case 2:
                          _context.next = 4;
                          return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                        case 4:
                          if (_fs["default"].existsSync(configuration.output.path)) {
                            _context.next = 9;
                            break;
                          }

                          _context.next = 7;
                          return _fs["default"].mkdirSync(configuration.output.path);

                        case 7:
                          _context.next = 9;
                          return _fs["default"].chmodSync(configuration.output.path, 777);

                        case 9:
                          if (!(typeof configuration.app === "function")) {
                            _context.next = 12;
                            break;
                          }

                          _context.next = 12;
                          return stepRejected({
                            status: false,
                            code: 500,
                            msg: "options app must object config { entry, .. args} "
                          });

                        case 12:
                          _context.next = 14;
                          return mProgressBar.increment({
                            state: _Options["default"].LOADED_STATE,
                            descriptions: "checking output path react"
                          });

                        case 14:
                          _context.next = 16;
                          return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                        case 16:
                          _context.next = 18;
                          return stepResolve(configuration);

                        case 18:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee);
                }));

                return function (_x3, _x4) {
                  return _ref2.apply(this, arguments);
                };
              }()).then( /*#__PURE__*/function () {
                var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(res) {
                  var compiler, devServerOptions, webpackInstance;
                  return _regenerator["default"].wrap(function _callee2$(_context2) {
                    while (1) {
                      switch (_context2.prev = _context2.next) {
                        case 0:
                          _context2.next = 2;
                          return mProgressBar.increment({
                            state: _Options["default"].LOADING_STATE,
                            descriptions: "starting webpack engine"
                          });

                        case 2:
                          _context2.next = 4;
                          return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                        case 4:
                          _context2.next = 6;
                          return (0, _webpack["default"])(res);

                        case 6:
                          compiler = _context2.sent;
                          _context2.next = 9;
                          return mProgressBar.increment({
                            state: _Options["default"].LOADED_STATE,
                            descriptions: "started webpack engine"
                          });

                        case 9:
                          _context2.next = 11;
                          return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                        case 11:
                          devServerOptions = {
                            "static": {
                              directory: config.options.publicDir
                            },
                            historyApiFallback: true,
                            compress: config.settings.reactCompress,
                            port: config.serverPort,
                            // Enable hot reloading
                            hot: config.settings.reactHot,
                            open: config.settings.reactOpen
                          };
                          _context2.next = 14;
                          return mProgressBar.increment({
                            state: _Options["default"].LOADING_STATE,
                            descriptions: "starting webpackDevServer Engine"
                          });

                        case 14:
                          _context2.next = 16;
                          return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                        case 16:
                          _context2.next = 18;
                          return new _webpackDevServer["default"](devServerOptions, compiler);

                        case 18:
                          webpackInstance = _context2.sent;
                          _context2.next = 21;
                          return mProgressBar.increment({
                            state: _Options["default"].LOADED_STATE,
                            descriptions: "started webpackDevServer Engine"
                          });

                        case 21:
                          _context2.next = 23;
                          return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                        case 23:
                          _context2.next = 25;
                          return resolve(webpackInstance);

                        case 25:
                        case "end":
                          return _context2.stop();
                      }
                    }
                  }, _callee2);
                }));

                return function (_x5) {
                  return _ref3.apply(this, arguments);
                };
              }())["catch"]( /*#__PURE__*/function () {
                var _ref4 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(error) {
                  return _regenerator["default"].wrap(function _callee3$(_context3) {
                    while (1) {
                      switch (_context3.prev = _context3.next) {
                        case 0:
                          _context3.next = 2;
                          return reject(error);

                        case 2:
                        case "end":
                          return _context3.stop();
                      }
                    }
                  }, _callee3);
                }));

                return function (_x6) {
                  return _ref4.apply(this, arguments);
                };
              }()));

            case 20:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }());
};

exports["default"] = _default;
//# sourceMappingURL=index.js.map