"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _Options = _interopRequireDefault(require("../../../Options"));

var _delay = _interopRequireDefault(require("delay"));

var _isElectron = _interopRequireDefault(require("is-electron"));

var _electronLog = _interopRequireDefault(require("electron-log"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Client = /*#__PURE__*/function () {
  var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(config) {
    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            return _context3.abrupt("return", new Promise( /*#__PURE__*/function () {
              var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(resolve, rejected) {
                var serverState, socketIo, mIo;
                return _regenerator["default"].wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        _context2.prev = 0;
                        //"development" | "production" | "none"
                        serverState = config.serverState === _Options["default"].SERVER_STATE_DEVELOPMENT ? "development" : config.serverState === _Options["default"].SERVER_STATE_PRODUCTION ? "production" : "none";
                        _context2.next = 4;
                        return mProgressBar.increment({
                          state: _Options["default"].LOADING_STATE,
                          descriptions: "merged setting for socket io engine"
                        });

                      case 4:
                        _context2.next = 6;
                        return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                      case 6:
                        _context2.next = 8;
                        return (0, _isElectron["default"])();

                      case 8:
                        if (!_context2.sent) {
                          _context2.next = 12;
                          break;
                        }

                        _electronLog["default"].info({
                          state: _Options["default"].LOADING_STATE,
                          descriptions: "http module"
                        });

                        _context2.next = 13;
                        break;

                      case 12:
                        mProgressBar.increment({
                          state: _Options["default"].LOADING_STATE,
                          descriptions: "http module"
                        });

                      case 13:
                        _context2.next = 15;
                        return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                      case 15:
                        _context2.next = 17;
                        return (0, _isElectron["default"])();

                      case 17:
                        if (!_context2.sent) {
                          _context2.next = 21;
                          break;
                        }

                        _electronLog["default"].info({
                          state: _Options["default"].LOADED_STATE,
                          descriptions: "http module"
                        });

                        _context2.next = 22;
                        break;

                      case 21:
                        mProgressBar.increment({
                          state: _Options["default"].LOADED_STATE,
                          descriptions: "http module"
                        });

                      case 22:
                        _context2.next = 24;
                        return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                      case 24:
                        _context2.next = 26;
                        return Promise.resolve().then(function () {
                          return _interopRequireWildcard(require("socket.io-client"));
                        })["catch"]( /*#__PURE__*/function () {
                          var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(reason) {
                            return _regenerator["default"].wrap(function _callee$(_context) {
                              while (1) {
                                switch (_context.prev = _context.next) {
                                  case 0:
                                    _context.next = 2;
                                    return (0, _isElectron["default"])();

                                  case 2:
                                    if (!_context.sent) {
                                      _context.next = 6;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "module socket.io client not exist. please install first for use"
                                    });

                                    _context.next = 7;
                                    break;

                                  case 6:
                                    mProgressBar.increment({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "module socket.io client not exist. please install first for use"
                                    });

                                  case 7:
                                    _context.next = 9;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 9:
                                    _context.next = 11;
                                    return rejected({
                                      status: false,
                                      code: 500,
                                      msg: "Engine Socket Client Io error Imported",
                                      error: reason
                                    });

                                  case 11:
                                  case "end":
                                    return _context.stop();
                                }
                              }
                            }, _callee);
                          }));

                          return function (_x4) {
                            return _ref3.apply(this, arguments);
                          };
                        }());

                      case 26:
                        socketIo = _context2.sent;
                        _context2.next = 29;
                        return socketIo.io(config.serverHost, config.settings);

                      case 29:
                        mIo = _context2.sent;
                        _context2.next = 32;
                        return resolve({
                          io: mIo
                        });

                      case 32:
                        _context2.next = 38;
                        break;

                      case 34:
                        _context2.prev = 34;
                        _context2.t0 = _context2["catch"](0);
                        _context2.next = 38;
                        return rejected({
                          status: false,
                          code: 500,
                          msg: "Engine Socket Client Io error",
                          error: _context2.t0
                        });

                      case 38:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2, null, [[0, 34]]);
              }));

              return function (_x2, _x3) {
                return _ref2.apply(this, arguments);
              };
            }()));

          case 1:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));

  return function Client(_x) {
    return _ref.apply(this, arguments);
  };
}();

var _default = Client;
exports["default"] = _default;
//# sourceMappingURL=index.js.map