"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _Options = _interopRequireDefault(require("../../../Options"));

var _delay = _interopRequireDefault(require("delay"));

var _Config = _interopRequireDefault(require("../../../Config"));

var _isElectron = _interopRequireDefault(require("is-electron"));

var _electronLog = _interopRequireDefault(require("electron-log"));

var _EngineHook = _interopRequireDefault(require("./EngineHook"));

var _StateHook = _interopRequireDefault(require("./StateHook"));

var _HookHandler = _interopRequireDefault(require("./HookHandler"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 *
 * @param {{app: boolean, settings: {localtunnel: boolean, pingInterval: number, reactCompress: boolean, cors: {origin: string}, reactHot: boolean, secretKey: string, perMessageDeflate: boolean, ngrok: {authToken: null, enabled: boolean}, reactOpen: boolean, firewall: [], connectTimeout: number, pingTimeout: number, maxListeners: number}, serverView: number, serverEngine: Number, serverName: *|null, serverPort: number, secure: boolean, serverHost: string, serverEnabled: Boolean, serverState: ("dev"|"prod"), library: {socketIo: {cors: {origin: string}, perMessageDeflate: boolean}}, plugin: {FastifyGracefulShutdown: {options: {}, enabled: boolean}, FastifyCookie: {options: {}, enabled: boolean}, FastifyCors: {options: {origin: string}, enabled: boolean}, FastifyRateLimit: {options: {}, enabled: boolean}, FastifyJwt: {options: {}, enabled: boolean}, FastifyMultipart: {options: {}, enabled: boolean}, FastifyLog: {options: {}, enabled: boolean}, FastifyFormBody: {options: {}, enabled: boolean}, FastifyHelmet: {options: {contentSecurityPolicy: boolean}, enabled: boolean}, FastifyCompress: {options: {global: boolean}, enabled: boolean}, FastifySocketIO: {options: {cors: {origin: string}, perMessageDeflate: boolean}, enabled: boolean}, FastifyPointOfView: {options: {}, enabled: boolean}}, options: {layoutDir: string, distDir: string, backupDir: string, autoloadDir: string, uploadDir: string, appDir: string, srcDir: string, assetsDir: string, publicDir: string}, serverDomain: (Boolean|String), http2: boolean, Webpack: {mode: string, resolve: {extensions: string[]}, module: {rules: [{test: RegExp, use: {loader: string, options: {presets: string[], plugins: string[]}}, exclude: RegExp},{test: RegExp, use: string[]},{test: RegExp, use: [{loader: string},{loader: string}]}]}, target: string}}} config
 * @return {Promise<WebSocket>}
 */
var Server = /*#__PURE__*/function () {
  var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
    var config,
        _args3 = arguments;
    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            config = _args3.length > 0 && _args3[0] !== undefined ? _args3[0] : _Config["default"].Server;
            return _context3.abrupt("return", new Promise( /*#__PURE__*/function () {
              var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(resolve, reject) {
                var serverState, http, socketIo, mServer, mIo;
                return _regenerator["default"].wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        _context2.prev = 0;
                        //"development" | "production" | "none"
                        serverState = config.serverState === _Options["default"].SERVER_STATE_DEVELOPMENT ? "development" : config.serverState === _Options["default"].SERVER_STATE_PRODUCTION ? "production" : "none";
                        _context2.next = 4;
                        return mProgressBar.increment({
                          state: _Options["default"].LOADING_STATE,
                          descriptions: "merged setting for socket io engine"
                        });

                      case 4:
                        _context2.next = 6;
                        return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                      case 6:
                        _context2.next = 8;
                        return (0, _isElectron["default"])();

                      case 8:
                        if (!_context2.sent) {
                          _context2.next = 12;
                          break;
                        }

                        _electronLog["default"].info({
                          state: _Options["default"].LOADING_STATE,
                          descriptions: "http module"
                        });

                        _context2.next = 13;
                        break;

                      case 12:
                        mProgressBar.increment({
                          state: _Options["default"].LOADING_STATE,
                          descriptions: "http module"
                        });

                      case 13:
                        _context2.next = 15;
                        return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                      case 15:
                        _context2.next = 17;
                        return Promise.resolve().then(function () {
                          return _interopRequireWildcard(require("http"));
                        });

                      case 17:
                        http = _context2.sent;
                        _context2.next = 20;
                        return (0, _isElectron["default"])();

                      case 20:
                        if (!_context2.sent) {
                          _context2.next = 24;
                          break;
                        }

                        _electronLog["default"].info({
                          state: _Options["default"].LOADED_STATE,
                          descriptions: "http module"
                        });

                        _context2.next = 25;
                        break;

                      case 24:
                        mProgressBar.increment({
                          state: _Options["default"].LOADED_STATE,
                          descriptions: "http module"
                        });

                      case 25:
                        _context2.next = 27;
                        return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                      case 27:
                        _context2.next = 29;
                        return Promise.resolve().then(function () {
                          return _interopRequireWildcard(require("socket.io"));
                        })["catch"]( /*#__PURE__*/function () {
                          var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(reason) {
                            return _regenerator["default"].wrap(function _callee$(_context) {
                              while (1) {
                                switch (_context.prev = _context.next) {
                                  case 0:
                                    _context.next = 2;
                                    return (0, _isElectron["default"])();

                                  case 2:
                                    if (!_context.sent) {
                                      _context.next = 6;
                                      break;
                                    }

                                    _electronLog["default"].info({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "module socket.io not exist. please install first for use"
                                    });

                                    _context.next = 7;
                                    break;

                                  case 6:
                                    mProgressBar.increment({
                                      state: _Options["default"].ERROR_STATE,
                                      descriptions: "module socket.io not exist. please install first for use"
                                    });

                                  case 7:
                                    _context.next = 9;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 9:
                                    _context.next = 11;
                                    return rejected({
                                      status: false,
                                      code: 500,
                                      msg: "Engine Socket Server Io error Imported",
                                      error: reason
                                    });

                                  case 11:
                                  case "end":
                                    return _context.stop();
                                }
                              }
                            }, _callee);
                          }));

                          return function (_x3) {
                            return _ref3.apply(this, arguments);
                          };
                        }());

                      case 29:
                        socketIo = _context2.sent;
                        _context2.next = 32;
                        return (0, _isElectron["default"])();

                      case 32:
                        if (!_context2.sent) {
                          _context2.next = 36;
                          break;
                        }

                        _electronLog["default"].info({
                          state: _Options["default"].LOADED_STATE,
                          descriptions: "socket.io loaded"
                        });

                        _context2.next = 37;
                        break;

                      case 36:
                        mProgressBar.increment({
                          state: _Options["default"].LOADED_STATE,
                          descriptions: "socket.io loaded"
                        });

                      case 37:
                        _context2.next = 39;
                        return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                      case 39:
                        _context2.next = 41;
                        return (0, _isElectron["default"])();

                      case 41:
                        if (!_context2.sent) {
                          _context2.next = 45;
                          break;
                        }

                        _electronLog["default"].info({
                          state: _Options["default"].LOADING_STATE,
                          descriptions: "http function create server"
                        });

                        _context2.next = 46;
                        break;

                      case 45:
                        mProgressBar.increment({
                          state: _Options["default"].LOADING_STATE,
                          descriptions: "http function create server"
                        });

                      case 46:
                        _context2.next = 48;
                        return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                      case 48:
                        _context2.next = 50;
                        return http.createServer();

                      case 50:
                        mServer = _context2.sent;
                        _context2.next = 53;
                        return (0, _isElectron["default"])();

                      case 53:
                        if (!_context2.sent) {
                          _context2.next = 57;
                          break;
                        }

                        _electronLog["default"].info({
                          state: _Options["default"].LOADED_STATE,
                          descriptions: "http function create server"
                        });

                        _context2.next = 58;
                        break;

                      case 57:
                        mProgressBar.increment({
                          state: _Options["default"].LOADED_STATE,
                          descriptions: "http function create server"
                        });

                      case 58:
                        _context2.next = 60;
                        return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                      case 60:
                        /**
                         *
                         * @type {Server<DefaultEventsMap, DefaultEventsMap, DefaultEventsMap, any>}
                         */
                        mIo = new socketIo.Server(mServer, config.settings);
                        /** The Global Middleware Module Socket.io **/

                        _context2.t0 = Promise;
                        _context2.next = 64;
                        return (0, _EngineHook["default"])(mIo, config);

                      case 64:
                        _context2.t1 = _context2.sent;
                        _context2.next = 67;
                        return (0, _HookHandler["default"])(mIo, config);

                      case 67:
                        _context2.t2 = _context2.sent;
                        _context2.next = 70;
                        return (0, _StateHook["default"])(mIo, config);

                      case 70:
                        _context2.t3 = _context2.sent;
                        _context2.t4 = [_context2.t1, _context2.t2, _context2.t3];
                        _context2.next = 74;
                        return _context2.t0.all.call(_context2.t0, _context2.t4);

                      case 74:
                        _context2.next = 76;
                        return resolve({
                          io: mIo,
                          http: mServer
                        });

                      case 76:
                        _context2.next = 82;
                        break;

                      case 78:
                        _context2.prev = 78;
                        _context2.t5 = _context2["catch"](0);
                        _context2.next = 82;
                        return reject({
                          status: false,
                          code: 500,
                          msg: "Engine Socket Io error",
                          error: _context2.t5
                        });

                      case 82:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2, null, [[0, 78]]);
              }));

              return function (_x, _x2) {
                return _ref2.apply(this, arguments);
              };
            }()));

          case 2:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));

  return function Server() {
    return _ref.apply(this, arguments);
  };
}();

var _default = Server;
exports["default"] = _default;
//# sourceMappingURL=index.js.map