'use strict';
'use warning';

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _lodash = _interopRequireDefault(require("lodash"));

var _delay = _interopRequireDefault(require("delay"));

var _cliProgress = _interopRequireDefault(require("cli-progress"));

var _ansiColors = _interopRequireDefault(require("ansi-colors"));

var _indexModuleD = _interopRequireDefault(require("./../index.module.d.js"));

var _isElectron = _interopRequireDefault(require("is-electron"));

var _electronLog = _interopRequireDefault(require("electron-log"));

var _fs = require("fs");

var _Config = _interopRequireDefault(require("./../Config"));

var _Options = _interopRequireDefault(require("./../Options"));

var _HTTP = _interopRequireDefault(require("./HTTP"));

var _REACT = _interopRequireDefault(require("./REACT"));

var _FASTIFY = _interopRequireDefault(require("./FASTIFY"));

var _EXPRESS = _interopRequireDefault(require("./EXPRESS"));

var _SOCKET = _interopRequireDefault(require("./SOCKET"));

var _UDP = _interopRequireDefault(require("./UDP"));

var _ELECTRON = _interopRequireDefault(require("./ELECTRON"));

var _NTP = _interopRequireDefault(require("./NTP"));

var _Autoloads = _interopRequireDefault(require("./Autoloads"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var mApp = null;
/**
 *
 * @type {function<Socket>} co
 */

var configuration = {};
global.mProgressBar = new _cliProgress["default"].Bar({
  format: 'DKA [{state}] {descriptions}' + _ansiColors["default"].blue('{bar}') + ' | {percentage}% || {value} Chunks',
  barCompleteChar: "\u2588",
  barIncompleteChar: "\u2591",
  hideCursor: true
});
/**
 *
 * @param {{app: boolean, settings: {localtunnel: boolean, pingInterval: number, reactCompress: boolean, cors: {origin: string}, reactHot: boolean, secretKey: string, firewall: [], connectTimeout: number, pingTimeout: number, perMessageDeflate: boolean, ngrok: {authToken: null, enabled: boolean}, reactOpen: boolean}, serverView: number, serverEngine: Number, serverName: *|null, serverPort: number, secure: boolean, serverHost: string, serverEnabled: Boolean, serverState: string, library: {socketIo: {cors: {origin: string}, perMessageDeflate: boolean}}, plugin: {FastifyGracefulShutdown: {options: {}, enabled: boolean}, FastifyCookie: {options: {}, enabled: boolean}, FastifyCors: {options: {origin: string}, enabled: boolean}, FastifyRateLimit: {options: {}, enabled: boolean}, FastifyJwt: {options: {}, enabled: boolean}, FastifyMultipart: {options: {}, enabled: boolean}, FastifyLog: {options: {}, enabled: boolean}, FastifyFormBody: {options: {}, enabled: boolean}, FastifyHelmet: {options: {contentSecurityPolicy: boolean}, enabled: boolean}, FastifyCompress: {options: {global: boolean}, enabled: boolean}, FastifySocketIO: {options: {cors: {origin: string}, perMessageDeflate: boolean}, enabled: boolean}, FastifyPointOfView: {options: {}, enabled: boolean}}, options: {layoutDir: string, distDir: string, backupDir: string, autoloadDir: string, uploadDir: string, appDir: string, srcDir: string, assetsDir: string, publicDir: string}, serverDomain: (Boolean|String), http2: boolean, Webpack: {mode: string, resolve: {extensions: string[]}, module: {rules: [{test: RegExp, use: {loader: string, options: {presets: string[], plugins: string[]}}, exclude: RegExp},{test: RegExp, use: string[]},{test: RegExp, use: [{loader: string},{loader: string}]}]}, target: string}}} config
 * @return {Promise<Object>}
 * @constructor
 */

var Server = /*#__PURE__*/function () {
  var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee49() {
    var config,
        _args49 = arguments;
    return _regenerator["default"].wrap(function _callee49$(_context49) {
      while (1) {
        switch (_context49.prev = _context49.next) {
          case 0:
            config = _args49.length > 0 && _args49[0] !== undefined ? _args49[0] : _Config["default"].Server;
            _context49.next = 3;
            return new Promise( /*#__PURE__*/function () {
              var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(resolve) {
                return _regenerator["default"].wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _context.next = 2;
                        return (0, _isElectron["default"])();

                      case 2:
                        if (!_context.sent) {
                          _context.next = 6;
                          break;
                        }

                        _electronLog["default"].info({
                          state: _Options["default"].READY_STATE,
                          descriptions: "Running Program"
                        });

                        _context.next = 7;
                        break;

                      case 6:
                        mProgressBar.start(43, 0, {
                          state: _Options["default"].READY_STATE,
                          descriptions: "Running Program"
                        });

                      case 7:
                        _context.next = 9;
                        return resolve();

                      case 9:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));

              return function (_x) {
                return _ref2.apply(this, arguments);
              };
            }()).then( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
              return _regenerator["default"].wrap(function _callee2$(_context2) {
                while (1) {
                  switch (_context2.prev = _context2.next) {
                    case 0:
                      _context2.next = 2;
                      return (0, _isElectron["default"])();

                    case 2:
                      if (!_context2.sent) {
                        _context2.next = 6;
                        break;
                      }

                      _electronLog["default"].info({
                        state: _Options["default"].LOADING_STATE,
                        descriptions: "get configuration"
                      });

                      _context2.next = 7;
                      break;

                    case 6:
                      mProgressBar.increment({
                        state: _Options["default"].LOADING_STATE,
                        descriptions: "get configuration"
                      });

                    case 7:
                      _context2.next = 9;
                      return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                    case 9:
                      _context2.next = 11;
                      return _lodash["default"].merge(_indexModuleD["default"].config.Server, config);

                    case 11:
                      configuration = _context2.sent;
                      _indexModuleD["default"].config.Server = configuration;
                      Server.CONFIG = configuration; //######################################################################################################
                      //------------------------------------------------------------------------------------------------------

                      _context2.next = 16;
                      return (0, _isElectron["default"])();

                    case 16:
                      if (!_context2.sent) {
                        _context2.next = 20;
                        break;
                      }

                      _electronLog["default"].info({
                        state: _Options["default"].LOADED_STATE,
                        descriptions: "get configuration"
                      });

                      _context2.next = 21;
                      break;

                    case 20:
                      mProgressBar.increment({
                        state: _Options["default"].LOADED_STATE,
                        descriptions: "get configuration"
                      });

                    case 21:
                      _context2.next = 23;
                      return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                    case 23:
                      return _context2.abrupt("return", true);

                    case 24:
                    case "end":
                      return _context2.stop();
                  }
                }
              }, _callee2);
            }))).then( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee24() {
              var AppEngine, mTime;
              return _regenerator["default"].wrap(function _callee24$(_context24) {
                while (1) {
                  switch (_context24.prev = _context24.next) {
                    case 0:
                      _context24.next = 2;
                      return (0, _isElectron["default"])();

                    case 2:
                      if (!_context24.sent) {
                        _context24.next = 6;
                        break;
                      }

                      _electronLog["default"].info({
                        state: _Options["default"].LOADING_STATE,
                        descriptions: "core server engine"
                      });

                      _context24.next = 7;
                      break;

                    case 6:
                      mProgressBar.increment({
                        state: _Options["default"].LOADING_STATE,
                        descriptions: "core server engine"
                      });

                    case 7:
                      _context24.next = 9;
                      return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                    case 9:
                      _context24.t0 = configuration.serverEngine;
                      _context24.next = _context24.t0 === _Options["default"].HTTP2_CORE_ENGINE ? 12 : _context24.t0 === _Options["default"].EXPRESS_CORE_ENGINE ? 16 : _context24.t0 === _Options["default"].FASTIFY_CORE_ENGINE ? 20 : _context24.t0 === _Options["default"].RESTIFY_CORE_ENGINE ? 48 : _context24.t0 === _Options["default"].REACTJS_CORE_ENGINE ? 49 : _context24.t0 === _Options["default"].SOCKETIO_CORE_ENGINE ? 62 : _context24.t0 === _Options["default"].SOCKETIO_CLIENT_ENGINE ? 75 : _context24.t0 === _Options["default"].UPD_CORE_ENGINE ? 88 : _context24.t0 === _Options["default"].ELECTRON_CORE_ENGINE ? 101 : _context24.t0 === _Options["default"].NTP_CORE_ENGINE ? 114 : _context24.t0 === _Options["default"].NTP_CLIENT_ENGINE ? 127 : 142;
                      break;

                    case 12:
                      //**************************************************/
                      mApp = null;
                      _context24.next = 15;
                      return (0, _HTTP["default"])(configuration).then(function (AppEngine) {
                        mApp = AppEngine;
                      });

                    case 15:
                      return _context24.abrupt("return", mApp);

                    case 16:
                      //**************************************************/
                      mApp = null;
                      _context24.next = 19;
                      return (0, _EXPRESS["default"])(configuration).then( /*#__PURE__*/function () {
                        var _ref5 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(AppEngine) {
                          return _regenerator["default"].wrap(function _callee3$(_context3) {
                            while (1) {
                              switch (_context3.prev = _context3.next) {
                                case 0:
                                  mApp = AppEngine;

                                case 1:
                                case "end":
                                  return _context3.stop();
                              }
                            }
                          }, _callee3);
                        }));

                        return function (_x2) {
                          return _ref5.apply(this, arguments);
                        };
                      }());

                    case 19:
                      return _context24.abrupt("return", mApp);

                    case 20:
                      if (!configuration.serverEnabled) {
                        _context24.next = 47;
                        break;
                      }

                      _context24.next = 23;
                      return (0, _isElectron["default"])();

                    case 23:
                      if (!_context24.sent) {
                        _context24.next = 27;
                        break;
                      }

                      _electronLog["default"].info({
                        state: _Options["default"].LOADING_STATE,
                        descriptions: "selected [Fastify] core engine"
                      });

                      _context24.next = 28;
                      break;

                    case 27:
                      mProgressBar.increment({
                        state: _Options["default"].LOADING_STATE,
                        descriptions: "selected [Fastify] core engine"
                      });

                    case 28:
                      _context24.next = 30;
                      return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                    case 30:
                      _context24.next = 32;
                      return (0, _FASTIFY["default"])(configuration);

                    case 32:
                      AppEngine = _context24.sent;
                      _context24.next = 35;
                      return (0, _isElectron["default"])();

                    case 35:
                      if (!_context24.sent) {
                        _context24.next = 39;
                        break;
                      }

                      _electronLog["default"].info({
                        state: _Options["default"].LOADED_STATE,
                        descriptions: "selected [Fastify] core engine"
                      });

                      _context24.next = 40;
                      break;

                    case 39:
                      mProgressBar.increment({
                        state: _Options["default"].LOADED_STATE,
                        descriptions: "selected [Fastify] core engine"
                      });

                    case 40:
                      _context24.next = 42;
                      return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                    case 42:
                      _context24.next = 44;
                      return AppEngine.register( /*#__PURE__*/function () {
                        var _ref6 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee9(app, opts, next) {
                          var mAppPointing, appType, fromDirController, mAppHandler, mApp;
                          return _regenerator["default"].wrap(function _callee9$(_context9) {
                            while (1) {
                              switch (_context9.prev = _context9.next) {
                                case 0:
                                  mAppPointing = false;
                                  _context9.next = 3;
                                  return (0, _isElectron["default"])();

                                case 3:
                                  if (!_context9.sent) {
                                    _context9.next = 7;
                                    break;
                                  }

                                  _electronLog["default"].info({
                                    state: _Options["default"].LOADING_STATE,
                                    descriptions: "Pointing Entry System"
                                  });

                                  _context9.next = 8;
                                  break;

                                case 7:
                                  mProgressBar.increment({
                                    state: _Options["default"].LOADING_STATE,
                                    descriptions: "Pointing Entry System"
                                  });

                                case 8:
                                  _context9.next = 10;
                                  return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                case 10:
                                  /** get Configuration.app type variable **/
                                  appType = configuration.app;
                                  /** Checking Variable **/

                                  _context9.t0 = (0, _typeof2["default"])(appType);
                                  _context9.next = _context9.t0 === "boolean" ? 14 : _context9.t0 === "function" ? 38 : 40;
                                  break;

                                case 14:
                                  _context9.t1 = appType;
                                  _context9.next = _context9.t1 === true ? 17 : _context9.t1 === false ? 35 : 37;
                                  break;

                                case 17:
                                  if (!(0, _fs.existsSync)(configuration.options.appDir)) {
                                    _context9.next = 32;
                                    break;
                                  }

                                  if (!(require(configuration.options.appDir)["default"] !== undefined)) {
                                    _context9.next = 28;
                                    break;
                                  }

                                  fromDirController = require(configuration.options.appDir)["default"];

                                  if (!(typeof fromDirController === "function")) {
                                    _context9.next = 24;
                                    break;
                                  }

                                  mAppPointing = require(configuration.options.appDir)["default"];
                                  _context9.next = 26;
                                  break;

                                case 24:
                                  setTimeout( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4() {
                                    return _regenerator["default"].wrap(function _callee4$(_context4) {
                                      while (1) {
                                        switch (_context4.prev = _context4.next) {
                                          case 0:
                                            _context4.next = 2;
                                            return process.exit();

                                          case 2:
                                          case "end":
                                            return _context4.stop();
                                        }
                                      }
                                    }, _callee4);
                                  })), 2000);
                                  throw {
                                    status: false,
                                    code: 500,
                                    msg: "index.js in ".concat(configuration.options.appDir, " folder Illegal Format")
                                  };

                                case 26:
                                  _context9.next = 30;
                                  break;

                                case 28:
                                  setTimeout( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5() {
                                    return _regenerator["default"].wrap(function _callee5$(_context5) {
                                      while (1) {
                                        switch (_context5.prev = _context5.next) {
                                          case 0:
                                            _context5.next = 2;
                                            return process.exit();

                                          case 2:
                                          case "end":
                                            return _context5.stop();
                                        }
                                      }
                                    }, _callee5);
                                  })), 2000);
                                  throw {
                                    status: false,
                                    code: 500,
                                    msg: "index.js in ".concat(configuration.options.appDir, " folder don't have default export")
                                  };

                                case 30:
                                  _context9.next = 34;
                                  break;

                                case 32:
                                  setTimeout( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6() {
                                    return _regenerator["default"].wrap(function _callee6$(_context6) {
                                      while (1) {
                                        switch (_context6.prev = _context6.next) {
                                          case 0:
                                            _context6.next = 2;
                                            return process.exit();

                                          case 2:
                                          case "end":
                                            return _context6.stop();
                                        }
                                      }
                                    }, _callee6);
                                  })), 2000);
                                  throw {
                                    status: false,
                                    code: 500,
                                    msg: "File ".concat(configuration.options.appDir, " don't exist")
                                  };

                                case 34:
                                  return _context9.abrupt("break", 37);

                                case 35:
                                  mAppPointing = /*#__PURE__*/function () {
                                    var _ref10 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7(app, opts, next) {
                                      return _regenerator["default"].wrap(function _callee7$(_context7) {
                                        while (1) {
                                          switch (_context7.prev = _context7.next) {
                                            case 0:
                                              _context7.next = 2;
                                              return next();

                                            case 2:
                                            case "end":
                                              return _context7.stop();
                                          }
                                        }
                                      }, _callee7);
                                    }));

                                    return function mAppPointing(_x6, _x7, _x8) {
                                      return _ref10.apply(this, arguments);
                                    };
                                  }();

                                  return _context9.abrupt("break", 37);

                                case 37:
                                  return _context9.abrupt("break", 42);

                                case 38:
                                  mAppPointing = configuration.app;
                                  return _context9.abrupt("break", 42);

                                case 40:
                                  setTimeout( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee8() {
                                    return _regenerator["default"].wrap(function _callee8$(_context8) {
                                      while (1) {
                                        switch (_context8.prev = _context8.next) {
                                          case 0:
                                            _context8.next = 2;
                                            return process.exit();

                                          case 2:
                                          case "end":
                                            return _context8.stop();
                                        }
                                      }
                                    }, _callee8);
                                  })), 2000);
                                  throw {
                                    status: false,
                                    code: 500,
                                    msg: "Illegal app pointing. app must boolean or function"
                                  };

                                case 42:
                                  _context9.next = 44;
                                  return (0, _isElectron["default"])();

                                case 44:
                                  if (!_context9.sent) {
                                    _context9.next = 48;
                                    break;
                                  }

                                  _electronLog["default"].info({
                                    state: _Options["default"].LOADED_STATE,
                                    descriptions: "Pointing Entry System"
                                  });

                                  _context9.next = 49;
                                  break;

                                case 48:
                                  mProgressBar.increment({
                                    state: _Options["default"].LOADED_STATE,
                                    descriptions: "Pointing Entry System"
                                  });

                                case 49:
                                  _context9.next = 51;
                                  return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                case 51:
                                  _context9.next = 53;
                                  return (0, _isElectron["default"])();

                                case 53:
                                  if (!_context9.sent) {
                                    _context9.next = 57;
                                    break;
                                  }

                                  _electronLog["default"].info({
                                    state: _Options["default"].LOADING_STATE,
                                    descriptions: "Globally Handling"
                                  });

                                  _context9.next = 58;
                                  break;

                                case 57:
                                  mProgressBar.increment({
                                    state: _Options["default"].LOADING_STATE,
                                    descriptions: "Globally Handling"
                                  });

                                case 58:
                                  _context9.next = 60;
                                  return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                case 60:
                                  _context9.next = 62;
                                  return require("./FASTIFY/GlobHandler")["default"](app, configuration);

                                case 62:
                                  mAppHandler = _context9.sent;
                                  _context9.next = 65;
                                  return (0, _isElectron["default"])();

                                case 65:
                                  if (!_context9.sent) {
                                    _context9.next = 69;
                                    break;
                                  }

                                  _electronLog["default"].info({
                                    state: _Options["default"].LOADED_STATE,
                                    descriptions: "Globally Handling"
                                  });

                                  _context9.next = 70;
                                  break;

                                case 69:
                                  mProgressBar.increment({
                                    state: _Options["default"].LOADED_STATE,
                                    descriptions: "Globally Handling"
                                  });

                                case 70:
                                  _context9.next = 72;
                                  return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                case 72:
                                  _context9.next = 74;
                                  return (0, _isElectron["default"])();

                                case 74:
                                  if (!_context9.sent) {
                                    _context9.next = 78;
                                    break;
                                  }

                                  _electronLog["default"].info({
                                    state: _Options["default"].LOADING_STATE,
                                    descriptions: "Middleware Decorators"
                                  });

                                  _context9.next = 79;
                                  break;

                                case 78:
                                  mProgressBar.increment({
                                    state: _Options["default"].LOADING_STATE,
                                    descriptions: "Middleware Decorators"
                                  });

                                case 79:
                                  _context9.next = 81;
                                  return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                case 81:
                                  _context9.next = 83;
                                  return require('./FASTIFY/Decorator')["default"](mAppHandler, configuration);

                                case 83:
                                  mApp = _context9.sent;
                                  _context9.next = 86;
                                  return (0, _isElectron["default"])();

                                case 86:
                                  if (!_context9.sent) {
                                    _context9.next = 90;
                                    break;
                                  }

                                  _electronLog["default"].info({
                                    state: _Options["default"].LOADED_STATE,
                                    descriptions: "Globally Handling"
                                  });

                                  _context9.next = 91;
                                  break;

                                case 90:
                                  mProgressBar.increment({
                                    state: _Options["default"].LOADED_STATE,
                                    descriptions: "Globally Handling"
                                  });

                                case 91:
                                  _context9.next = 93;
                                  return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                case 93:
                                  _context9.next = 95;
                                  return (0, _isElectron["default"])();

                                case 95:
                                  if (!_context9.sent) {
                                    _context9.next = 99;
                                    break;
                                  }

                                  _electronLog["default"].info({
                                    state: _Options["default"].LOADING_STATE,
                                    descriptions: "Finally Pointing"
                                  });

                                  _context9.next = 100;
                                  break;

                                case 99:
                                  mProgressBar.increment({
                                    state: _Options["default"].LOADING_STATE,
                                    descriptions: "Finally Pointing"
                                  });

                                case 100:
                                  _context9.next = 102;
                                  return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                case 102:
                                  _context9.next = 104;
                                  return mApp.register(mAppPointing);

                                case 104:
                                  _context9.next = 106;
                                  return (0, _isElectron["default"])();

                                case 106:
                                  if (!_context9.sent) {
                                    _context9.next = 110;
                                    break;
                                  }

                                  _electronLog["default"].info({
                                    state: _Options["default"].LOADED_STATE,
                                    descriptions: "Finally Pointing"
                                  });

                                  _context9.next = 111;
                                  break;

                                case 110:
                                  mProgressBar.increment({
                                    state: _Options["default"].LOADED_STATE,
                                    descriptions: "Finally Pointing"
                                  });

                                case 111:
                                  _context9.next = 113;
                                  return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                case 113:
                                  _context9.next = 115;
                                  return next();

                                case 115:
                                case "end":
                                  return _context9.stop();
                              }
                            }
                          }, _callee9);
                        }));

                        return function (_x3, _x4, _x5) {
                          return _ref6.apply(this, arguments);
                        };
                      }());

                    case 44:
                      return _context24.abrupt("return", AppEngine);

                    case 47:
                      throw "Project '".concat(configuration.serverName, "' Dinonaktifkan. Set \"serverEnabled\" ke \"true\" Untuk Mengaktifkan");

                    case 48:
                      throw 'not available core engine';

                    case 49:
                      mApp = null;
                      _context24.next = 52;
                      return (0, _isElectron["default"])();

                    case 52:
                      if (!_context24.sent) {
                        _context24.next = 56;
                        break;
                      }

                      _electronLog["default"].info({
                        state: _Options["default"].LOADING_STATE,
                        descriptions: "preparing react core engine"
                      });

                      _context24.next = 57;
                      break;

                    case 56:
                      mProgressBar.increment({
                        state: _Options["default"].LOADING_STATE,
                        descriptions: "preparing react core engine"
                      });

                    case 57:
                      _context24.next = 59;
                      return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                    case 59:
                      _context24.next = 61;
                      return (0, _REACT["default"])(configuration).then( /*#__PURE__*/function () {
                        var _ref12 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee10(AppEngine) {
                          return _regenerator["default"].wrap(function _callee10$(_context10) {
                            while (1) {
                              switch (_context10.prev = _context10.next) {
                                case 0:
                                  mApp = AppEngine;
                                  _context10.next = 3;
                                  return (0, _isElectron["default"])();

                                case 3:
                                  if (!_context10.sent) {
                                    _context10.next = 7;
                                    break;
                                  }

                                  _electronLog["default"].info({
                                    state: _Options["default"].LOADED_STATE,
                                    descriptions: "finish react core engine"
                                  });

                                  _context10.next = 8;
                                  break;

                                case 7:
                                  mProgressBar.increment({
                                    state: _Options["default"].LOADED_STATE,
                                    descriptions: "finish react core engine"
                                  });

                                case 8:
                                  _context10.next = 10;
                                  return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                case 10:
                                case "end":
                                  return _context10.stop();
                              }
                            }
                          }, _callee10);
                        }));

                        return function (_x9) {
                          return _ref12.apply(this, arguments);
                        };
                      }())["catch"]( /*#__PURE__*/function () {
                        var _ref13 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee11(error) {
                          return _regenerator["default"].wrap(function _callee11$(_context11) {
                            while (1) {
                              switch (_context11.prev = _context11.next) {
                                case 0:
                                  throw error;

                                case 1:
                                case "end":
                                  return _context11.stop();
                              }
                            }
                          }, _callee11);
                        }));

                        return function (_x10) {
                          return _ref13.apply(this, arguments);
                        };
                      }());

                    case 61:
                      return _context24.abrupt("return", mApp);

                    case 62:
                      mApp = null;
                      _context24.next = 65;
                      return (0, _isElectron["default"])();

                    case 65:
                      if (!_context24.sent) {
                        _context24.next = 69;
                        break;
                      }

                      _electronLog["default"].info({
                        state: _Options["default"].LOADING_STATE,
                        descriptions: "preparing socket IO engine"
                      });

                      _context24.next = 70;
                      break;

                    case 69:
                      mProgressBar.increment({
                        state: _Options["default"].LOADING_STATE,
                        descriptions: "preparing socket IO engine"
                      });

                    case 70:
                      _context24.next = 72;
                      return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                    case 72:
                      _context24.next = 74;
                      return _SOCKET["default"].Server(configuration).then( /*#__PURE__*/function () {
                        var _ref14 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee12(AppEngine) {
                          return _regenerator["default"].wrap(function _callee12$(_context12) {
                            while (1) {
                              switch (_context12.prev = _context12.next) {
                                case 0:
                                  _context12.next = 2;
                                  return configuration.app(AppEngine.io);

                                case 2:
                                  mApp = AppEngine;
                                  _context12.next = 5;
                                  return (0, _isElectron["default"])();

                                case 5:
                                  if (!_context12.sent) {
                                    _context12.next = 9;
                                    break;
                                  }

                                  _electronLog["default"].info({
                                    state: _Options["default"].LOADED_STATE,
                                    descriptions: "finish Socket IO engine"
                                  });

                                  _context12.next = 10;
                                  break;

                                case 9:
                                  mProgressBar.increment({
                                    state: _Options["default"].LOADED_STATE,
                                    descriptions: "finish Socket IO engine"
                                  });

                                case 10:
                                  _context12.next = 12;
                                  return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                case 12:
                                case "end":
                                  return _context12.stop();
                              }
                            }
                          }, _callee12);
                        }));

                        return function (_x11) {
                          return _ref14.apply(this, arguments);
                        };
                      }())["catch"]( /*#__PURE__*/function () {
                        var _ref15 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee13(error) {
                          return _regenerator["default"].wrap(function _callee13$(_context13) {
                            while (1) {
                              switch (_context13.prev = _context13.next) {
                                case 0:
                                  throw error;

                                case 1:
                                case "end":
                                  return _context13.stop();
                              }
                            }
                          }, _callee13);
                        }));

                        return function (_x12) {
                          return _ref15.apply(this, arguments);
                        };
                      }());

                    case 74:
                      return _context24.abrupt("return", mApp);

                    case 75:
                      mApp = null;
                      _context24.next = 78;
                      return (0, _isElectron["default"])();

                    case 78:
                      if (!_context24.sent) {
                        _context24.next = 82;
                        break;
                      }

                      _electronLog["default"].info({
                        state: _Options["default"].LOADING_STATE,
                        descriptions: "preparing socket IO client"
                      });

                      _context24.next = 83;
                      break;

                    case 82:
                      mProgressBar.increment({
                        state: _Options["default"].LOADING_STATE,
                        descriptions: "preparing socket IO client"
                      });

                    case 83:
                      _context24.next = 85;
                      return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                    case 85:
                      _context24.next = 87;
                      return _SOCKET["default"].Client(configuration).then( /*#__PURE__*/function () {
                        var _ref16 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee14(AppEngine) {
                          return _regenerator["default"].wrap(function _callee14$(_context14) {
                            while (1) {
                              switch (_context14.prev = _context14.next) {
                                case 0:
                                  _context14.next = 2;
                                  return configuration.app(AppEngine.io);

                                case 2:
                                  mApp = AppEngine;
                                  _context14.next = 5;
                                  return (0, _isElectron["default"])();

                                case 5:
                                  if (!_context14.sent) {
                                    _context14.next = 9;
                                    break;
                                  }

                                  _electronLog["default"].info({
                                    state: _Options["default"].LOADED_STATE,
                                    descriptions: "finish Socket IO client"
                                  });

                                  _context14.next = 10;
                                  break;

                                case 9:
                                  mProgressBar.increment({
                                    state: _Options["default"].LOADED_STATE,
                                    descriptions: "finish Socket IO engine"
                                  });

                                case 10:
                                  _context14.next = 12;
                                  return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                case 12:
                                case "end":
                                  return _context14.stop();
                              }
                            }
                          }, _callee14);
                        }));

                        return function (_x13) {
                          return _ref16.apply(this, arguments);
                        };
                      }())["catch"]( /*#__PURE__*/function () {
                        var _ref17 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee15(error) {
                          return _regenerator["default"].wrap(function _callee15$(_context15) {
                            while (1) {
                              switch (_context15.prev = _context15.next) {
                                case 0:
                                  throw error;

                                case 1:
                                case "end":
                                  return _context15.stop();
                              }
                            }
                          }, _callee15);
                        }));

                        return function (_x14) {
                          return _ref17.apply(this, arguments);
                        };
                      }());

                    case 87:
                      return _context24.abrupt("return", mApp);

                    case 88:
                      mApp = null;
                      _context24.next = 91;
                      return (0, _isElectron["default"])();

                    case 91:
                      if (!_context24.sent) {
                        _context24.next = 95;
                        break;
                      }

                      _electronLog["default"].info({
                        state: _Options["default"].LOADING_STATE,
                        descriptions: "preparing socket IO client"
                      });

                      _context24.next = 96;
                      break;

                    case 95:
                      mProgressBar.increment({
                        state: _Options["default"].LOADING_STATE,
                        descriptions: "preparing socket IO client"
                      });

                    case 96:
                      _context24.next = 98;
                      return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                    case 98:
                      _context24.next = 100;
                      return _UDP["default"].Server(configuration).then( /*#__PURE__*/function () {
                        var _ref18 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee16(AppEngine) {
                          return _regenerator["default"].wrap(function _callee16$(_context16) {
                            while (1) {
                              switch (_context16.prev = _context16.next) {
                                case 0:
                                  _context16.next = 2;
                                  return configuration.app(AppEngine);

                                case 2:
                                  mApp = AppEngine;
                                  _context16.next = 5;
                                  return (0, _isElectron["default"])();

                                case 5:
                                  if (!_context16.sent) {
                                    _context16.next = 9;
                                    break;
                                  }

                                  _electronLog["default"].info({
                                    state: _Options["default"].LOADED_STATE,
                                    descriptions: "finish Socket IO client"
                                  });

                                  _context16.next = 10;
                                  break;

                                case 9:
                                  mProgressBar.increment({
                                    state: _Options["default"].LOADED_STATE,
                                    descriptions: "finish Socket IO engine"
                                  });

                                case 10:
                                  _context16.next = 12;
                                  return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                case 12:
                                case "end":
                                  return _context16.stop();
                              }
                            }
                          }, _callee16);
                        }));

                        return function (_x15) {
                          return _ref18.apply(this, arguments);
                        };
                      }())["catch"]( /*#__PURE__*/function () {
                        var _ref19 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee17(error) {
                          return _regenerator["default"].wrap(function _callee17$(_context17) {
                            while (1) {
                              switch (_context17.prev = _context17.next) {
                                case 0:
                                  throw error;

                                case 1:
                                case "end":
                                  return _context17.stop();
                              }
                            }
                          }, _callee17);
                        }));

                        return function (_x16) {
                          return _ref19.apply(this, arguments);
                        };
                      }());

                    case 100:
                      return _context24.abrupt("return", mApp);

                    case 101:
                      mApp = null;
                      _context24.next = 104;
                      return (0, _isElectron["default"])();

                    case 104:
                      if (!_context24.sent) {
                        _context24.next = 108;
                        break;
                      }

                      _electronLog["default"].info({
                        state: _Options["default"].LOADING_STATE,
                        descriptions: "preparing socket IO client"
                      });

                      _context24.next = 109;
                      break;

                    case 108:
                      mProgressBar.increment({
                        state: _Options["default"].LOADING_STATE,
                        descriptions: "preparing socket IO client"
                      });

                    case 109:
                      _context24.next = 111;
                      return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                    case 111:
                      _context24.next = 113;
                      return (0, _ELECTRON["default"])(configuration).then( /*#__PURE__*/function () {
                        var _ref20 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee18(AppEngine) {
                          return _regenerator["default"].wrap(function _callee18$(_context18) {
                            while (1) {
                              switch (_context18.prev = _context18.next) {
                                case 0:
                                  mApp = AppEngine;
                                  _context18.next = 3;
                                  return (0, _isElectron["default"])();

                                case 3:
                                  if (!_context18.sent) {
                                    _context18.next = 7;
                                    break;
                                  }

                                  _electronLog["default"].info({
                                    state: _Options["default"].LOADED_STATE,
                                    descriptions: "finish Socket IO client"
                                  });

                                  _context18.next = 8;
                                  break;

                                case 7:
                                  mProgressBar.increment({
                                    state: _Options["default"].LOADED_STATE,
                                    descriptions: "finish Socket IO engine"
                                  });

                                case 8:
                                  _context18.next = 10;
                                  return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                case 10:
                                case "end":
                                  return _context18.stop();
                              }
                            }
                          }, _callee18);
                        }));

                        return function (_x17) {
                          return _ref20.apply(this, arguments);
                        };
                      }())["catch"]( /*#__PURE__*/function () {
                        var _ref21 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee19(error) {
                          return _regenerator["default"].wrap(function _callee19$(_context19) {
                            while (1) {
                              switch (_context19.prev = _context19.next) {
                                case 0:
                                  throw error;

                                case 1:
                                case "end":
                                  return _context19.stop();
                              }
                            }
                          }, _callee19);
                        }));

                        return function (_x18) {
                          return _ref21.apply(this, arguments);
                        };
                      }());

                    case 113:
                      return _context24.abrupt("return", mApp);

                    case 114:
                      mApp = null;
                      _context24.next = 117;
                      return (0, _isElectron["default"])();

                    case 117:
                      if (!_context24.sent) {
                        _context24.next = 121;
                        break;
                      }

                      _electronLog["default"].info({
                        state: _Options["default"].LOADING_STATE,
                        descriptions: "preparing NTP Server engine"
                      });

                      _context24.next = 122;
                      break;

                    case 121:
                      mProgressBar.increment({
                        state: _Options["default"].LOADING_STATE,
                        descriptions: "preparing NTP Server engine"
                      });

                    case 122:
                      _context24.next = 124;
                      return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                    case 124:
                      _context24.next = 126;
                      return _NTP["default"].Server(configuration).then( /*#__PURE__*/function () {
                        var _ref22 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee20(AppEngine) {
                          return _regenerator["default"].wrap(function _callee20$(_context20) {
                            while (1) {
                              switch (_context20.prev = _context20.next) {
                                case 0:
                                  _context20.next = 2;
                                  return configuration.app(AppEngine);

                                case 2:
                                  mApp = AppEngine;
                                  _context20.next = 5;
                                  return (0, _isElectron["default"])();

                                case 5:
                                  if (!_context20.sent) {
                                    _context20.next = 9;
                                    break;
                                  }

                                  _electronLog["default"].info({
                                    state: _Options["default"].LOADED_STATE,
                                    descriptions: "finish NTP engine"
                                  });

                                  _context20.next = 10;
                                  break;

                                case 9:
                                  mProgressBar.increment({
                                    state: _Options["default"].LOADED_STATE,
                                    descriptions: "finish Socket IO engine"
                                  });

                                case 10:
                                  _context20.next = 12;
                                  return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                case 12:
                                case "end":
                                  return _context20.stop();
                              }
                            }
                          }, _callee20);
                        }));

                        return function (_x19) {
                          return _ref22.apply(this, arguments);
                        };
                      }())["catch"]( /*#__PURE__*/function () {
                        var _ref23 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee21(error) {
                          return _regenerator["default"].wrap(function _callee21$(_context21) {
                            while (1) {
                              switch (_context21.prev = _context21.next) {
                                case 0:
                                  throw error;

                                case 1:
                                case "end":
                                  return _context21.stop();
                              }
                            }
                          }, _callee21);
                        }));

                        return function (_x20) {
                          return _ref23.apply(this, arguments);
                        };
                      }());

                    case 126:
                      return _context24.abrupt("return", mApp);

                    case 127:
                      _context24.next = 129;
                      return (0, _isElectron["default"])();

                    case 129:
                      if (!_context24.sent) {
                        _context24.next = 133;
                        break;
                      }

                      _electronLog["default"].info({
                        state: _Options["default"].LOADING_STATE,
                        descriptions: "preparing NTP Client engine"
                      });

                      _context24.next = 134;
                      break;

                    case 133:
                      mProgressBar.increment({
                        state: _Options["default"].LOADING_STATE,
                        descriptions: "preparing NTP Client engine"
                      });

                    case 134:
                      _context24.next = 136;
                      return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                    case 136:
                      _context24.next = 138;
                      return _NTP["default"].Client(configuration);

                    case 138:
                      mTime = _context24.sent;
                      mTime.syncTime().then( /*#__PURE__*/function () {
                        var _ref24 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee22(ntpPacket) {
                          return _regenerator["default"].wrap(function _callee22$(_context22) {
                            while (1) {
                              switch (_context22.prev = _context22.next) {
                                case 0:
                                  _context22.next = 2;
                                  return configuration.app(null, ntpPacket);

                                case 2:
                                case "end":
                                  return _context22.stop();
                              }
                            }
                          }, _callee22);
                        }));

                        return function (_x21) {
                          return _ref24.apply(this, arguments);
                        };
                      }())["catch"]( /*#__PURE__*/function () {
                        var _ref25 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee23(error) {
                          return _regenerator["default"].wrap(function _callee23$(_context23) {
                            while (1) {
                              switch (_context23.prev = _context23.next) {
                                case 0:
                                  _context23.next = 2;
                                  return configuration.app(error);

                                case 2:
                                case "end":
                                  return _context23.stop();
                              }
                            }
                          }, _callee23);
                        }));

                        return function (_x22) {
                          return _ref25.apply(this, arguments);
                        };
                      }());
                      mProgressBar.stop();
                      return _context24.abrupt("return", true);

                    case 142:
                      throw ' Server Engine Unknown';

                    case 143:
                    case "end":
                      return _context24.stop();
                  }
                }
              }, _callee24);
            }))).then( /*#__PURE__*/function () {
              var _ref26 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee48(AppEngine) {
                return _regenerator["default"].wrap(function _callee48$(_context48) {
                  while (1) {
                    switch (_context48.prev = _context48.next) {
                      case 0:
                        _context48.t0 = configuration.serverEngine;
                        _context48.next = _context48.t0 === _Options["default"].FASTIFY_CORE_ENGINE ? 3 : _context48.t0 === _Options["default"].REACTJS_CORE_ENGINE ? 15 : _context48.t0 === _Options["default"].SOCKETIO_CORE_ENGINE ? 27 : _context48.t0 === _Options["default"].SOCKETIO_CLIENT_ENGINE ? 39 : _context48.t0 === _Options["default"].UPD_CORE_ENGINE ? 51 : _context48.t0 === _Options["default"].ELECTRON_CORE_ENGINE ? 63 : _context48.t0 === _Options["default"].NTP_CORE_ENGINE ? 75 : _context48.t0 === _Options["default"].NTP_CLIENT_ENGINE ? 87 : 89;
                        break;

                      case 3:
                        _context48.next = 5;
                        return (0, _isElectron["default"])();

                      case 5:
                        if (!_context48.sent) {
                          _context48.next = 9;
                          break;
                        }

                        _electronLog["default"].info({
                          state: _Options["default"].LOADING_STATE,
                          descriptions: "Listening Service"
                        });

                        _context48.next = 10;
                        break;

                      case 9:
                        mProgressBar.increment({
                          state: _Options["default"].LOADING_STATE,
                          descriptions: "Listening Service"
                        });

                      case 10:
                        _context48.next = 12;
                        return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                      case 12:
                        _context48.next = 14;
                        return new Promise( /*#__PURE__*/function () {
                          var _ref27 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee32(resolve, rejected) {
                            return _regenerator["default"].wrap(function _callee32$(_context32) {
                              while (1) {
                                switch (_context32.prev = _context32.next) {
                                  case 0:
                                    _context32.next = 2;
                                    return AppEngine.listen(configuration.serverPort, configuration.serverHost, /*#__PURE__*/function () {
                                      var _ref28 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee31(err, address) {
                                        var response;
                                        return _regenerator["default"].wrap(function _callee31$(_context31) {
                                          while (1) {
                                            switch (_context31.prev = _context31.next) {
                                              case 0:
                                                if (err) {
                                                  _context31.next = 20;
                                                  break;
                                                }

                                                if (!(configuration.settings.ngrok.enabled === true)) {
                                                  _context31.next = 5;
                                                  break;
                                                }

                                                Promise.resolve().then(function () {
                                                  return _interopRequireWildcard(require("ngrok"));
                                                }).then( /*#__PURE__*/function () {
                                                  var _ref29 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee27(ngrok) {
                                                    var api;
                                                    return _regenerator["default"].wrap(function _callee27$(_context27) {
                                                      while (1) {
                                                        switch (_context27.prev = _context27.next) {
                                                          case 0:
                                                            _context27.next = 2;
                                                            return ngrok.connect({
                                                              addr: configuration.serverPort,
                                                              authtoken: configuration.settings.ngrok.authToken,
                                                              onStatusChange: function onStatusChange(_) {},
                                                              onLogEvent: function onLogEvent(_) {}
                                                            })["catch"](function (e) {
                                                              rejected(e.toString());
                                                            });

                                                          case 2:
                                                            api = ngrok.getApi();
                                                            _context27.next = 5;
                                                            return api.listTunnels().then( /*#__PURE__*/function () {
                                                              var _ref30 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee25(result) {
                                                                var response;
                                                                return _regenerator["default"].wrap(function _callee25$(_context25) {
                                                                  while (1) {
                                                                    switch (_context25.prev = _context25.next) {
                                                                      case 0:
                                                                        response = JSON.stringify({
                                                                          status: true,
                                                                          msg: "Berhasil",
                                                                          text: "Aplikasi '".concat(configuration.serverName, "' Server Dengan Alamat ").concat(address),
                                                                          Ngrok: [result.tunnels[1].public_url, result.tunnels[0].public_url]
                                                                        });
                                                                        _context25.next = 3;
                                                                        return resolve(response);

                                                                      case 3:
                                                                      case "end":
                                                                        return _context25.stop();
                                                                    }
                                                                  }
                                                                }, _callee25);
                                                              }));

                                                              return function (_x29) {
                                                                return _ref30.apply(this, arguments);
                                                              };
                                                            }())["catch"]( /*#__PURE__*/function () {
                                                              var _ref31 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee26(error) {
                                                                var response;
                                                                return _regenerator["default"].wrap(function _callee26$(_context26) {
                                                                  while (1) {
                                                                    switch (_context26.prev = _context26.next) {
                                                                      case 0:
                                                                        response = JSON.stringify({
                                                                          status: true,
                                                                          msg: "Berhasil",
                                                                          text: "Aplikasi '".concat(configuration.serverName, "' Server Dengan Alamat ").concat(address),
                                                                          Ngrok: {
                                                                            error: error
                                                                          }
                                                                        });
                                                                        _context26.next = 3;
                                                                        return resolve(response);

                                                                      case 3:
                                                                      case "end":
                                                                        return _context26.stop();
                                                                    }
                                                                  }
                                                                }, _callee26);
                                                              }));

                                                              return function (_x30) {
                                                                return _ref31.apply(this, arguments);
                                                              };
                                                            }());

                                                          case 5:
                                                          case "end":
                                                            return _context27.stop();
                                                        }
                                                      }
                                                    }, _callee27);
                                                  }));

                                                  return function (_x28) {
                                                    return _ref29.apply(this, arguments);
                                                  };
                                                }())["catch"]( /*#__PURE__*/function () {
                                                  var _ref32 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee28(error) {
                                                    return _regenerator["default"].wrap(function _callee28$(_context28) {
                                                      while (1) {
                                                        switch (_context28.prev = _context28.next) {
                                                          case 0:
                                                            rejected({
                                                              status: false,
                                                              code: 500,
                                                              msg: "module \"ngrok\" not exist or not Installed. please install ngrok module",
                                                              error: error
                                                            });

                                                          case 1:
                                                          case "end":
                                                            return _context28.stop();
                                                        }
                                                      }
                                                    }, _callee28);
                                                  }));

                                                  return function (_x31) {
                                                    return _ref32.apply(this, arguments);
                                                  };
                                                }());
                                                _context31.next = 18;
                                                break;

                                              case 5:
                                                if (!configuration.settings.localtunnel) {
                                                  _context31.next = 9;
                                                  break;
                                                }

                                                Promise.resolve().then(function () {
                                                  return _interopRequireWildcard(require("localtunnel"));
                                                }).then( /*#__PURE__*/function () {
                                                  var _ref33 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee29(localtunnel) {
                                                    var tunnel, response;
                                                    return _regenerator["default"].wrap(function _callee29$(_context29) {
                                                      while (1) {
                                                        switch (_context29.prev = _context29.next) {
                                                          case 0:
                                                            _context29.next = 2;
                                                            return localtunnel({
                                                              port: configuration.serverPort
                                                            });

                                                          case 2:
                                                            tunnel = _context29.sent;
                                                            response = JSON.stringify({
                                                              status: true,
                                                              msg: "Berhasil",
                                                              text: "Aplikasi '".concat(configuration.serverName, "' Server Dengan Alamat ").concat(address),
                                                              Localtunnel: tunnel.url
                                                            });
                                                            _context29.next = 6;
                                                            return mProgressBar.increment({
                                                              state: _Options["default"].COMPLETE_STATE,
                                                              descriptions: "Listening Service"
                                                            });

                                                          case 6:
                                                            _context29.next = 8;
                                                            return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                                          case 8:
                                                            _context29.next = 10;
                                                            return resolve(response);

                                                          case 10:
                                                            _context29.next = 12;
                                                            return mProgressBar.stop();

                                                          case 12:
                                                          case "end":
                                                            return _context29.stop();
                                                        }
                                                      }
                                                    }, _callee29);
                                                  }));

                                                  return function (_x32) {
                                                    return _ref33.apply(this, arguments);
                                                  };
                                                }())["catch"]( /*#__PURE__*/function () {
                                                  var _ref34 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee30(error) {
                                                    return _regenerator["default"].wrap(function _callee30$(_context30) {
                                                      while (1) {
                                                        switch (_context30.prev = _context30.next) {
                                                          case 0:
                                                            rejected({
                                                              status: false,
                                                              code: 500,
                                                              msg: "module \"localtunnel\" not exist or not Installed. please install localtunnel module",
                                                              error: error
                                                            });

                                                          case 1:
                                                          case "end":
                                                            return _context30.stop();
                                                        }
                                                      }
                                                    }, _callee30);
                                                  }));

                                                  return function (_x33) {
                                                    return _ref34.apply(this, arguments);
                                                  };
                                                }());
                                                _context31.next = 18;
                                                break;

                                              case 9:
                                                response = JSON.stringify({
                                                  status: true,
                                                  msg: "Berhasil",
                                                  text: "Aplikasi '".concat(configuration.serverName, "' Server Dengan Alamat ").concat(address)
                                                });
                                                _context31.next = 12;
                                                return mProgressBar.increment({
                                                  state: _Options["default"].COMPLETE_STATE,
                                                  descriptions: "Listening Service"
                                                });

                                              case 12:
                                                _context31.next = 14;
                                                return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                              case 14:
                                                _context31.next = 16;
                                                return resolve(response);

                                              case 16:
                                                _context31.next = 18;
                                                return mProgressBar.stop();

                                              case 18:
                                                _context31.next = 24;
                                                break;

                                              case 20:
                                                _context31.next = 22;
                                                return rejected(JSON.stringify(err));

                                              case 22:
                                                _context31.next = 24;
                                                return mProgressBar.stop();

                                              case 24:
                                              case "end":
                                                return _context31.stop();
                                            }
                                          }
                                        }, _callee31);
                                      }));

                                      return function (_x26, _x27) {
                                        return _ref28.apply(this, arguments);
                                      };
                                    }());

                                  case 2:
                                  case "end":
                                    return _context32.stop();
                                }
                              }
                            }, _callee32);
                          }));

                          return function (_x24, _x25) {
                            return _ref27.apply(this, arguments);
                          };
                        }()).then(function (result) {
                          if (configuration.serverState === _Options["default"].SERVER_STATE_DEVELOPMENT) {
                            console.log(result);
                          }
                        })["catch"]( /*#__PURE__*/function () {
                          var _ref35 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee33(error) {
                            return _regenerator["default"].wrap(function _callee33$(_context33) {
                              while (1) {
                                switch (_context33.prev = _context33.next) {
                                  case 0:
                                    if (configuration.serverState === _Options["default"].SERVER_STATE_DEVELOPMENT) {
                                      console.error(error);
                                    }

                                  case 1:
                                  case "end":
                                    return _context33.stop();
                                }
                              }
                            }, _callee33);
                          }));

                          return function (_x34) {
                            return _ref35.apply(this, arguments);
                          };
                        }());

                      case 14:
                        return _context48.abrupt("return", _context48.sent);

                      case 15:
                        _context48.next = 17;
                        return (0, _isElectron["default"])();

                      case 17:
                        if (!_context48.sent) {
                          _context48.next = 21;
                          break;
                        }

                        _electronLog["default"].info({
                          state: _Options["default"].LOADING_STATE,
                          descriptions: "start engine webpackDev"
                        });

                        _context48.next = 22;
                        break;

                      case 21:
                        mProgressBar.increment({
                          state: _Options["default"].LOADING_STATE,
                          descriptions: "start engine webpackDev"
                        });

                      case 22:
                        _context48.next = 24;
                        return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                      case 24:
                        _context48.next = 26;
                        return AppEngine.start().then(function (result) {
                          if (configuration.serverState === _Options["default"].SERVER_STATE_DEVELOPMENT) {
                            console.log(result);
                          }
                        })["catch"]( /*#__PURE__*/function () {
                          var _ref36 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee34(error) {
                            return _regenerator["default"].wrap(function _callee34$(_context34) {
                              while (1) {
                                switch (_context34.prev = _context34.next) {
                                  case 0:
                                    if (configuration.serverState === _Options["default"].SERVER_STATE_DEVELOPMENT) {
                                      console.error(error);
                                    }

                                  case 1:
                                  case "end":
                                    return _context34.stop();
                                }
                              }
                            }, _callee34);
                          }));

                          return function (_x35) {
                            return _ref36.apply(this, arguments);
                          };
                        }());

                      case 26:
                        return _context48.abrupt("break", 90);

                      case 27:
                        _context48.next = 29;
                        return (0, _isElectron["default"])();

                      case 29:
                        if (!_context48.sent) {
                          _context48.next = 33;
                          break;
                        }

                        _electronLog["default"].info({
                          state: _Options["default"].LOADING_STATE,
                          descriptions: "Listening Service"
                        });

                        _context48.next = 34;
                        break;

                      case 33:
                        mProgressBar.increment({
                          state: _Options["default"].LOADING_STATE,
                          descriptions: "Listening Service"
                        });

                      case 34:
                        _context48.next = 36;
                        return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                      case 36:
                        _context48.next = 38;
                        return new Promise( /*#__PURE__*/function () {
                          var _ref37 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee36(resolve, rejected) {
                            return _regenerator["default"].wrap(function _callee36$(_context36) {
                              while (1) {
                                switch (_context36.prev = _context36.next) {
                                  case 0:
                                    _context36.next = 2;
                                    return AppEngine.http.listen(configuration.serverPort, configuration.serverHost, /*#__PURE__*/function () {
                                      var _ref38 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee35(error) {
                                        return _regenerator["default"].wrap(function _callee35$(_context35) {
                                          while (1) {
                                            switch (_context35.prev = _context35.next) {
                                              case 0:
                                                if (error) {
                                                  _context35.next = 11;
                                                  break;
                                                }

                                                _context35.next = 3;
                                                return mProgressBar.increment({
                                                  state: _Options["default"].COMPLETE_STATE,
                                                  descriptions: "Listening Service"
                                                });

                                              case 3:
                                                _context35.next = 5;
                                                return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                              case 5:
                                                _context35.next = 7;
                                                return resolve({
                                                  status: true,
                                                  code: 200,
                                                  msg: "Successfully To Running Server Socket Io Engine"
                                                });

                                              case 7:
                                                _context35.next = 9;
                                                return mProgressBar.stop();

                                              case 9:
                                                _context35.next = 15;
                                                break;

                                              case 11:
                                                _context35.next = 13;
                                                return rejected({
                                                  status: false,
                                                  code: 500,
                                                  msg: "Error Running Server Socket Io Engine",
                                                  error: error
                                                });

                                              case 13:
                                                _context35.next = 15;
                                                return mProgressBar.stop();

                                              case 15:
                                              case "end":
                                                return _context35.stop();
                                            }
                                          }
                                        }, _callee35);
                                      }));

                                      return function (_x38) {
                                        return _ref38.apply(this, arguments);
                                      };
                                    }());

                                  case 2:
                                  case "end":
                                    return _context36.stop();
                                }
                              }
                            }, _callee36);
                          }));

                          return function (_x36, _x37) {
                            return _ref37.apply(this, arguments);
                          };
                        }()).then(function (result) {
                          if (configuration.serverState === _Options["default"].SERVER_STATE_DEVELOPMENT) {
                            console.log(result);
                          }
                        })["catch"]( /*#__PURE__*/function () {
                          var _ref39 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee37(error) {
                            return _regenerator["default"].wrap(function _callee37$(_context37) {
                              while (1) {
                                switch (_context37.prev = _context37.next) {
                                  case 0:
                                    if (configuration.serverState === _Options["default"].SERVER_STATE_DEVELOPMENT) {
                                      console.error(error);
                                    }

                                  case 1:
                                  case "end":
                                    return _context37.stop();
                                }
                              }
                            }, _callee37);
                          }));

                          return function (_x39) {
                            return _ref39.apply(this, arguments);
                          };
                        }());

                      case 38:
                        return _context48.abrupt("return", _context48.sent);

                      case 39:
                        _context48.next = 41;
                        return (0, _isElectron["default"])();

                      case 41:
                        if (!_context48.sent) {
                          _context48.next = 45;
                          break;
                        }

                        _electronLog["default"].info({
                          state: _Options["default"].LOADING_STATE,
                          descriptions: "Listening Service"
                        });

                        _context48.next = 46;
                        break;

                      case 45:
                        mProgressBar.increment({
                          state: _Options["default"].LOADING_STATE,
                          descriptions: "Listening Service"
                        });

                      case 46:
                        _context48.next = 48;
                        return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                      case 48:
                        _context48.next = 50;
                        return new Promise( /*#__PURE__*/function () {
                          var _ref40 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee38(resolve) {
                            return _regenerator["default"].wrap(function _callee38$(_context38) {
                              while (1) {
                                switch (_context38.prev = _context38.next) {
                                  case 0:
                                    _context38.next = 2;
                                    return mProgressBar.increment({
                                      state: _Options["default"].COMPLETE_STATE,
                                      descriptions: "Listening Service"
                                    });

                                  case 2:
                                    _context38.next = 4;
                                    return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                  case 4:
                                    _context38.next = 6;
                                    return resolve({
                                      status: true,
                                      code: 200,
                                      msg: "Successfully To Running Server Socket Io Client"
                                    });

                                  case 6:
                                    _context38.next = 8;
                                    return mProgressBar.stop();

                                  case 8:
                                  case "end":
                                    return _context38.stop();
                                }
                              }
                            }, _callee38);
                          }));

                          return function (_x40) {
                            return _ref40.apply(this, arguments);
                          };
                        }()).then(function (result) {
                          if (configuration.serverState === _Options["default"].SERVER_STATE_DEVELOPMENT) {
                            console.log(result);
                          }
                        })["catch"]( /*#__PURE__*/function () {
                          var _ref41 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee39(error) {
                            return _regenerator["default"].wrap(function _callee39$(_context39) {
                              while (1) {
                                switch (_context39.prev = _context39.next) {
                                  case 0:
                                    if (configuration.serverState === _Options["default"].SERVER_STATE_DEVELOPMENT) {
                                      console.error(error);
                                    }

                                  case 1:
                                  case "end":
                                    return _context39.stop();
                                }
                              }
                            }, _callee39);
                          }));

                          return function (_x41) {
                            return _ref41.apply(this, arguments);
                          };
                        }());

                      case 50:
                        return _context48.abrupt("return", _context48.sent);

                      case 51:
                        _context48.next = 53;
                        return (0, _isElectron["default"])();

                      case 53:
                        if (!_context48.sent) {
                          _context48.next = 57;
                          break;
                        }

                        _electronLog["default"].info({
                          state: _Options["default"].LOADING_STATE,
                          descriptions: "Listening Service"
                        });

                        _context48.next = 58;
                        break;

                      case 57:
                        mProgressBar.increment({
                          state: _Options["default"].LOADING_STATE,
                          descriptions: "Listening Service"
                        });

                      case 58:
                        _context48.next = 60;
                        return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                      case 60:
                        _context48.next = 62;
                        return new Promise( /*#__PURE__*/function () {
                          var _ref42 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee41(resolve, rejected) {
                            return _regenerator["default"].wrap(function _callee41$(_context41) {
                              while (1) {
                                switch (_context41.prev = _context41.next) {
                                  case 0:
                                    AppEngine.on("listening", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee40() {
                                      return _regenerator["default"].wrap(function _callee40$(_context40) {
                                        while (1) {
                                          switch (_context40.prev = _context40.next) {
                                            case 0:
                                              _context40.next = 2;
                                              return mProgressBar.increment({
                                                state: _Options["default"].COMPLETE_STATE,
                                                descriptions: "Listening Service"
                                              });

                                            case 2:
                                              _context40.next = 4;
                                              return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                            case 4:
                                              _context40.next = 6;
                                              return resolve({
                                                status: true,
                                                code: 200,
                                                msg: "Successfully To Running Server UDP Engine"
                                              });

                                            case 6:
                                              _context40.next = 8;
                                              return mProgressBar.stop();

                                            case 8:
                                            case "end":
                                              return _context40.stop();
                                          }
                                        }
                                      }, _callee40);
                                    })));
                                    AppEngine.bind({
                                      port: configuration.serverPort,
                                      address: configuration.serverHost,
                                      exclusive: configuration.settings.exclusive
                                    });

                                  case 2:
                                  case "end":
                                    return _context41.stop();
                                }
                              }
                            }, _callee41);
                          }));

                          return function (_x42, _x43) {
                            return _ref42.apply(this, arguments);
                          };
                        }()).then(function (result) {
                          if (configuration.serverState === _Options["default"].SERVER_STATE_DEVELOPMENT) {
                            console.log(result);
                          }
                        })["catch"]( /*#__PURE__*/function () {
                          var _ref44 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee42(error) {
                            return _regenerator["default"].wrap(function _callee42$(_context42) {
                              while (1) {
                                switch (_context42.prev = _context42.next) {
                                  case 0:
                                    if (configuration.serverState === _Options["default"].SERVER_STATE_DEVELOPMENT) {
                                      console.error(error);
                                    }

                                  case 1:
                                  case "end":
                                    return _context42.stop();
                                }
                              }
                            }, _callee42);
                          }));

                          return function (_x44) {
                            return _ref44.apply(this, arguments);
                          };
                        }());

                      case 62:
                        return _context48.abrupt("return", _context48.sent);

                      case 63:
                        _context48.next = 65;
                        return (0, _isElectron["default"])();

                      case 65:
                        if (!_context48.sent) {
                          _context48.next = 69;
                          break;
                        }

                        _electronLog["default"].info({
                          state: _Options["default"].LOADING_STATE,
                          descriptions: "Listening Service"
                        });

                        _context48.next = 70;
                        break;

                      case 69:
                        mProgressBar.increment({
                          state: _Options["default"].LOADING_STATE,
                          descriptions: "Listening Service"
                        });

                      case 70:
                        _context48.next = 72;
                        return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                      case 72:
                        _context48.next = 74;
                        return new Promise( /*#__PURE__*/function () {
                          var _ref45 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee44(resolve, rejected) {
                            return _regenerator["default"].wrap(function _callee44$(_context44) {
                              while (1) {
                                switch (_context44.prev = _context44.next) {
                                  case 0:
                                    AppEngine.on("spawn", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee43() {
                                      return _regenerator["default"].wrap(function _callee43$(_context43) {
                                        while (1) {
                                          switch (_context43.prev = _context43.next) {
                                            case 0:
                                              _context43.next = 2;
                                              return mProgressBar.increment({
                                                state: _Options["default"].COMPLETE_STATE,
                                                descriptions: "Listening Service"
                                              });

                                            case 2:
                                              _context43.next = 4;
                                              return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                            case 4:
                                              _context43.next = 6;
                                              return resolve({
                                                status: true,
                                                code: 200,
                                                msg: "Successfully To Running Server UDP Engine"
                                              });

                                            case 6:
                                              _context43.next = 8;
                                              return mProgressBar.stop();

                                            case 8:
                                            case "end":
                                              return _context43.stop();
                                          }
                                        }
                                      }, _callee43);
                                    })));

                                  case 1:
                                  case "end":
                                    return _context44.stop();
                                }
                              }
                            }, _callee44);
                          }));

                          return function (_x45, _x46) {
                            return _ref45.apply(this, arguments);
                          };
                        }()).then(function (result) {
                          if (configuration.serverState === _Options["default"].SERVER_STATE_DEVELOPMENT) {
                            console.log(result);
                          }
                        })["catch"]( /*#__PURE__*/function () {
                          var _ref47 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee45(error) {
                            return _regenerator["default"].wrap(function _callee45$(_context45) {
                              while (1) {
                                switch (_context45.prev = _context45.next) {
                                  case 0:
                                    if (configuration.serverState === _Options["default"].SERVER_STATE_DEVELOPMENT) {
                                      console.error(error);
                                    }

                                  case 1:
                                  case "end":
                                    return _context45.stop();
                                }
                              }
                            }, _callee45);
                          }));

                          return function (_x47) {
                            return _ref47.apply(this, arguments);
                          };
                        }());

                      case 74:
                        return _context48.abrupt("return", _context48.sent);

                      case 75:
                        _context48.next = 77;
                        return (0, _isElectron["default"])();

                      case 77:
                        if (!_context48.sent) {
                          _context48.next = 81;
                          break;
                        }

                        _electronLog["default"].info({
                          state: _Options["default"].LOADING_STATE,
                          descriptions: "Listening Service"
                        });

                        _context48.next = 82;
                        break;

                      case 81:
                        mProgressBar.increment({
                          state: _Options["default"].LOADING_STATE,
                          descriptions: "Listening Service"
                        });

                      case 82:
                        _context48.next = 84;
                        return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                      case 84:
                        _context48.next = 86;
                        return new Promise( /*#__PURE__*/function () {
                          var _ref48 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee47(resolve, rejected) {
                            return _regenerator["default"].wrap(function _callee47$(_context47) {
                              while (1) {
                                switch (_context47.prev = _context47.next) {
                                  case 0:
                                    _context47.next = 2;
                                    return AppEngine.listen(configuration.serverPort, /*#__PURE__*/function () {
                                      var _ref49 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee46(error) {
                                        return _regenerator["default"].wrap(function _callee46$(_context46) {
                                          while (1) {
                                            switch (_context46.prev = _context46.next) {
                                              case 0:
                                                if (error) {
                                                  _context46.next = 11;
                                                  break;
                                                }

                                                _context46.next = 3;
                                                return mProgressBar.increment({
                                                  state: _Options["default"].COMPLETE_STATE,
                                                  descriptions: "Listening Service"
                                                });

                                              case 3:
                                                _context46.next = 5;
                                                return (0, _delay["default"])(_Options["default"].DELAY_TIME);

                                              case 5:
                                                _context46.next = 7;
                                                return resolve({
                                                  status: true,
                                                  code: 200,
                                                  msg: "Successfully To Running Server NTP Engine"
                                                });

                                              case 7:
                                                _context46.next = 9;
                                                return mProgressBar.stop();

                                              case 9:
                                                _context46.next = 15;
                                                break;

                                              case 11:
                                                _context46.next = 13;
                                                return rejected({
                                                  status: false,
                                                  code: 500,
                                                  msg: "Error Running Server NTP Engine",
                                                  error: error
                                                });

                                              case 13:
                                                _context46.next = 15;
                                                return mProgressBar.stop();

                                              case 15:
                                              case "end":
                                                return _context46.stop();
                                            }
                                          }
                                        }, _callee46);
                                      }));

                                      return function (_x50) {
                                        return _ref49.apply(this, arguments);
                                      };
                                    }());

                                  case 2:
                                  case "end":
                                    return _context47.stop();
                                }
                              }
                            }, _callee47);
                          }));

                          return function (_x48, _x49) {
                            return _ref48.apply(this, arguments);
                          };
                        }());

                      case 86:
                        return _context48.abrupt("return", _context48.sent);

                      case 87:
                        return _context48.abrupt("return", true);

                      case 89:
                        throw "Server Engine Not Found";

                      case 90:
                      case "end":
                        return _context48.stop();
                    }
                  }
                }, _callee48);
              }));

              return function (_x23) {
                return _ref26.apply(this, arguments);
              };
            }());

          case 3:
            return _context49.abrupt("return", _context49.sent);

          case 4:
          case "end":
            return _context49.stop();
        }
      }
    }, _callee49);
  }));

  return function Server() {
    return _ref.apply(this, arguments);
  };
}();

Server.Autoload = _Autoloads["default"];
var _default = Server;
exports["default"] = _default;
//# sourceMappingURL=index.js.map