'use strict';
'use warning';
/**
 * DKA JS FRAMEWORK
 * @author Yovangga Anandhika
 * @email dhikaprivate@gmail.com
 * @version 1.0
 * @description
 * All Right Reserved.
 * */

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "Api", {
  enumerable: true,
  get: function get() {
    return _Api["default"];
  }
});
Object.defineProperty(exports, "Config", {
  enumerable: true,
  get: function get() {
    return _Config["default"];
  }
});
Object.defineProperty(exports, "Database", {
  enumerable: true,
  get: function get() {
    return _Database["default"];
  }
});
Object.defineProperty(exports, "Document", {
  enumerable: true,
  get: function get() {
    return _Document["default"];
  }
});
Object.defineProperty(exports, "Functions", {
  enumerable: true,
  get: function get() {
    return _Functions["default"];
  }
});
Object.defineProperty(exports, "Hardware", {
  enumerable: true,
  get: function get() {
    return _Hardware["default"];
  }
});
Object.defineProperty(exports, "Helper", {
  enumerable: true,
  get: function get() {
    return _Helper["default"];
  }
});
Object.defineProperty(exports, "Networking", {
  enumerable: true,
  get: function get() {
    return _Networking["default"];
  }
});
Object.defineProperty(exports, "Options", {
  enumerable: true,
  get: function get() {
    return _Options["default"];
  }
});
Object.defineProperty(exports, "Security", {
  enumerable: true,
  get: function get() {
    return _Security["default"];
  }
});
Object.defineProperty(exports, "Server", {
  enumerable: true,
  get: function get() {
    return _Server["default"];
  }
});
Object.defineProperty(exports, "Utils", {
  enumerable: true,
  get: function get() {
    return _Utils["default"];
  }
});
exports["default"] = exports.Version = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _Functions = _interopRequireDefault(require("./Functions"));

var _Helper = _interopRequireDefault(require("./Helper"));

var _Server = _interopRequireDefault(require("./Server"));

var _Security = _interopRequireDefault(require("./Security"));

var _Config = _interopRequireDefault(require("./Config"));

var _Database = _interopRequireDefault(require("./Database"));

var _Document = _interopRequireDefault(require("./Document"));

var _Networking = _interopRequireDefault(require("./Networking"));

var _Options = _interopRequireDefault(require("./Options"));

var _Hardware = _interopRequireDefault(require("./Hardware"));

var _Api = _interopRequireDefault(require("./Api"));

var _Utils = _interopRequireDefault(require("./Utils"));

var status = {};
var mVersion = version();
exports.Version = mVersion;

function version() {
  var fs = require('fs');

  var path = require('path');

  var pg = path.join(__dirname, "./../../../package.json");

  if (fs.existsSync(pg)) {
    var mPckage = require(pg);

    return "".concat(mPckage.version);
  } else {
    return "package_json_not_found";
  }
}
/**
 *
 * @typedef {Object} DKA
 * @property {Functions} DKA.Functions
 * @property { Hardware } DKA.Hardware
 */


var DKA = {
  Functions: _Functions["default"],
  Helper: _Helper["default"],
  Security: _Security["default"],
  Database: _Database["default"],
  Document: _Document["default"],
  Server: _Server["default"],
  Options: _Options["default"],
  Networking: _Networking["default"],
  Hardware: _Hardware["default"],
  Api: _Api["default"],
  Version: mVersion,
  Config: _Config["default"],
  Utils: _Utils["default"],

  get config() {
    return _Config["default"];
  },

  set config(config) {
    var Config = _lodash["default"].merge(Config, config);
  }

};
/** Declalration Global Variable **/

global.DKA = DKA;
global.Server = _Server["default"];
global.DKAnum = 0;
global.DKAServerConfig = [];
var _default = DKA;
exports["default"] = _default;
//# sourceMappingURL=index.module.d.js.map