#!/usr/bin/env node
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var mPackage = require("./../../../package.json");

var path = require("path");

var _require = require("child_process"),
    spawn = _require.spawn;

var nodemon = require("nodemon");

var _require2 = require("commander"),
    Command = _require2.Command;

var program = new Command();
(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6() {
  var nodemonInst, debug;
  return _regenerator["default"].wrap(function _callee6$(_context6) {
    while (1) {
      switch (_context6.prev = _context6.next) {
        case 0:
          nodemonInst = null;
          debug = false;
          _context6.next = 4;
          return program.version(mPackage.version).arguments("<file>").option('-d, --debug', 'Run Debug Mode').option('-w, --watch <dir>', 'directory watch changes').option('-n, --nodemon', 'Use Nodemon With Run').option('-b, --babel', 'Use Babel').option('-bc, --babelconfig <fileconfig>', 'use costum babel config').option('-c, --compile', 'Compile <react> and <babel> to Production').action( /*#__PURE__*/function () {
            var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(file, options, command) {
              var pushOptions, watchOpt, babelOpt, configFilePath, configBabel;
              return _regenerator["default"].wrap(function _callee4$(_context4) {
                while (1) {
                  switch (_context4.prev = _context4.next) {
                    case 0:
                      pushOptions = [];
                      watchOpt = options.watch !== undefined ? "--watch ".concat(options.watch) : "--watch false";
                      pushOptions.push(watchOpt);
                      babelOpt = options.babel !== undefined ? " babel-node" : " node";
                      pushOptions.push(babelOpt);

                      if (!(options.babelconfig !== undefined)) {
                        _context4.next = 9;
                        break;
                      }

                      _context4.t0 = "".concat(options.babelconfig);
                      _context4.next = 12;
                      break;

                    case 9:
                      _context4.next = 11;
                      return path.join(process.cwd(), "./node_modules/dkaframework/dist/Framework/bin/babel.config.js");

                    case 11:
                      _context4.t0 = _context4.sent;

                    case 12:
                      configFilePath = _context4.t0;
                      configBabel = options.babel !== undefined ? " --config-file ".concat(configFilePath) : "";
                      pushOptions.push(configBabel);
                      _context4.next = 17;
                      return new Promise( /*#__PURE__*/function () {
                        var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(resolve, rejected) {
                          var finalScript, _finalScript;

                          return _regenerator["default"].wrap(function _callee$(_context) {
                            while (1) {
                              switch (_context.prev = _context.next) {
                                case 0:
                                  if (!(options.nodemon !== undefined)) {
                                    _context.next = 10;
                                    break;
                                  }

                                  finalScript = "".concat(watchOpt, " --exec").concat(babelOpt).concat(configBabel, " ").concat(file);

                                  if (options.debug !== undefined) {
                                    debug = true;
                                    console.log("#### --- nodemon ".concat(finalScript, " --- ####"));
                                  } //Spawn Proccess


                                  spawn("nodemon");
                                  _context.next = 6;
                                  return nodemon(finalScript);

                                case 6:
                                  nodemonInst = _context.sent;
                                  resolve();
                                  _context.next = 16;
                                  break;

                                case 10:
                                  _finalScript = "".concat(watchOpt, " --exec").concat(babelOpt).concat(configBabel, " ").concat(file);

                                  if (options.debug !== undefined) {
                                    debug = true;
                                    console.log("#### --- node ".concat(_finalScript, " --- ####"));
                                  }

                                  _context.next = 14;
                                  return nodemon(_finalScript);

                                case 14:
                                  nodemonInst = _context.sent;
                                  resolve();

                                case 16:
                                case "end":
                                  return _context.stop();
                              }
                            }
                          }, _callee);
                        }));

                        return function (_x4, _x5) {
                          return _ref3.apply(this, arguments);
                        };
                      }())["finally"]( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
                        var mNodemon;
                        return _regenerator["default"].wrap(function _callee3$(_context3) {
                          while (1) {
                            switch (_context3.prev = _context3.next) {
                              case 0:
                                _context3.next = 2;
                                return nodemon;

                              case 2:
                                mNodemon = _context3.sent;
                                _context3.next = 5;
                                return mNodemon.once('start', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
                                  return _regenerator["default"].wrap(function _callee2$(_context2) {
                                    while (1) {
                                      switch (_context2.prev = _context2.next) {
                                        case 0:
                                          console.log("DKA V.".concat(mPackage.version, " :: Program Starting ..."));

                                        case 1:
                                        case "end":
                                          return _context2.stop();
                                      }
                                    }
                                  }, _callee2);
                                })));

                              case 5:
                                _context3.next = 7;
                                return mNodemon.on('crash', function (e) {
                                  console.log("DKA :: Has Detecting Crash ...");
                                  console.log(e); //process.exit(1);
                                });

                              case 7:
                                _context3.next = 9;
                                return mNodemon.on('quit', function () {
                                  console.log("DKA V.".concat(mPackage.version, " :: Has Quit ..."));
                                  process.exit();
                                });

                              case 9:
                                _context3.next = 11;
                                return mNodemon.on('restart', function (files) {
                                  console.log("DKA :: V.".concat(mPackage.version, " a code changes. has restarted ..."));
                                });

                              case 11:
                              case "end":
                                return _context3.stop();
                            }
                          }
                        }, _callee3);
                      })));

                    case 17:
                    case "end":
                      return _context4.stop();
                  }
                }
              }, _callee4);
            }));

            return function (_x, _x2, _x3) {
              return _ref2.apply(this, arguments);
            };
          }());

        case 4:
          _context6.next = 6;
          return process.on("SIGINT", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5() {
            return _regenerator["default"].wrap(function _callee5$(_context5) {
              while (1) {
                switch (_context5.prev = _context5.next) {
                  case 0:
                    if (debug) {
                      console.log("DKA Program In Signint");
                    }

                    process.exit();

                  case 2:
                  case "end":
                    return _context5.stop();
                }
              }
            }, _callee5);
          })));

        case 6:
          _context6.next = 8;
          return program.parse(process.argv, {});

        case 8:
        case "end":
          return _context6.stop();
      }
    }
  }, _callee6);
}))();
//# sourceMappingURL=dka.js.map